﻿/*
 * Copyright 2005, Gemtek Technology Co., Ltd.
 * 
 * All Rights Reserved
 * 
 * Permission to use, copy, modify, and distribute this software and its 
 * documentation for any purpose and without fee is hereby granted, 
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in 
 * supporting documentation, and that the name of Gemtek Technology not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission. 
 */
/*
 * Copyright 2001-2005, Broadcom Corporation
 * All Rights Reserved.
 * 
 * THIS SOFTWARE IS OFFERED "AS IS", AND BROADCOM GRANTS NO WARRANTIES OF ANY
 * KIND, EXPRESS OR IMPLIED, BY STATUTE, COMMUNICATION OR OTHERWISE. BROADCOM
 * SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTIES OF MERCHANTABILITY, FITNESS
 * FOR A SPECIFIC PURPOSE OR NONINFRINGEMENT CONCERNING THIS SOFTWARE.
 *
 * $Id$
 *
*/

#ifdef WEBS
#include <webs.h>
#include <uemf.h>
#include <ej.h>
#else /* !WEBS */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <errno.h>
#include <unistd.h>
#include <limits.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <assert.h>
#include <httpd.h>
#endif /* WEBS */

#ifdef vxworks
#include <netinet/if_ether.h>
#endif

#include <typedefs.h>
#include <proto/ethernet.h>
#include <bcmnvram.h>
#include <bcmutils.h>
#include <shutils.h>
#include <netconf.h>
#include <nvparse.h>
#include <wlutils.h>

static char * rfctime(const time_t *timep);
static char * reltime(unsigned int seconds);

#if defined(linux)

#include <fcntl.h>
#include <signal.h>
#include <time.h>
#include <sys/klog.h>
#include <sys/wait.h>
#include <sys/ioctl.h>
#include <net/if.h>

typedef u_int64_t u64;
typedef u_int32_t u32;
typedef u_int16_t u16;
typedef u_int8_t u8;
#include <linux/ethtool.h>
#include <linux/sockios.h>

#define sys_restart() kill(1, SIGHUP)
#define sys_reboot() kill(1, SIGTERM)
#define sys_stats(url) eval("stats", (url))

#ifndef WEBS

#define MIN_BUF_SIZE	4096



#define MOTOROLA_SERIES


#if defined(MOTOROLA_SERIES)
static int apply_cgi(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg, char_t *url, char_t *path, char_t *query);
//#define MOTOROLA_SERIES_CHECK_FIRMWARE
#define DanielDBG(x)
#define MOTOROLA_WE800G
#define WE800G
//#define TERENCE_DEBUG
#ifdef TERENCE_DEBUG
#define tsprintf(str, args...) printf(str, ## args)
#else
#define tsprintf(str, args...)
#endif
unsigned char key_buf[65];
int wizard_reboot = 0;
#define EVENT_NUM 50
extern int AuthReset;
extern int MOTOROLA_Wizard;
enum
{
	JUMP_NOTHING,
	JUMP_FOOTER,
	JUMP_PAGENAME,
	JUMP_ACTION,
	JUMP_RETURN,
};

enum {
	NOTHING,
	REBOOT,
	RESTART,
};

static const char* const Firmware_Update_Header =
"<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Transitional//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd\">\n"
"<html xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"en\" lang=\"en\">\n"
"<head>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html;charset=UTF-8\" />\n"
"<meta http-equiv=\"Script-Content-Type\" content=\"text/javascript\" />\n"
"<title>Motorola HomeNet Product WE800G - Control Panel : Firwmware Update</title>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n"
"<link rel=\"stylesheet\" type=\"text/css\" href=\"style.css\" />\n"
"<script language=\"JavaScript\" type=\"text/JavaScript\" src=\"left_menu.js\"></script>\n"
"<script language=\"JavaScript\" type=\"text/javascript\" src=\"nsutil.js\"></script>\n"
"<script language=\"JavaScript\" type=\"text/JavaScript\" src=\"sub_nav.js\"></script>\n"
"<script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"<!--\n"
"function Init_Left_Menu(passForm)\n"
"{\n"
"	var i;\n"
"	for(i=0;i<8;i++)\n"
"		left_status[i] = 0;\n"
"	now_page = 43;\n"
"	left_status[4] = 1;	\n"
"	if(passForm.restart_status.value!=\"1\")	\n"
"		passForm.main_left_btn_restart.src = \"main_left_btn_restart_Normal.gif\";\n"
"	else\n"
"		passForm.main_left_btn_restart.src = \"main_left_btn_restart_Blink.gif\";\n"
"	passForm.main_left_btn_control.src = \"main_left_btn_control_Click.gif\";\n"
"	(new Image()).src = \"main_left_btn_control_Click.gif\";\n"
"	(new Image()).src = \"main_left_btn_control_Normal.gif\";\n"
"	(new Image()).src = \"main_left_btn_control_Over.gif\";\n"
"	(new Image()).src = \"main_left_btn_help_Click.gif\";\n"
"	(new Image()).src = \"main_left_btn_help_Normal.gif\";\n"
"	(new Image()).src = \"main_left_btn_help_Over.gif\";\n"
"	(new Image()).src = \"main_left_btn_logout_Click.gif\";\n"
"	(new Image()).src = \"main_left_btn_logout_Normal.gif\";\n"
"	(new Image()).src = \"main_left_btn_logout_Over.gif\";\n"
"	(new Image()).src = \"main_left_btn_restart_Click.gif\";\n"
"	(new Image()).src = \"main_left_btn_restart_Normal.gif\";\n"
"	(new Image()).src = \"main_left_btn_restart_Over.gif\";\n"
"	(new Image()).src = \"main_left_btn_wp1_Click.gif\";\n"
"	(new Image()).src = \"main_left_btn_wp1_Normal.gif\";\n"
"	(new Image()).src = \"main_left_btn_wp1_Over.gif\";\n"
"	(new Image()).src = \"main_left_btn_wp2_Click.gif\";\n"
"	(new Image()).src = \"main_left_btn_wp2_Normal.gif\";\n"
"	(new Image()).src = \"main_left_btn_wp2_Over.gif\";\n"
"	(new Image()).src = \"main_left_btn_site_survey_Click.gif\";\n"
"	(new Image()).src = \"main_left_btn_site_survey_Normal.gif\";\n"
"	(new Image()).src = \"main_left_btn_site_survey_Over.gif\";\n"
"}\n"
"//-->\n"
"</script>\n"
"<body onLoad=\"Init_Left_Menu(document.forms[0]);\" background=\"main_bottom_center-all.gif\" bgproperties=\"auto\">\n"
"<div align=\"left\">\n"
"<form method=\"post\" action=\"sysconf.cgi\">\n"
"  <TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0>\n"
"    <tr valign=\"top\"> \n"
"      <td>\n"
"          <TABLE WIDTH=177 BORDER=0 CELLPADDING=0 CELLSPACING=0>\n"
"            <TR><TD><IMG SRC=\"main_left-frame1_logo.gif\" WIDTH=177 HEIGHT=96></TD></TR>\n"
"            <TR><TD><IMG SRC=\"main_left-frame1_table_up.gif\" WIDTH=177 HEIGHT=41></TD></TR>\n"
"            <TR><TD><IMG SRC=\"main_left-main_left_04.gif\" WIDTH=177 HEIGHT=5></TD></TR>\n"
"            <TR><TD><script>write_img('main_left_btn_site_survey', 177, 22, 1);</script></TD></TR>\n"
"            <TR><TD><IMG SRC=\"main_left-main_left_10.gif\" WIDTH=177 HEIGHT=5></TD></TR>\n"
"            <TR><TD><script>write_img('main_left_btn_wp1', 177, 22, 2);</script></TD></TR>\n"
"            <TR><TD><IMG SRC=\"main_left-main_left_10.gif\" WIDTH=177 HEIGHT=5></TD></TR>\n"
"            <TR><TD><script>write_img('main_left_btn_wp2', 177, 22, 3);</script></TD></TR>\n"
"            <TR><TD><IMG SRC=\"main_left-main_left_10.gif\" WIDTH=177 HEIGHT=5></TD></TR>\n"
"            <TR><TD><script>write_img('main_left_btn_control', 177, 22, 4);</script></TD></TR>\n"
"            <TR><TD><IMG SRC=\"main_left-main_left_12.gif\" WIDTH=177 HEIGHT=32></TD></TR>\n"
"            <TR><TD><script>write_img('main_left_btn_help', 177, 22, 5);</script></TD></TR>\n"
"            <TR><TD><IMG SRC=\"main_left-main_left_14.gif\" WIDTH=177 HEIGHT=6></TD></TR>\n"
"            <TR><TD><script>write_img('main_left_btn_restart', 177, 22, 6);</script></TD></TR>\n"
"            <TR><TD><IMG SRC=\"main_left-main_left_16.gif\" WIDTH=177 HEIGHT=4></TD></TR>\n"
"            <TR><TD><script>write_img('main_left_btn_logout', 177, 22, 7);</script></TD></TR>\n"
"          </TABLE>\n"
"       </td>\n"
"      	<td>\n"
"      		<TABLE HEIGHT=151 BORDER=0 CELLPADDING=0 CELLSPACING=0><TR>\n"
"      			<TD><IMG SRC=\"main_top_frame2_control.gif\" WIDTH=518 HEIGHT=151></TD>\n"
"	          <TD><IMG SRC=\"main_top_frame2_2.jpg\" WIDTH=220 HEIGHT=151></TD>\n"
"	          <TD>&nbsp;</TD>\n"
"	        </TR></table>\n"
"        	<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0><TR> \n"
"            <TD><IMG SRC=\"control_firmware_bg_left.gif\" WIDTH=192 HEIGHT=27></TD>\n"
"            <TD><a href=\"javascript:to_control_network();\"><IMG SRC=\"control_firmware_network.gif\" WIDTH=148 HEIGHT=27 border=\"0\"></a></TD>\n"
"            <TD><a href=\"javascript:to_control_device();\"><IMG SRC=\"control_firmware_device.gif\" WIDTH=133 HEIGHT=27 border=\"0\"></a></TD>\n"
"            <TD><a href=\"javascript:to_control_firmware();\"><IMG SRC=\"control_firmware_firmware.gif\" WIDTH=158 HEIGHT=27 border=\"0\"></a></TD>\n"
"            <TD><a href=\"javascript:to_control_configuration();\"><IMG SRC=\"control_firmware_configurat.gif\" WIDTH=162 HEIGHT=27 border=\"0\"></a></TD>\n"
"            <TD>&nbsp;</TD>\n"
"          </TR></TABLE>\n"
"        <TABLE HEIGHT=18 BORDER=0 CELLPADDING=0 CELLSPACING=0><TR>\n"
"        	<TD HEIGHT=18>&nbsp;</TD>\n"
"        </TR></TABLE>\n"
"				<table cellSpacing=0 cellPadding=0 border=0 height=\"200\" width=\"780\"><tr>\n"
"						<td width=\"15\" class=\"bg\"></td>\n"
"						<td valign=\"center\" height=\"10\" align=\"center\" bgcolor=\"#D5D35A\">\n"
;

static const char* const Firmware_Update_Footer =
"						</td>\n"
"				</tr></table>\n"
"        </td>\n"
"    	</tr>\n"
"  	</table>\n"
"</form>"
"</div>\n"
"<form method=\"post\" name=\"restart\" action=\"sysconf.cgi\">\n"
"<input type=\"hidden\" name=\"action\" value=\"RedirectToReboot\">\n"
"<input type=\"hidden\" name=\"PageName\" value=\"reboot\">\n"
"</form>\n"
"<form method=\"post\" name=\"logout\" action=\"sysconf.cgi\">\n"
"<input type=\"hidden\" name=\"action\" value=\"Logout\">\n"
"<input type=\"hidden\" name=\"PageName\" value=\"Logout\">\n"
"</form>\n"
"</body>\n"
"</html>\n"
;
						
static const char* const Login_Fail_asp =
"<html lang=\"en\">\n"
"<head>\n"
"<title>Motorola HomeNet WE800G Product</title>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n"
"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"
//"<meta http-equiv=\"refresh\" content=\"0;URL=index.asp\">\n"
"<body>\n"
"<script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"<!--\n"
"	top.window.location.href = \"redirect.asp\";\n"
"//-->\n"
"</script>\n"
"</body>\n"
"</html>\n"
;

static const char* const Login_OK_wizard_asp =
"<html lang=\"en\">\n"
"<head>\n"
"<title>Motorola HomeNet Product WA840G</title>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n"
"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"
//"<meta http-equiv=\"refresh\" content=\"0;URL=frames.asp\">\n"
"<body>\n"
"<script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"<!--\n"
"	top.window.location.href = \"wizard.html\";\n"
"//-->\n"
"</script>\n"
"</body>\n"
"</html>\n"
;

static const char* const Login_OK_asp =
"<html lang=\"en\">\n"
"<head>\n"
"<title>Motorola HomeNet WE800G Product</title>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n"
"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"
//"<meta http-equiv=\"refresh\" content=\"0;URL=frames.asp\">\n"
"<body>\n"
"<script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"<!--\n"
"	top.window.location.href = \"frames.asp\";\n"
"//-->\n"
"</script>\n"
"</body>\n"
"</html>\n"
;





static const char * const apply_header =
"<head>"
"<title>Motorola 802.11g Wireless Router: Apply</title>"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">"
"<style type=\"text/css\">"
/*"body { background: black; color: black; font-family: arial, sans-serif; font-size: 9pt }"*/
".title	{ font-family: arial, sans-serif; font-size: 13pt; font-weight: bold }"
".subtitle { font-family: arial, sans-serif; font-size: 11pt }"
".label { color: #306498; font-family: arial, sans-serif; font-size: 7pt }"
"</style>"
"</head>"
"<body background=\"main_bottom_center-all.gif\" bgproperties=\"auto\" bgcolor=\"#DEDA4C\">"
"<center>"
"<p>"
"<form method=\"get\" action=\"apply.cgi\">"
"<p>"
"<table border=0 cellspacing=0 cellpadding=0 width=557>"
"<tr>"
"<th height=400><font size=4 face=Arial>"
//"Your changes have been saved."
"<p>"
;

static const char * const upgrade_fail_4702_only_footer =
"<script>\n"
"function InitValue()\n"
"{\n"
"	parent.firmware_bottom.time_out_value = 50;\n"
"	if(parent.firmware_bottom.CurTime < 100)\n"
"	{\n"
"		//loop until 100\n"
"		setTimeout(\"InitValue()\",100);\n"
"		return;\n"
"	}\n"
"	else\n"
"	{\n"
"		window.status=\"Upgrade progress status : Upgrade Failed\";\n"
"   document.fw.submit();\n"
"	}\n"
"}\n"
" InitValue();\n"
"</script>\n"
"</th>"
"</tr>"
"</table>"
"</form>"
"<form method=\"post\" name=\"fw\" action=\"sysconf.cgi\">\n"
"	  <input type=\"hidden\" name=\"action\" value=\"Upgrade4702OnlyFail\">\n"
"</form>"
"</center>"
"</body>"
;

static const char * const upgrade_fail_footer =
//"<input type=\"hidden\" name=\"action\" value=\"restart\">"
//"<input type=\"button\" name=\"action_btn\" value=\"Reboot\" OnClick=\"document.forms[0].submit();\">"
//"<H3>Please upgrade your firmware.</H3>"
"<script>\n"
"function InitValue()\n"
"{\n"
"	parent.firmware_bottom.time_out_value = 50;\n"
"	if(parent.firmware_bottom.CurTime < 100)\n"
"	{\n"
"		//loop until 100\n"
"		setTimeout(\"InitValue()\",100);\n"
"		return;\n"
"	}\n"
"	else\n"
"	{\n"
//"		top.location.href = 'frame_control_panel_firmware_update_fail.asp';\n"
"		window.status=\"Upgrade progress status : Upgrade Failed\";\n"
"   document.fw.submit();\n"
"	}\n"
"}\n"
" InitValue();\n"
"</script>\n"
//"<script>window.status = \"Upgrade progress status : Upgrade fail\"</script>"
//"<script>document.location.href = 'frame_control_panel_firmware_update_fail.asp';</script>"
"</th>"
"</tr>"
"</table>"
"</form>"
"<form method=\"post\" name=\"fw\" action=\"sysconf.cgi\">\n"
"	  <input type=\"hidden\" name=\"action\" value=\"UpgradeFail\">\n"
"</form>"
"</center>"
"</body>"
;

static const char * const force_reboot_footer =
//"<input type=\"hidden\" name=\"action\" value=\"restart\">"
//"<input type=\"button\" name=\"action_btn\" value=\"Reboot\" OnClick=\"document.forms[0].submit();\">"
//"<script>window.status = \"Upgrade progress status : Upgrade Complete\"</script>"
//"<script>top.left.document.forms[0].restart_status.value = \"1\"; top.left.document.forms[0].main_left_btn_restart.src = \"main_left_btn_restart_Blink.gif\";</script>\n"
//"<H3>Please press <b>Restart</b> button.</H3>"
"<script>\n"
"function InitValue()\n"
"{\n"
"	parent.firmware_bottom.time_out_value = 50;\n"
"	if(parent.firmware_bottom.CurTime < 100)\n"
"	{\n"
"		//loop until 100\n"
"		setTimeout(\"InitValue()\",100);\n"
"		return;\n"
"	}\n"
"	else\n"
"	{\n"
//"		top.location.href = 'frame_control_panel_firmware_update_complete.asp';\n"
"		window.status=\"Upgrade progress status : Upgrade Complete\";\n"
"   document.fw.submit();\n"
"	}\n"
"}\n"
" InitValue();\n"
"</script>\n"
//"<script>document.location.href = 'frame_control_panel_firmware_update_complete.asp';</script>"
"</font>"
"</th>"
"</tr>"
"</table>"
"</form>"
"<form method=\"post\" name=\"fw\" action=\"sysconf.cgi\">\n"
"	  <input type=\"hidden\" name=\"action\" value=\"UpgradeComplete\">\n"
"</form>"
"</center>"
"</body>"
;

static const char* const apply_asp_header =
"<html lang=\"en\">\n"
"<head>\n"
"<title>Motorola HomeNet Product WA840G</title>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n"
"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"
"<link rel=\"stylesheet\" type=\"text/css\" href=\"style.css\">\n"
"<script language=\"JavaScript\" type=\"text/JavaScript\" src=\"banner.js\"></script>\n"
"<script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"<!--\n"
"function go()\n"
"{\n"
//"	top.location = 'http://' + document.forms[0].dest_ip.value + '/reboot.asp';\n"
"document.forms[0].submit();\n"
"}\n"
"function wait_to_go()\n"
"{\n"
"setTimeout('go()', 0);\n"
"}\n"
"//-->\n"
"</script>\n"
"\n"
"<body style=\"text-align: left; background-color: #BEB800;\">\n"
"<form method=\"post\" action=\"sysconf.cgi\">\n"
"	<div align=\"center\">\n"
"       	<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n"
"		     	<tr>\n"
"		        <input type=\"hidden\" name=\"action\" value=\"RedirectToReboot\">\n"
"		        <input type=\"hidden\" name=\"PageName\" value=\"\">\n"
;



static const char* const apply_asp_footer =
"		       	<td height=\"50\" style=\"text-align: left; background-color: #BEB800;\"  align=\"center\">\n"
//"<font color=\"black\"><b>Please Wait...</b></font>\n"
//"		            <input type=\"button\" name=\"ApplyBtn\" onClick=\"wait_to_go();\" value=\" Apply \" style=\"font-size: 10pt;\">\n"
"               <script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"               <!--\n"
"	                wait_to_go();\n"
"               //-->\n"
"               </script>\n"
//"               <script>top.main.location.href = 'none-bg.asp';</script>"
"               <script>top.main_top.location.href = 'none-bg.asp';</script>"
"               <script>top.left.location.href = 'none-bg.asp';</script>"
"		        </td>\n"
"		      </tr>\n"
"         </table>\n"
"	</div>\n"
"</form>\n"
"</body>\n"
"</html>\n"
;

static const char* const apply_asp_wizard_header =
"<html lang=\"en\">\n"
"<head>\n"
"<title>Motorola HomeNet Product WA840G</title>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n"
"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"
"<link rel=\"stylesheet\" type=\"text/css\" href=\"style.css\">\n"
"<script language=\"JavaScript\" type=\"text/JavaScript\" src=\"banner.js\"></script>\n"
"<script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"<!--\n"
"function go()\n"
"{\n"
"	window.location.href = document.referrer;\n"
//"	top.location = 'http://' + document.forms[0].dest_ip.value + '/reboot.asp';\n"
//"document.forms[0].submit();\n"
"}\n"
"function wait_to_go()\n"
"{\n"
"setTimeout('go()',0);\n"
"}\n"
"//-->\n"
"</script>\n"
"\n"
"<body style=\"text-align: left; background-color: #BEB800;\">\n"
"<form method=\"post\" action=\"sysconf.cgi\">\n"
"	<div align=\"center\">\n"
"       	<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n"
"		     	<tr>\n"
"		        <input type=\"hidden\" name=\"action\" value=\"RedirectToReboot\">\n"
"		        <input type=\"hidden\" name=\"PageName\" value=\"\">\n"
;

static const char* const apply_asp_wizard_footer =
"		       	<td height=\"50\" style=\"text-align: left; background-color: #BEB800;\"  align=\"center\">\n"
//"<font color=\"black\"><b>Please Wait...</b></font>\n"
//"		            <input type=\"button\" name=\"ApplyBtn\" onClick=\"wait_to_go();\" value=\" Apply \" style=\"font-size: 10pt;\">\n"
"               <script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"               <!--\n"
"	                wait_to_go();\n"
"               //-->\n"
"               </script>\n"
"		      </tr>\n"
"         </table>\n"
"	</div>\n"
"</form>\n"
"</body>\n"
"</html>\n"
;


static const char* const apply_asp_restore_default_footer =
"		       	<td height=\"50\" style=\"text-align: left; background-color: #BEB800;\"  align=\"center\">\n"
//"<font color=\"black\"><b>Please Wait...</b></font>\n"
//"		            <input type=\"button\" name=\"ApplyBtn\" onClick=\"wait_to_go();\" value=\" Apply \" style=\"font-size: 10pt;\">\n"
"               <script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"               <!--\n"
"	                wait_to_go();\n"
"               //-->\n"
"               </script>\n"
//"               <script>top.main_top.location.href = 'none-bg.asp';</script>"
//"               <script>top.left.location.href = 'none-bg.asp';</script>"
"		      </tr>\n"
"         </table>\n"
"	</div>\n"
"</form>\n"
"</body>\n"
"</html>\n"
;


static const char* const reboot_asp =
"<html lang=\"en\">\n"
"<head>\n"
"<title>Motorola HomeNet Product WE800G</title>\n"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-1\">\n"
"<meta http-equiv=\"Pragma\" content=\"no-cache\">\n"
"<link rel=\"stylesheet\" type=\"text/css\" href=\"style.css\">\n"
"<script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"<!--\n"
"var CurTime=0;\n"
"function timebegin() {\n"
"\n"
"		\n"
"  var mybar='|';\n"
"  for(i=0; i<CurTime; i++)\n"
"    mybar+='|';\n"
"  window.status='Restart status : ' + CurTime+ '%%' + ' ' + mybar;\n"
"  if(CurTime < 100){\n"
"    setTimeout(\"timebegin()\",160);\n"
"    CurTime++;\n"
"  }  \n"
"  else{\n"
//"    window.status="";\n"
"		clearTimeout(\"timebegin()\");\n"
"		go();\n"
"  }  \n"
"}\n"
"\n"
"function goProgress() \n"
"{\n"
"	timebegin();\n"
"}\n"
"function go()\n"
"{\n"
"if(document.forms[0].wan_proto.value == 'dhcp')\n"
"	top.location = 'http://' + document.forms[0].server_ip.value + '/index.asp';\n"
"else\n"
"	top.location = 'http://' + document.forms[0].dest_ip.value + '/index.asp';\n"
"}\n"
"function wait_to_go()\n"
"{\n"
"	strip_space(document.forms[0].dest_ip);\n"
"	strip_space(document.forms[0].server_ip);\n"
"	setTimeout(\"goProgress()\", 1000);\n"
"}\n"
"function strip_space(o)\n"
"{\n"
"	var temp = '';\n"
"	for(var i=0;i < o.value.length;i++)\n"
"	{\n"
"		if(o.value.charAt(i) != ' ')\n"
"			temp += o.value.charAt(i);\n"
"	}\n"
"	o.value = temp;\n"
"}\n"
"//-->\n"
"</script>\n"
"\n"
"<body style=\"text-align: left; background-color: #BEB800;\">\n"
"<form>\n"
"	<div align=\"left\">\n"
"       	\n"
"    <p>&nbsp;</p>\n"
"    <p>&nbsp;</p>\n"
"    <p>&nbsp;</p>\n"
"    <p>&nbsp;</p>\n"
"    <table width=\"343\" border=\"0\" cellpadding=\"0\" cellspacing=\"0\">\n"
"      <tr> \n"
;

static const char* const reboot_asp_footer =
"        <td align=\"left\" style=\"text-align: left; background-color: #BEB800;\" height=\"50\" width=\"545\" class=\"text\" ><b>&nbsp;&nbsp;&nbsp;&nbsp;<span class=\"text\">Please Wait...</span></b></td>\n"
"        <script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"               <!--\n"
"	                wait_to_go();\n"
"               //-->\n"
"               </script> \n"
"      </tr>\n"
"    </table>\n"
"  </div>\n"
"</form>\n"
"</body>\n"
"</html>\n"
;

static const char *const RedirectApplyCGI =
"<head>\n"
"<title>Rediect</title>\n"
"<meta http-equiv=\"refresh\" content=\"0; url=apply.cgi?action=restore\">\n"
"<script language=\"javascript\">\n"
"<!--\n"
"	window.location.href = \"apply.cgi?action=restore\" ;\n"
"//-->\n"
"</script>"
"</head>\n"
"<body>\n"
"&nbsp;\n"
"</body>"
;




static const char * const apply_header_child =
"<head>"
"<title>Motorola HomeNet Product WE800G</title>"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">"
"<style type=\"text/css\">"
/*"body { background: black; color: black; font-family: arial, sans-serif; font-size: 9pt }"*/
".title	{ font-family: arial, sans-serif; font-size: 13pt; font-weight: bold }"
".subtitle { font-family: arial, sans-serif; font-size: 11pt }"
".label { color: #306498; font-family: arial, sans-serif; font-size: 7pt }"
"</style>"
"</head>"
"<body  background=\"main_bottom_center-all.gif\" bgproperties=\"auto\" bgcolor=\"#DEDA4C\">"
"<center>"
"<p>"
"<form method=\"get\" action=\"apply.cgi\">"
"<p>"
"<table border=0 cellspacing=0 cellpadding=0 width=557>"
"<tr>"
"<th height=400><font size=4 face=Arial>"
//"Your changes have been saved."
"<p>"
;



static const char * const apply_restore_footer =
//"<input type=\"button\" name=\"action\" value=\"Continue\" OnClick=\"window.location.href = document.referrer;\">"
"<script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"<!--\n"
"	document.location.href = 'frame_control_panel_configuration_backup_top.asp';\n"
"//-->\n"
"</script>\n"
"</th>"
"</tr>"
"</table>"
"</form>"
"</center>"
"</body>"
;

int check_associate_status(void)
{
	FILE *fp;
	
	system("wl dump > /tmp/wl_temp");		
	
	if ((fp = fopen("/tmp/wl_temp","r")) == NULL) 
	{

		tsprintf(" No /tmp/wl_temp file!\n");

	}

	else

	{
		char buf[1024], buf1[100], buf2[100], buf3[100], buf4[100];
				
		fgets(buf, 1000, fp);
		//fprintf(stderr, "%s\n", buf);
		fgets(buf, 1000, fp);
		//fprintf(stderr, "%s\n", buf);
		fgets(buf, 1000, fp);
		//fprintf(stderr, "%s\n", buf);
		fgets(buf, 1000, fp);
		//fprintf(stderr, "%s\n", buf);
		fgets(buf, 1000, fp);
		//fprintf(stderr, "%s\n", buf);
		fgets(buf, 1000, fp);
		//fprintf(stderr, "%s\n", buf);
		fgets(buf, 1000, fp);
		//fprintf(stderr, "%s\n", buf);
		fgets(buf, 1000, fp);
		//fprintf(stderr, "%s\n", buf);
		fscanf(fp, "%s %s", buf1, buf2);

		//fprintf(stderr, "%s %s %s %s\n", buf1, buf2, buf3, buf4);	
		fclose(fp);			

		if(!strcmp( buf2, "00:00:00:00:00:00"))
		{
			return 0;
		}
		else
		{	
			return 1;
		}
	}	
}

void check_eventlog_buffer()
{
	FILE *fp;
	int event_num = EVENT_NUM;
	char event_buf[EVENT_NUM][200], p, msg[200];
	int position = 0, i = 0;

	if ((fp = fopen("/var/log/eventmsg","r")) == NULL)
	{
		tsprintf("open /var/log/eventmsg error !!!\n");
		return;
	}

	while(!feof(fp))
	{
		memset(msg, 0, sizeof(msg));
		fgets(msg, sizeof(msg), fp);
		p = strstr(msg, "##");
		if(p == NULL)
		{
			tsprintf("broadcom.c : empty msg : [%s] %p p : %s %p\n", msg, msg, p, p);
		}
		else
		{
			strcpy(event_buf[position++], msg);
			//printf("event log[%d] check : broadcom.c : %s\n", position - 1, event_buf[position - 1]);
		}
	}

	fclose(fp);

	if(position == 0)
		return;

	if ((fp = fopen("/var/log/eventmsg","w")) == NULL)
	{
		tsprintf("open /var/log/eventmsg error !!!\n");
		return;
	}

	if(position >= event_num)
	{
		for(i = 0;i < event_num - 1;i++)
		{
			tsprintf("event log[%d] over write : broadcom.c : %s\n", i+ 1, event_buf[i + 1]);
			fprintf(fp ,"%s\n", event_buf[i + 1]);
		}
	}
	else
	{
		for(i = 0;i < position;i++)
		{
			tsprintf("event log[%d] normal write : broadcom.c : %s\n", i, event_buf[i]);
			fprintf(fp ,"%s\n", event_buf[i]);
		}
	}

	fclose(fp);
}


//-----------------------------------------------------------------------------
void write_eventlog(int type, char *msg)
{
#if defined(MOTOROLA_WE800G)
 	return;
#else
	int fd;
	FILE *fp;

	if(type == 0 && !strcmp(nvram_get("EVENTLOGENABLE1"), "0"))
 		return;
	else if(type == 1 && !strcmp(nvram_get("EVENTLOGENABLE2"), "0"))
 		return;
	else if(type == 2 && !strcmp(nvram_get("EVENTLOGENABLE3"), "0"))
 		return;

	check_eventlog_buffer();

	fp = fopen ("/var/log/eventmsg","a+");
	if( fp == NULL ){
		printf("open /var/log/eventmsg error !!! \n");
		return ;
	}

	fprintf(fp ,"%d %s\n", type, msg);
	fclose(fp);
#endif
}

static int
ej_force_reboot( int eid , webs_t wp , int argc , char_t **argv )
{
	if(wizard_reboot == 1)
		sys_reboot ();
	// system("/sbin/reboot&");
}


//-----------------------------------------------------------------------------
static int
ej_get_login_msg( int eid , webs_t wp , int argc , char_t **argv )
{
      	char buf[200]={0};
	if(nvram_get("login_msg") != NULL)
	{
 		if(!strcmp(nvram_get("login_msg"), "fail"))
		{
			websWrite(wp, "log_in_bg_fail.gif");
		}
		else
		{
			websWrite(wp, "log_in_bg.gif");
		}
		nvram_set("login_msg", "");
	}
}
//----------------------------------------------------------------------------- 

char applybuf[9216]; 

static void
do_wep_post ( char *url , FILE *stream , int len , char *boundary )/* Added by PeterChen , 2002/11/06 PM 01:27 */
{
	char buf[9216];
	/* Look for our part */
	while ( len > 0 ) {
		if ( !fgets ( buf , MIN ( len + 1 , sizeof ( buf ) ) , stream ) ) { return; }
		len -= strlen ( buf );
		if ( !strncasecmp ( buf , "Content-Disposition:" , 20 ) &&
		     strstr ( buf , "name=\"file\"" ) ) { break; }
	}

	/* Skip boundary and headers */
	while ( len > 0 ) {
		if ( !fgets ( buf , MIN ( len + 1 , sizeof ( buf ) ) , stream ) ) { return; }
		len -= strlen ( buf );
		if ( !strcmp ( buf , "\n" ) || !strcmp ( buf , "\r\n" ) ) { break; }
	}

	strcpy(applybuf, buf);

	/* Slurp anything remaining in the request */
	while (len--)
		(void) fgetc(stream);
}
//-----------------------------------------------------------------------------
#define ApplyString "apply.cgi?"

static void
do_wep_cgi ( char *url , FILE *stream )	/* Added by PeterChen , 2002/11/06 PM 01:27 */
{
	char *path = NULL , *query = NULL , *TempUrl = NULL;
	int StrSize = 0;

	StrSize = strlen ( ApplyString ) + strlen ( applybuf ) + 1;
	TempUrl = (char*) malloc ( sizeof ( char ) * StrSize );

	memset ( TempUrl , '\0' , StrSize );
	TempUrl = strcat ( TempUrl , ApplyString );
	TempUrl = strcat ( TempUrl , applybuf );
	query = TempUrl;
	path = strsep ( &query , "?" ) ? : TempUrl;
	init_cgi ( query );
	apply_cgi ( stream , NULL , NULL , 0 , TempUrl , path , query );
	free ( TempUrl );
}

int wl_ioctl(char *name, int cmd, void *buf, int len)
{
	struct ifreq ifr;
	wl_ioctl_t ioc;
	int ret = 0;
 	int s;

	/* open socket to kernel */
	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0) 
	{
		perror("socket");
		return errno;
	}

	/* do it */
	ioc.cmd = cmd;
	ioc.buf = buf;
	ioc.len = len;
	strncpy(ifr.ifr_name, name, IFNAMSIZ);
	ifr.ifr_data = (caddr_t) &ioc;
	
	if ((ret = ioctl(s, SIOCDEVPRIVATE, &ifr)) < 0)
		perror(ifr.ifr_name);

	/* cleanup */
	close(s);
	return ret;
}

//-----------------------------------------------------------------------------
/*
struct site_survey_t {
	char SSID[33];
	char Mode[10];
	int  RSSI;
	char noise[4];
	char Channel[3];
	char BSSID[18];
	char Capability[30];
	char SupRate;
} site_survey_table[48] ;
*/


static int ej_doSiteSurvey ( int eid , webs_t wp , int argc , char_t **argv )
{
	char name[10];
	char *mode ;
	unsigned char buf[8192] ;
	unsigned char web_buf[8192] ;
	static int  val;//,ret ;
	wl_bss_info_t *bi;
	wl_scan_results_t *list = (wl_scan_results_t *) buf ;
	uint i = 0, rssi = 0 ;
	char *p = NULL, *q = NULL ;
	FILE *fp = NULL ;
	char tmp[100] ;
	int count = 0 ;
	//if(!strcmp(nvram_safe_get("WlEnable"), "0"))
	if(!strcmp(nvram_safe_get("wl_radio"), "0"))
	{
		websWrite ( wp , "%s", "You must enable Radio Interface to start Site Monitor");
		return;
	}

	strcpy(name, nvram_safe_get("wlif"));

	
	memset( buf, '\0', sizeof(buf) );
	memset( web_buf, '\0', sizeof(web_buf) );
	
	if( ejArgs(argc, argv, "%s", &mode ) < 1 )
	{
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}
#if defined(WE800G)
        //system("sitesurvey");
#else
	if(strcmp(nvram_get("wl_mode"), "sta"))
	{
		printf("broadcom.c : before wl_mode is %s\n", nvram_get("wl_mode"));
		nvram_set("wl_mode", "sta");
		nvram_set("wl0_mode", "sta");
		system("sitesurvey");
		sleep(2);
	}
#endif
	if(!strcmp(mode, "all"))
	{	/* do site survey */
		//websWrite ( wp , "%s", sitesurvey_table_header );

#if 1
    tsprintf("site survey all\n");
		if(!strcmp(nvram_safe_get("wl_mode"), "sta" ))
		{

			tsprintf("broadcom.c : WLC_UP\n");
			//wl_ioctl( name, WLC_UP, NULL, sizeof(val) ) ;
                         
			memset(buf,0,sizeof(buf));
			tsprintf("broadcom.c : WLC_SCAN\n");
			wl_ioctl( name, WLC_SCAN, buf, sizeof(buf) );
			usleep(1000000);
			tsprintf("broadcom.c : WLC_SCAN_RESULTS\n");
			wl_ioctl( name, WLC_SCAN_RESULTS, buf, sizeof(buf) );
      wl_ioctl( name, WLC_SCAN_RESULTS, buf, sizeof(buf) );
      tsprintf("------------------\n");
//			sprintf ( web_buf , "<tr bgcolor=\"#DDDDDD\">\n<font face=\"Arial\" size=\"2\"><b>\n
//			 <td height=\"25\" align=\"center\" valign=\"middle\"><font face=\"Arial\" size=\"2\"><b>Type</b></font></td>\n
//			 <td height=\"25\" align=\"center\" valign=\"middle\"><font face=\"Arial\" size=\"2\"><b>SSID</b></font></td>\n
//			 <td align=\"center\" valign=\"middle\"><font face=\"Arial\" size=\"2\"><b>MAC address</b></font></td>\n
//			 <td align=\"center\" valign=\"middle\"><font face=\"Arial\" size=\"2\"><b>Channel</b></font></td>\n
//			 <td align=\"center\" valign=\"middle\"><font face=\"Arial\" size=\"2\"><b>RSSI</b></font></td>\n      
//			 <td align=\"center\" valign=\"middle\"><font face=\"Arial\" size=\"2\"><b>Wireless Mode</b></font></td>\n</b></font></tr>\n");
//
//			websWrite ( wp , "%s", web_buf );
			//list = (wl_scan_results_t *) buf ;
			tsprintf("list->count  : %d\n", list->count );
		}
		
		//websWrite ( wp , "<input type=\"hidden\" name=\"ap_cnt\" value=\"%d\">\n", i );
		//websWrite ( wp , "%s", sitesurvey_table_footer );
#endif

	}
	else if(!strcmp(mode, "channel"))
	{
		tsprintf("site survey one channel\n");
		if(!strcmp(nvram_safe_get("wl_mode"), "sta" ))
		{	
			wl_ioctl( name, WLC_UP, NULL, sizeof(val) ) ;
			wl_ioctl( name, WLC_SCAN, buf, sizeof(buf) );
			usleep(200000);
			wl_ioctl( name, WLC_SCAN_RESULTS, buf, sizeof(buf) );
		}
		
		websWrite ( wp , "<input type=\"hidden\" name=\"ap_cnt\" value=\"%d\">\n", i );
	}

#if 1

  char ssid[33];
	char bssid[18];
        bi=list->bss_info;
	int mode2;
	
	websWrite ( wp , "<table cellSpacing=\"0\" cellPadding=\"0\" width=\"720\" border=\"1\">");
	for( i=0 ; i < list->count ; i++ )
	{
		memset( web_buf, '\0', sizeof(web_buf) );

/*
		rssi = abs(bi->RSSI)-20 ;
		rssi = (5*rssi)/4 ;
		rssi = 100 - rssi ;
*/

		rssi = 100 - abs(bi->RSSI) ;
		
		memset(ssid,0,sizeof(ssid));
                memcpy(ssid,bi->SSID,bi->SSID_len);
		tsprintf("ssid: %s , ",ssid);
		memset(bssid,0,sizeof(bssid));
		sprintf(bssid,"%02X:%02X:%02X:%02X:%02X:%02X",bi->BSSID.octet[0],bi->BSSID.octet[1],bi->BSSID.octet[2],bi->BSSID.octet[3],bi->BSSID.octet[4],bi->BSSID.octet[5]);
                tsprintf("bssid: %s\n",bssid);

		tsprintf("Sitesurvey : bssid : %s bi->RSSI : %d, rssi : %d\n", bssid, bi->RSSI, rssi);
		
		//sprintf(web_buf,"<tr bgcolor=\"%s\">",(i%2)?"#EEEEEE":"#FFFFFF");
		sprintf(web_buf,"<tr>");

                websWrite ( wp , "%s", web_buf );
                mode2 = (bi->capability & 0x01);
		sprintf(web_buf,"<td height=\"15\"  width=\"10%%\" align=\"center\" valign=\"middle\">%s</td>",(mode2)?"Infra":"Adhoc");
		websWrite ( wp , "%s", web_buf );
#if 0
		{
			int i=0;

			for(i=0;i<16;i++)
			{
				websWrite ( wp , "%X", (bi->capability >> i) & 0x01);
			}
		}
#endif
		sprintf(web_buf,"<td align=\"center\" width=\"30%%\" valign=\"middle\">%s</td>",ssid);
                websWrite ( wp , "%s", web_buf );
		sprintf(web_buf,"<td align=\"center\" width=\"20%%\" valign=\"middle\">%s</td>",bssid);
                websWrite ( wp , "%s", web_buf );
		sprintf(web_buf,"<td align=\"center\" width=\"10%%\" valign=\"middle\">%d</td>",bi->channel);
                websWrite ( wp , "%s", web_buf );
		sprintf(web_buf,"<td align=\"center\" width=\"10%%\" valign=\"middle\">%d%%</td>",rssi);
                websWrite ( wp , "%s", web_buf );
		mode2 = ((bi->capability >> 4) & 0x01);
		sprintf(web_buf,"<td align=\"center\" width=\"10%%\" valign=\"middle\">%s</td>",(bi->rateset.count > 4) ? "802.11b/g" : "802.11b");
                websWrite ( wp , "%s", web_buf );
		sprintf(web_buf,"<td align=\"center\" width=\"10%%\" valign=\"middle\">%s</td>",(mode2)?"WEP":"None");
                websWrite ( wp , "%s", web_buf );		
		websWrite ( wp , "</tr>");                
		
		bi = (wl_bss_info_t*)((int8*)bi + bi->length);
	}

	websWrite ( wp , "</table>");		
	websWrite ( wp , "<input type=\"hidden\" name=\"ap_cnt\" value=\"%d\">\n", i );


#endif
#if defined(WE800G)
        /* In WE800G "wl_mode" is always "sta" */
#else
	nvram_set("wl_mode", "wet");
	nvram_set("wl0_mode", "wet");
 	tsprintf("broadcom.c : after wl_mode is %s\n", nvram_get("wl_mode"));
	system("sitesurvey");
	sleep(2);
	//sys_commit();
#endif
	return 0 ;
}
//-----------------------------------------------------------------------------

static int ej_doSite_Survey_Info ( int eid , webs_t wp , int argc , char_t **argv )
{
	char name[10];
	char *mode ;
	unsigned char buf[8192] ;
	unsigned char web_buf[8192] ;
	static int  val;//,ret ;
	wl_bss_info_t *bi;
	wl_scan_results_t *list = (wl_scan_results_t *) buf ;
	uint i = 0, rssi = 0 ;
	char *p = NULL, *q = NULL ;
	FILE *fp = NULL ;
	char tmp[100] ;
	int count = 0 ;
	//if(!strcmp(nvram_safe_get("WlEnable"), "0"))
	if(!strcmp(nvram_safe_get("wl_radio"), "0"))
	{
		websWrite ( wp , "%s", "<tr><td align=\"center\">You must enable Radio Interface to start Site Monitor</td></tr>");
		return;
	}

	strcpy(name, nvram_safe_get("wlif"));

	
	memset( buf, '\0', sizeof(buf) );
	memset( web_buf, '\0', sizeof(web_buf) );
	
	if( ejArgs(argc, argv, "%s", &mode ) < 1 )
	{
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}
#if defined(WE800G)
        //system("sitesurvey");
#else
	if(strcmp(nvram_get("wl_mode"), "sta"))
	{
		printf("broadcom.c : before wl_mode is %s\n", nvram_get("wl_mode"));
		nvram_set("wl_mode", "sta");
		nvram_set("wl0_mode", "sta");
		system("sitesurvey");
		sleep(2);
	}
#endif
	if(!strcmp(mode, "all"))
	{	/* do site survey */
		//websWrite ( wp , "%s", sitesurvey_table_header );

#if 1
    tsprintf("site survey all\n");
		if(!strcmp(nvram_safe_get("wl_mode"), "sta" ))
		{

			tsprintf("broadcom.c : WLC_UP\n");
			//wl_ioctl( name, WLC_UP, NULL, sizeof(val) ) ;
                         
			memset(buf,0,sizeof(buf));
			tsprintf("broadcom.c : WLC_SCAN\n");
			wl_ioctl( name, WLC_SCAN, buf, sizeof(buf) );
			usleep(1000000);
			tsprintf("broadcom.c : WLC_SCAN_RESULTS\n");
			wl_ioctl( name, WLC_SCAN_RESULTS, buf, sizeof(buf) );
      wl_ioctl( name, WLC_SCAN_RESULTS, buf, sizeof(buf) );
      tsprintf("------------------\n");
//			sprintf ( web_buf , "<tr bgcolor=\"#DDDDDD\">\n<font face=\"Arial\" size=\"2\"><b>\n
//			 <td height=\"25\" align=\"center\" valign=\"middle\"><font face=\"Arial\" size=\"2\"><b>Type</b></font></td>\n
//			 <td height=\"25\" align=\"center\" valign=\"middle\"><font face=\"Arial\" size=\"2\"><b>SSID</b></font></td>\n
//			 <td align=\"center\" valign=\"middle\"><font face=\"Arial\" size=\"2\"><b>MAC address</b></font></td>\n
//			 <td align=\"center\" valign=\"middle\"><font face=\"Arial\" size=\"2\"><b>Channel</b></font></td>\n
//			 <td align=\"center\" valign=\"middle\"><font face=\"Arial\" size=\"2\"><b>RSSI</b></font></td>\n      
//			 <td align=\"center\" valign=\"middle\"><font face=\"Arial\" size=\"2\"><b>Wireless Mode</b></font></td>\n</b></font></tr>\n");
//
//			websWrite ( wp , "%s", web_buf );
			//list = (wl_scan_results_t *) buf ;
			tsprintf("list->count  : %d\n", list->count );
		}
		
		//websWrite ( wp , "<input type=\"hidden\" name=\"ap_cnt\" value=\"%d\">\n", i );
		//websWrite ( wp , "%s", sitesurvey_table_footer );
#endif

	}
	else if(!strcmp(mode, "channel"))
	{
		tsprintf("site survey one channel\n");
		if(!strcmp(nvram_safe_get("wl_mode"), "sta" ))
		{	
			wl_ioctl( name, WLC_UP, NULL, sizeof(val) ) ;
			wl_ioctl( name, WLC_SCAN, buf, sizeof(buf) );
			usleep(200000);
			wl_ioctl( name, WLC_SCAN_RESULTS, buf, sizeof(buf) );
		}
		
		websWrite ( wp , "<input type=\"hidden\" name=\"ap_cnt\" value=\"%d\">\n", i );
	}

#if 1

  char ssid[33];
	char bssid[18];
        bi=list->bss_info;
	int mode2;
	
	//websWrite ( wp , "<table cellSpacing=\"0\" cellPadding=\"0\" width=\"720\" border=\"1\">\n");
	for( i=0 ; i < list->count ; i++ )
	{
		memset( web_buf, '\0', sizeof(web_buf) );

/*
		rssi = abs(bi->RSSI)-20 ;
		rssi = (5*rssi)/4 ;
		rssi = 100 - rssi ;
*/

		rssi = 100 - abs(bi->RSSI) ;
		
		memset(ssid,0,sizeof(ssid));
    memcpy(ssid,bi->SSID,bi->SSID_len);
		tsprintf("ssid: %s , ",ssid);
		memset(bssid,0,sizeof(bssid));
		sprintf(bssid,"%02X:%02X:%02X:%02X:%02X:%02X",bi->BSSID.octet[0],bi->BSSID.octet[1],bi->BSSID.octet[2],bi->BSSID.octet[3],bi->BSSID.octet[4],bi->BSSID.octet[5]);
    tsprintf("bssid: %s\n",bssid);

		tsprintf("Sitesurvey : bssid : %s bi->RSSI : %d, rssi : %d\n", bssid, bi->RSSI, rssi);
		
		//sprintf(web_buf,"<tr bgcolor=\"%s\">",(i%2)?"#EEEEEE":"#FFFFFF");
		//sprintf(web_buf,"<tr>");

    //websWrite ( wp , "%s", web_buf );
    //mode2 = (bi->capability & 0x01);
		//sprintf(web_buf,"\t<td height=\"15\"  width=\"10%%\" align=\"center\" valign=\"middle\">%s</td>",(mode2)?"Infra":"Adhoc");
		//websWrite ( wp , "%s", web_buf );
//		sprintf(web_buf,"\t<td align=\"center\" width=\"30%%\" valign=\"middle\">%s</td>\n",ssid);
//		websWrite ( wp , "%s", web_buf );
//		sprintf(web_buf,"\t<td align=\"center\" width=\"20%%\" valign=\"middle\">%s</td>\n",bssid);
//		websWrite ( wp , "%s", web_buf );
//		sprintf(web_buf,"\t<td align=\"center\" width=\"10%%\" valign=\"middle\">%d</td>\n",bi->channel);
//		websWrite ( wp , "%s", web_buf );
//		sprintf(web_buf,"\t<td align=\"center\" width=\"10%%\" valign=\"middle\">%d%%</td>\n",rssi);
//		websWrite ( wp , "%s", web_buf );
//		mode2 = ((bi->capability >> 4) & 0x01);
//		sprintf(web_buf,"\t<td align=\"center\" width=\"10%%\" valign=\"middle\">%s</td>\n",(bi->rateset.count > 4) ? "802.11g" : "802.11b/g");
//		websWrite ( wp , "%s", web_buf );
//		sprintf(web_buf,"\t<td align=\"center\" width=\"10%%\" valign=\"middle\">%s</td>\n",(mode2)?"WEP":"None");
//		websWrite ( wp , "%s", web_buf );		
//		websWrite ( wp , "</tr>\n");                

		websWrite(wp, "\t<script>site_survey_data(\"%s\", \"%s\", \"%s\", \"%d\", \"%d%%\", \"%s\", \"%s\");</script>\n", (bi->capability & 0x01)?"Infra":"Adhoc", ssid, bssid, bi->channel, rssi, (bi->rateset.count > 4) ? "802.11b/g" : "802.11b", ((bi->capability >> 4) & 0x01)?"WEP":"None");
		
		bi = (wl_bss_info_t*)((int8*)bi + bi->length);
	}

	//websWrite ( wp , "</table>\n");		
	websWrite ( wp , "<input type=\"hidden\" name=\"ap_cnt\" value=\"%d\">\n", i );


#endif
#if defined(WE800G)
        /* In WE800G "wl_mode" is always "sta" */
#else
	nvram_set("wl_mode", "wet");
	nvram_set("wl0_mode", "wet");
 	tsprintf("broadcom.c : after wl_mode is %s\n", nvram_get("wl_mode"));
	system("sitesurvey");
	sleep(2);
	//sys_commit();
#endif
	return 0 ;
}
//-----------------------------------------------------------------------------

static int
ej_GetAllVar( int eid , webs_t wp , int argc , char_t **argv )
{
	char buf[10000];
	int i=0,ret=0;
	
	ret = nvram_getall(buf,sizeof(buf));

	for (i=0; i<sizeof(buf) ; i++)
	{		

		if (buf[i] == '\0')
			websWrite(wp,"<br>\n");
		else
			websWrite(wp, "%c", buf[i]);
		if ((buf[i] == '\0') && (buf[i+1] == '\0'))
			break;
	}

	return 1;
}

static int
ej_get_reboot_msg( int eid , webs_t wp , int argc , char_t **argv )
{
 	if(nvram_get("NeedReboot") != NULL)
	{
		if(!strcmp(nvram_get("NeedReboot"), "1"))
		{
			websWrite(wp, "<script>if(top.left.document.forms[0].restart_status != null && top.left.document.forms[0].main_left_btn_restart != null){top.left.document.forms[0].restart_status.value = \"1\"; top.left.document.forms[0].main_left_btn_restart.src = \"main_left_btn_restart_Blink.gif\";}</script>\n");
		}
	}   
	return 0;
}


//-----------------------------------------------------------------------------
static int apply_cgi_connect(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_disconnect(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_Re_associate(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_debug_page(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_Login(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_log_out(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_Apply(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_restart(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_Restore_Defaults(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_wizard(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_redirect_to_reboot(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_backup_configuration(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_restore_configuration(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_restore(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_UpgradeComplete(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_UpgradeFail(char* act, int *action, int *jumpto, webs_t wp);
static int apply_cgi_UpgradeFail4702Only(char* act, int *action, int *jumpto, webs_t wp);
//-----------------------------------------------------------------------------

struct apply_cgi_handler
{
	char* pattern;
	int (*output)(char* act, int *action, int *jumpto, webs_t wp);
};

struct apply_cgi_handler apply_cgi_handlers[]=
{
        /* the first parameter is the action value in web page */
#if 0
	{"wlmac",          	apply_cgi_wlmac},
	{"filterindex",    	apply_cgi_filterindex},
	{"GenKey",         	apply_cgi_GenKey},
	{"GenKey_5G",      	apply_cgi_GenKey_5G},
	{"network_diagnostic",	apply_cgi_network_diagnostic},
	{"TZODDNS",      	apply_cgi_DDNS},
	{"DynDDNS",      	apply_cgi_DDNS},
	{"DHCPStatus",   	apply_cgi_DHCPStatus},
	{"PPPoEStatus",  	apply_cgi_PPPoE_PPTP_Status},
	{"PPTPStatus",   	apply_cgi_PPPoE_PPTP_Status},
	{"PPPStatus",      	apply_cgi_PPPoE_PPTP_Status},
	{"SelFilter",      	apply_cgi_SelFilter},
	{"Release",      	apply_cgi_Release},
	{"Renew",      		apply_cgi_Renew},
#endif
	{"Login", 		apply_cgi_Login},
	{"Logout", 		apply_cgi_log_out},
	{"Apply",      		apply_cgi_Apply},
	{"restart",      	apply_cgi_restart},
	{"Restore_Defaults",	apply_cgi_Restore_Defaults},
	{"wizard.html", 	apply_cgi_wizard},
	{"RedirectToReboot",	apply_cgi_redirect_to_reboot},
	{"backup_configuration",	apply_cgi_backup_configuration},
	{"restore_configuration",	apply_cgi_restore_configuration},
	{"restore",		apply_cgi_restore},
	{"debug_page", apply_cgi_debug_page},
	{"Re-associate", apply_cgi_Re_associate},
	{"disassociate", apply_cgi_disconnect},
	{"associate", apply_cgi_connect},	
	{"UpgradeComplete", apply_cgi_UpgradeComplete},
	{"UpgradeFail", apply_cgi_UpgradeFail},	
	{"Upgrade4702OnlyFail", apply_cgi_UpgradeFail4702Only},	
	{NULL, NULL}

};

//-----------------------------------------------------------------------------








/* Start of 11i passphrase function */

//#define HMAC_DEBUG

#define MAX_MESSAGE_LENGTH 4096

/****************************************/
/* Text output options.                 */
/* Comment out to reduce text output    */
/****************************************/

void debug_out(unsigned char *label, unsigned char *data, int data_length);

/********************************************/
/* Test Cases                               */
/* An array of test cases, each containing  */
/* a block to be processed by michael       */
/********************************************/
#define NUM_TEST_CASES  1

int passphrase_lengths[] = {8, 15, 32};
int ssid_lengths[] = {4, 11, 32};
                                                           
unsigned char passphrases[] =
{
    'p','a','s','s','w','o','r','d',

    'T','h','i','s','I','s','A','P','a','s','s','w','o','r','d',

    'a','a','a','a','a','a','a','a',
    'a','a','a','a','a','a','a','a',
    'a','a','a','a','a','a','a','a',
    'a','a','a','a','a','a','a','a'
};

unsigned char ssids[] =
{

    'I','E','E','E',

    'T','h','i','s','I','s','A','S','S','I','D',

    'Z','Z','Z','Z','Z','Z','Z','Z',
    'Z','Z','Z','Z','Z','Z','Z','Z',
    'Z','Z','Z','Z','Z','Z','Z','Z',
    'Z','Z','Z','Z','Z','Z','Z','Z'
};

/****************************************/
/* sha1()                               */
/* Performs the NIST SHA-1 algorithm    */
/****************************************/

unsigned long int ft(int t, unsigned long int x, unsigned long int y, unsigned long int z)
{
    unsigned long int a,b,c;

    if (t < 20)
    {
        a = x & y;
        b = (~x) & z;
        c = a ^ b;
    }
    else if (t < 40)
    {
        c = x ^ y ^ z;
    }
    else if (t < 60)
    {
        a = x & y;
        b = a ^ (x & z);
        c = b ^ (y & z);
    }
    else if (t < 80)
    {
        c = (x ^ y) ^ z;
    }

    return c;
}

unsigned long int k(int t)
{
    unsigned long int c;

    if (t < 20)
    {
        c = 0x5a827999;
    }
    else if (t < 40)
    {
        c = 0x6ed9eba1;
    }
    else if (t < 60)
    {
        c = 0x8f1bbcdc;
    }
    else if (t < 80)
    {
        c = 0xca62c1d6;
    }

    return c;
}

unsigned long int rotr(int bits, unsigned long int a)
{
    unsigned long int c,d,e,f,g;
    c = (0x0001 << bits)-1;
    d = ~c;

    e = (a & d) >> bits;
    f = (a & c) << (32 - bits);

    g = e | f;

    return (g & 0xffffffff );

}

unsigned long int rotl(int bits, unsigned long int a)
{
    unsigned long int c,d,e,f,g;
    c = (0x0001 << (32-bits))-1;
    d = ~c;

    e = (a & c) << bits;
    f = (a & d) >> (32 - bits);

    g = e | f;

    return (g & 0xffffffff );

}


void sha1(unsigned char *message, int message_length, unsigned char *digest)
{
int i;
int num_blocks;
int block_remainder;
int padded_length;

unsigned long int l;
unsigned long int t;
unsigned long int h[5];
unsigned long int a,b,c,d,e;
unsigned long int w[80];
unsigned long int temp;

#ifdef SHA1_DEBUG
int x,y;
#endif

    /* Calculate the number of 512 bit blocks */

    padded_length = message_length + 8; /* Add length for l */
    padded_length = padded_length + 1; /* Add the 0x01 bit postfix */

    l = message_length * 8;

    num_blocks = padded_length / 64;
    block_remainder = padded_length % 64;


    if (block_remainder > 0)
    {
        num_blocks++;
    }

    padded_length = padded_length + (64 - block_remainder);

     /* clear the padding field */
    for (i = message_length; i < (num_blocks * 64); i++)
    {
        message[i] = 0x00;           
    }

    /* insert b1 padding bit */
    message[message_length] = 0x80;
    
    /* Insert l */
    message[(num_blocks*64)-1] = (unsigned char)( l        & 0xff);
    message[(num_blocks*64)-2] = (unsigned char)((l >> 8)  & 0xff);
    message[(num_blocks*64)-3] = (unsigned char)((l >> 16) & 0xff);
    message[(num_blocks*64)-4] = (unsigned char)((l >> 24) & 0xff);

    /* Set initial hash state */
    h[0] = 0x67452301;
    h[1] = 0xefcdab89;
    h[2] = 0x98badcfe;
    h[3] = 0x10325476;
    h[4] = 0xc3d2e1f0;

#ifdef SHA1_DEBUG
    printf("INITIAL message_length = %d\n", message_length);
    printf("INITIAL padded_length = %d\n", padded_length);
    printf("INITIAL num_blocks = %d\n", num_blocks);

        for (x=0;x<num_blocks; x++)
        {
            printf("\t\t"); 
            for (y=0; y<16;y++)
            {
                printf("%02x ",message[y + (x*64)]);
            }
            printf("\n");
            printf("\t\t"); 
            for (y=0; y<16;y++)
            {
                printf("%02x ",message[16 + y + (x*64)]);
            }
            printf("\n");
            printf("\t\t"); 
            for (y=0; y<16;y++)
            {
                printf("%02x ",message[32 + y + (x*64)]);
            }
            printf("\n");
            printf("\t\t"); 
            for (y=0; y<16;y++)
            {
                printf("%02x ",message[48 + y + (x*64)]);
            }
            printf("\n");
        }

#endif

    for (i = 0; i < num_blocks; i++)
    {
        /* Prepare the message schedule */
        for (t=0; t < 80; t++)
        {
            if (t < 16)
            {
                w[t]  = (256*256*256) * message[(i*64)+(t*4)];
                w[t] += (256*256    ) * message[(i*64)+(t*4) + 1];
                w[t] += (256        ) * message[(i*64)+(t*4) + 2];
                w[t] +=                 message[(i*64)+(t*4) + 3];
            }
            else if (t < 80)
            {
                w[t] = rotl(1,(w[t-3] ^ w[t-8] ^ w[t-14] ^ w[t-16]));
            }
        }

#ifdef SHA1_DEBUG
        printf("\tW(0) = %08lX \t W(9)  = %08lX \n", w[0], w[8]);
        printf("\tW(1) = %08lX \t W(10) = %08lX \n", w[1], w[9]);
        printf("\tW(2) = %08lX \t W(11) = %08lX \n", w[2], w[10]);
        printf("\tW(3) = %08lX \t W(12) = %08lX \n", w[3], w[11]);
        printf("\tW(4) = %08lX \t W(13) = %08lX \n", w[4], w[12]);
        printf("\tW(5) = %08lX \t W(14) = %08lX \n", w[5], w[13]);
        printf("\tW(6) = %08lX \t W(15) = %08lX \n", w[6], w[14]);
        printf("\tW(7) = %08lX \t W(16) = %08lX \n\n", w[7], w[15]);

#endif
        /* Initialize the five working variables */
        a = h[0];
        b = h[1];
        c = h[2];
        d = h[3];
        e = h[4];

        /* iterate a-e 80 times */

        for (t = 0; t < 80; t++)
        {
            temp = (rotl(5,a) + ft(t,b,c,d)) & 0xffffffff;
            temp = (temp + e) & 0xffffffff;
            temp = (temp + k(t)) & 0xffffffff;
            temp = (temp + w[t]) & 0xffffffff;
            e = d;
            d = c;
            c = rotl(30,b);
            b = a;
            a = temp;
#ifdef SHA1_DEBUG
            printf("t = %2ld\t %08lx, %08lx, %08lx, %08lx, %08lx\n", t,a,b,c,d,e);
#endif

        }

        /* compute the ith intermediate hash value */
#ifdef SHA1_DEBUG
        printf("  +   \t %08lx, %08lx, %08lx, %08lx, %08lx\n", h[0],h[1],h[2],h[3],h[4]);
#endif
        h[0] = (a + h[0]) & 0xffffffff;
        h[1] = (b + h[1]) & 0xffffffff;
        h[2] = (c + h[2]) & 0xffffffff;
        h[3] = (d + h[3]) & 0xffffffff;
        h[4] = (e + h[4]) & 0xffffffff;

#ifdef SHA1_DEBUG
        printf("  =   \t %08lx, %08lx, %08lx, %08lx, %08lx\n", h[0],h[1],h[2],h[3],h[4]);
#endif

    }

    digest[3]  = (unsigned char) ( h[0]       & 0xff);
    digest[2]  = (unsigned char) ((h[0] >> 8) & 0xff);
    digest[1]  = (unsigned char) ((h[0] >> 16) & 0xff);
    digest[0]  = (unsigned char) ((h[0] >> 24) & 0xff);

    digest[7]  = (unsigned char) ( h[1]       & 0xff);
    digest[6]  = (unsigned char) ((h[1] >> 8) & 0xff);
    digest[5]  = (unsigned char) ((h[1] >> 16) & 0xff);
    digest[4]  = (unsigned char) ((h[1] >> 24) & 0xff);

    digest[11]  = (unsigned char) ( h[2]       & 0xff);
    digest[10]  = (unsigned char) ((h[2] >> 8) & 0xff);
    digest[9] = (unsigned char) ((h[2] >> 16) & 0xff);
    digest[8] = (unsigned char) ((h[2] >> 24) & 0xff);

    digest[15] = (unsigned char) ( h[3]       & 0xff);
    digest[14] = (unsigned char) ((h[3] >> 8) & 0xff);
    digest[13] = (unsigned char) ((h[3] >> 16) & 0xff);
    digest[12] = (unsigned char) ((h[3] >> 24) & 0xff);

    digest[19] = (unsigned char) ( h[4]       & 0xff);
    digest[18] = (unsigned char) ((h[4] >> 8) & 0xff);
    digest[17] = (unsigned char) ((h[4] >> 16) & 0xff);
    digest[16] = (unsigned char) ((h[4] >> 24) & 0xff);

}

/******************************************************/
/* hmac-sha1()                                        */
/* Performs the hmac-sha1 keyed secure hash algorithm */
/******************************************************/

void hmac_sha1(unsigned char *key, int key_length, unsigned char *data, int data_length, unsigned char *digest)

{
    int b = 64; /* blocksize */
    unsigned char ipad = 0x36;

    unsigned char opad = 0x5c;

    unsigned char k0[64];
    unsigned char k0xorIpad[64];
    unsigned char step7data[64];
    unsigned char step5data[MAX_MESSAGE_LENGTH+128];
    //unsigned char step8data[64+20];

    unsigned char step8data[128];//[64+20];	// modified by Jimmy Ma 2003.5.16
    int i;

    for (i=0; i<64; i++)
    {
        k0[i] = 0x00;
    }



    if (key_length != b)    /* Step 1 */
    {
        /* Step 2 */
        if (key_length > b)      
        {
            sha1(key, key_length, digest);
            for (i=0;i<20;i++)
            {
                k0[i]=digest[i];
            }
        }
        else if (key_length < b)  /* Step 3 */
        {
            for (i=0; i<key_length; i++)
            {
                k0[i] = key[i];
            }
        }
    }
    else
    {
        for (i=0;i<b;i++)
        {
            k0[i] = key[i];
        }
    }
#ifdef HMAC_DEBUG
    debug_out("k0",k0,64);
#endif
    /* Step 4 */
    for (i=0; i<64; i++)
    {
        k0xorIpad[i] = k0[i] ^ ipad;
    }
#ifdef HMAC_DEBUG
    debug_out("k0 xor ipad",k0xorIpad,64);
#endif
    /* Step 5 */
    for (i=0; i<64; i++)
    {
        step5data[i] = k0xorIpad[i];
    }
    for (i=0;i<data_length;i++)
    {
        step5data[i+64] = data[i];
    }
#ifdef HMAC_DEBUG
    debug_out("(k0 xor ipad) || text",step5data,data_length+64);
#endif

    /* Step 6 */
    sha1(step5data, data_length+b, digest);

#ifdef HMAC_DEBUG
    debug_out("Hash((k0 xor ipad) || text)",digest,20);
#endif

    /* Step 7 */
    for (i=0; i<64; i++)
    {
        step7data[i] = k0[i] ^ opad;
    }

#ifdef HMAC_DEBUG
    debug_out("(k0 xor opad)",step7data,64);
#endif

    /* Step 8 */
    for (i=0;i<64;i++)
    {
        step8data[i] = step7data[i];
    }
    for (i=0;i<20;i++)
    {
        step8data[i+64] = digest[i];
    }

#ifdef HMAC_DEBUG
    debug_out("(k0 xor opad) || Hash((k0 xor ipad) || text)",step8data,20+64);
#endif

    /* Step 9 */
    sha1(step8data, b+20, digest);

#ifdef HMAC_DEBUG
    debug_out("HASH((k0 xor opad) || Hash((k0 xor ipad) || text))",digest,20);
#endif

}


/*****************************/
/* password_hash()           */
/*****************************/
void password_hash_src(unsigned char *password, int password_length, unsigned char *ssid, int ssid_length, int iterations, int ctr, unsigned char *hash)
{
    int i,j;
    unsigned char digest[36];
    unsigned char digest1[20];

    for (i=0; i< ssid_length; i++)
    {
        digest[i] = ssid[i];
    }
    digest[ssid_length]   = (unsigned char)((ctr / (256*256*256)) & 0xff);
    digest[ssid_length+1] = (unsigned char)((ctr / (256*256)) & 0xff);
    digest[ssid_length+2] = (unsigned char)((ctr / (256)) & 0xff);
    digest[ssid_length+3] = (unsigned char) (ctr & 0xff);
    hmac_sha1(password, password_length, digest, ssid_length+4, digest1);
    for (j=0; j<20; j++)
    {
        hash[j] = digest1[j];   
    }

    for (i=0; i<(iterations-1); i++)
    {

        hmac_sha1(password, password_length, digest1, 20, digest);

        for (j=0; j<20; j++)
        {
            digest1[j] = digest[j];
        }

        for(j=0; j<20; j++)
        {
            hash[j] = hash[j] ^ digest[j];
        }
    }
}

void password_hash(unsigned char *password, int password_length, unsigned char *ssid, int ssid_length, unsigned char *hash)
{
    password_hash_src(password, password_length, ssid, ssid_length, 4096, 1, hash);
    password_hash_src(password, password_length, ssid, ssid_length, 4096, 2, hash+20);
}

/************************************************/
/* get_testcase()                               */
/* Copies an mpdu from the test case data       */
/************************************************/
void get_testcase(int test_case, unsigned char *passphrase, int *passphrase_length, unsigned char *ssid, int *ssid_length)
{
    strcpy(passphrase, nvram_get("wl_passphrase"));
    *passphrase_length = strlen(nvram_get("wl_passphrase"));
    strcpy(ssid, nvram_get("wl_ssid"));
    *ssid_length = strlen(nvram_get("wl_ssid"));
}

//-----------------------------------------------------------------------------

void get_testcase_we800g(int test_case, unsigned char *passphrase, int *passphrase_length, unsigned char *ssid, int *ssid_length, int profile)
{
  switch(profile)
  {
    case 1:
      strcpy(passphrase, nvram_get("wl_passphrase_wp1"));
      *passphrase_length = strlen(nvram_get("wl_passphrase_wp1"));
      strcpy(ssid, nvram_get("wl_ssid_wp1"));
      *ssid_length = strlen(nvram_get("wl_ssid_wp1"));
      break;
    case 2:
      strcpy(passphrase, nvram_get("wl_passphrase_wp2"));
      *passphrase_length = strlen(nvram_get("wl_passphrase_wp2"));
      strcpy(ssid, nvram_get("wl_ssid_wp2"));
      *ssid_length = strlen(nvram_get("wl_ssid_wp2"));
      break;
  }
}

//-----------------------------------------------------------------------------

void debug_out(unsigned char *label, unsigned char *data, int data_length)
{
int i,j;
int num_blocks;
int block_remainder;
    num_blocks = data_length / 16;
    block_remainder = data_length % 16;

    printf("%s\n",label);

    for (i=0; i< num_blocks;i++)
    {
        printf("\t");
        for (j=0; j< 16;j++)
        {
            printf("%02x ", data[j + (i*16)]);
        }
        printf("\n");
    }

    if (block_remainder > 0)
    {
        printf("\t");
        for (j=0; j<block_remainder; j++)
        {
            printf("%02x ", data[j+(num_blocks*16)]);
        }
        printf("\n");
    }

}

/* End of 11i passphrase function */












static unsigned char hash[65];

#define PROFILE_1 1
#define PROFILE_2 2
void gen_11i_passphrase_key_we800g(int profile)
{
  unsigned char passphrase[65];
  unsigned char ssid[65];

//  unsigned char key_buf[33];
  int passphrase_length;
  int ssid_length;

  int test_case;


  for (test_case = 1; test_case < (NUM_TEST_CASES+1); test_case++)
  {
      get_testcase_we800g(test_case, passphrase, &passphrase_length, ssid, &ssid_length, profile);
      password_hash(passphrase, passphrase_length, ssid, ssid_length, hash);
  }

  memset(key_buf, 0, 33);
  memcpy(key_buf, hash, 32);
//  switch(profile)
//  {     
//    case PROFILE_1:
//      nvram_set("Passphrase_key_11i_wp1", key_buf);
//      break;
//    case PROFILE_2:
//      nvram_set("Passphrase_key_11i_wp2", key_buf);
//      break;
//  }
//
//  if (profile==atoi(nvram_get("wl_profile")))
//    nvram_set("Passphrase_key_11i", key_buf);
}

void gen_11i_passphrase_key()
{
  unsigned char passphrase[65];
  unsigned char ssid[65];

//  unsigned char key_buf[33];
  int passphrase_length;
  int ssid_length;

  int test_case;


  for (test_case = 1; test_case < (NUM_TEST_CASES+1); test_case++)
  {
      get_testcase(test_case, passphrase, &passphrase_length, ssid, &ssid_length);

      //printf ("\nTEST CASE %d\n",test_case);

      password_hash(passphrase, passphrase_length, ssid, ssid_length, hash);
      /*debug_out("Password =", passphrase, passphrase_length);
      debug_out("ssid =", ssid, ssid_length);
*/
      //printf("\tPassphrase = %s\n",passphrase);
      //printf("\tSSID       = %s\n",ssid);
      //debug_out("\thash =", hash, 32);
  }

  memset(key_buf, 0, 33);
  memcpy(key_buf, hash, 32);
  nvram_set("Passphrase_key_11i", key_buf);
}


static int apply_cgi_PageName_frame_wireless_basic_asp(char* pagename, int *action, int *jumpto, webs_t wp)
{
//	char *p, *pstr;
	tsprintf("apply_cgi_PageName_frame_wireless_basic_asp : %s\n", pagename);
	gen_11i_passphrase_key();
	*action = NOTHING;
	*jumpto = JUMP_NOTHING;
	return *action;
}

static int apply_cgi_PageName_frame_wp1_basic_asp(char* pagename, int *action, int *jumpto, webs_t wp)
{
//	char *p, *pstr;
	//gen_11i_passphrase_key_we800g(1);
	*action = NOTHING;
	*jumpto = JUMP_NOTHING;
	return *action;
} 


static int apply_cgi_PageName_frame_wp2_basic_asp(char* pagename, int *action, int *jumpto, webs_t wp)
{
//	char *p, *pstr;
	//gen_11i_passphrase_key_we800g(2);
	*action = NOTHING;
	*jumpto = JUMP_NOTHING;
	return *action;
}

//-----------------------------------------------------------------------------
static int apply_cgi_PageName_reboot_footer(char* pagename, int *action, int *jumpto, webs_t wp)
{
	tsprintf("apply_cgi_PageName_reboot_footer : %s\n", pagename);
/*
	websHeader(wp);
	websWrite(wp, (char_t *) apply_header);
	websWrite(wp, (char_t *) reboot_footer);
	action = REBOOT;
*/
	return *action;
}


//-----------------------------------------------------------------------------
static int apply_cgi_PageName_frame_wireless_security_asp(char* pagename, int *action, int *jumpto, webs_t wp)
{
//	char *p, *pstr;
	tsprintf("apply_cgi_PageName_frame_wireless_security_asp : %s\n", pagename);

	printf("Key Info : Input method : %s Key Lnegth : %s\n", nvram_get("wl_key_input_method"), nvram_get("wl_key_strength"));
	if(!strcmp(nvram_get("wl_key_input_method"), "0")) /* 0 */
	{
		if(!strcmp(nvram_get("wl_key_strength"), "64")) /* 64 128 */
		{
//			unsigned char key_buf[65] = {0};
			unsigned char buf[65] = {0};
			gen_11i_passphrase_key();
//			strncpy(key_buf, nvram_get("Passphrase_key_11i"), 65);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[0], key_buf[1], key_buf[2], key_buf[3], key_buf[4]);
			nvram_set("wl_key1", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[8], key_buf[9], key_buf[10], key_buf[11], key_buf[12]);
			nvram_set("wl_key2", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[16], key_buf[17], key_buf[18], key_buf[19], key_buf[20]);
			nvram_set("wl_key3", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[24], key_buf[25], key_buf[26], key_buf[27], key_buf[28]);
			nvram_set("wl_key4", buf);			
			
			printf("Final result : \n");
			printf("1 : %s\n2 : %s\n3 : %s\n4 : %s\n", nvram_get("wl_key1"), nvram_get("wl_key2"), nvram_get("wl_key3"), nvram_get("wl_key4"));
		}
		else if(!strcmp(nvram_get("wl_key_strength"), "128"))
		{
//			unsigned char key_buf[65] = {0};
			unsigned char buf[65] = {0};
			gen_11i_passphrase_key();
//			strncpy(key_buf, nvram_get("Passphrase_key_11i"), 65);
			sprintf(buf, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", key_buf[0], key_buf[1], key_buf[2], key_buf[3], key_buf[4], key_buf[5], key_buf[6], key_buf[7], key_buf[8], key_buf[9], key_buf[10], key_buf[11], key_buf[12]);
			nvram_set("wl_key1", buf);			
			sprintf(buf, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", key_buf[16], key_buf[17], key_buf[18], key_buf[19], key_buf[20], key_buf[21], key_buf[22], key_buf[23], key_buf[24], key_buf[25], key_buf[26], key_buf[27], key_buf[28]);			
			nvram_set("wl_key2", buf);
			nvram_set("wl_key3", "");
			nvram_set("wl_key4", "");			
			
			printf("Final result : \n");
			printf("1 : %s\n2 : %s\n3 : %s\n4 : %s\n", nvram_get("wl_key1"), nvram_get("wl_key2"), nvram_get("wl_key3"), nvram_get("wl_key4"));
			
		}
		else
		{
			printf("Unknown wl_key_strength!\n"); 
			*action = NOTHING;
			*jumpto = JUMP_NOTHING;
			return *action;
		}
	}


	*action = NOTHING;
	*jumpto = JUMP_NOTHING;

	return *action;
}

//-----------------------------------------------------------------------------
static int apply_cgi_PageName_frame_wp1_security_asp(char* pagename, int *action, int *jumpto, webs_t wp)
{
//	char *p, *pstr;
	tsprintf("apply_cgi_PageName_frame_wp1_security_asp : %s\n", pagename);

	tsprintf("Key Info : Input method : %s, Key Lnegth : %s, wep: %s\n", nvram_get("wl_key_input_method_wp1"), nvram_get("wl_key_strength_wp1"), nvram_get("wl_wep_wp1"));
	if(!strcmp(nvram_get("wl_key_input_method_wp1"), "0")) /* 0 */
	{
//		unsigned char key_buf[65] = {0};
		unsigned char buf[65] = {0};
		gen_11i_passphrase_key_we800g(PROFILE_1);
//		strncpy(key_buf, nvram_get("Passphrase_key_11i_wp1"), 65);

		if(!strcmp(nvram_get("wl_key_strength_wp1"), "64")) /* 64 128 */
		{
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[0], key_buf[1], key_buf[2], key_buf[3], key_buf[4]);
			nvram_set("wl_key1_wp1", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[8], key_buf[9], key_buf[10], key_buf[11], key_buf[12]);
			nvram_set("wl_key2_wp1", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[16], key_buf[17], key_buf[18], key_buf[19], key_buf[20]);
			nvram_set("wl_key3_wp1", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[24], key_buf[25], key_buf[26], key_buf[27], key_buf[28]);
			nvram_set("wl_key4_wp1", buf);
		}
		else if(!strcmp(nvram_get("wl_key_strength_wp1"), "128"))
		{
			sprintf(buf, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", key_buf[0], key_buf[1], key_buf[2], key_buf[3], key_buf[4], key_buf[5], key_buf[6], key_buf[7], key_buf[8], key_buf[9], key_buf[10], key_buf[11], key_buf[12]);
			nvram_set("wl_key1_wp1", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", key_buf[16], key_buf[17], key_buf[18], key_buf[19], key_buf[20], key_buf[21], key_buf[22], key_buf[23], key_buf[24], key_buf[25], key_buf[26], key_buf[27], key_buf[28]);			
			nvram_set("wl_key2_wp1", buf);
			nvram_set("wl_key3_wp1", "");
			nvram_set("wl_key4_wp1", "");
		}
		else
		{
			//printf("Unknown wl_key_strength!\n");
			*action = NOTHING;
			*jumpto = JUMP_NOTHING;
			return *action;
		} 

		tsprintf("Final result : \n");
		tsprintf("1 : %s\n2 : %s\n3 : %s\n4 : %s\n", nvram_get("wl_key1_wp1"), nvram_get("wl_key2_wp1"), nvram_get("wl_key3_wp1"), nvram_get("wl_key4_wp1"));

	}


	*action = NOTHING;
	*jumpto = JUMP_NOTHING;

	return *action;
}

//-----------------------------------------------------------------------------
static int apply_cgi_PageName_frame_wp2_security_asp(char* pagename, int *action, int *jumpto, webs_t wp)
{
//	char *p, *pstr;
	tsprintf("apply_cgi_PageName_frame_wp2_security_asp : %s\n", pagename);

	tsprintf("Key Info : Input method : %s, Key Lnegth : %s, wep: %s\n", nvram_get("wl_key_input_method_wp2"), nvram_get("wl_key_strength_wp2"), nvram_get("wl_wep_wp2"));
	if(!strcmp(nvram_get("wl_key_input_method_wp2"), "0")) /* 0 */
	{
//		unsigned char key_buf[65] = {0};
		unsigned char buf[65] = {0};
		gen_11i_passphrase_key_we800g(PROFILE_2);
//		strncpy(key_buf, nvram_get("Passphrase_key_11i_wp2"), 65);

		if(!strcmp(nvram_get("wl_key_strength_wp2"), "64")) /* 64 128 */
		{
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[0], key_buf[1], key_buf[2], key_buf[3], key_buf[4]);
			nvram_set("wl_key1_wp2", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[8], key_buf[9], key_buf[10], key_buf[11], key_buf[12]);
			nvram_set("wl_key2_wp2", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[16], key_buf[17], key_buf[18], key_buf[19], key_buf[20]);
			nvram_set("wl_key3_wp2", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[24], key_buf[25], key_buf[26], key_buf[27], key_buf[28]);
			nvram_set("wl_key4_wp2", buf);
		}
		else if(!strcmp(nvram_get("wl_key_strength_wp2"), "128"))
		{
			sprintf(buf, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", key_buf[0], key_buf[1], key_buf[2], key_buf[3], key_buf[4], key_buf[5], key_buf[6], key_buf[7], key_buf[8], key_buf[9], key_buf[10], key_buf[11], key_buf[12]);
			nvram_set("wl_key1_wp2", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", key_buf[16], key_buf[17], key_buf[18], key_buf[19], key_buf[20], key_buf[21], key_buf[22], key_buf[23], key_buf[24], key_buf[25], key_buf[26], key_buf[27], key_buf[28]);			
			nvram_set("wl_key2_wp2", buf);
			nvram_set("wl_key3_wp2", "");
			nvram_set("wl_key4_wp2", "");
		}
		else
		{
			//printf("Unknown wl_key_strength!\n");
			*action = NOTHING;
			*jumpto = JUMP_NOTHING;
			return *action;
		} 

		tsprintf("Final result : \n");
		tsprintf("1 : %s\n2 : %s\n3 : %s\n4 : %s\n", nvram_get("wl_key1_wp2"), nvram_get("wl_key2_wp2"), nvram_get("wl_key3_wp2"), nvram_get("wl_key4_wp2"));

	}


	*action = NOTHING;
	*jumpto = JUMP_NOTHING;

	return *action;
}
//-----------------------------------------------------------------------------


//-----------------------------------------------------------------------------

//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------
//-----------------------------------------------------------------------------

struct apply_cgi_PageName
{
	char* pattern;
	int (*output)(char* pagename, int *action, int *jumpto, webs_t wp);
};

struct apply_cgi_PageName apply_cgi_PageNames[]=
{
#if 0
	{"IPMACFilter",      apply_cgi_PageName_applycontinueclose_footer},
	{"WlMACFilter",      apply_cgi_PageName_applycontinueclose_footer},
	{"WEPKey",      apply_cgi_PageName_applycontinueclose_footer_REBOOT},
	{"WEPKey_5G",      apply_cgi_PageName_applycontinueclose_footer_REBOOT},
	{"MAClone",      apply_cgi_PageName_MAClone},
	{"PortForward",      apply_cgi_PageName_PortForward},
	{"frame_internet_advanced_WAN.asp", apply_cgi_PageName_frame_internet_advanced_WAN_asp},
	{"frame_networking_dns_proxy.asp", apply_cgi_PageName_frame_networking_dns_proxy_asp},
	{"frame_parental_control_content_policy.asp", apply_cgi_PageName_frame_parental_control_content_policy_asp},

#endif
	{"frame_wireless_basic.asp", apply_cgi_PageName_frame_wireless_basic_asp},
	{"frame_wp1_basic.asp", apply_cgi_PageName_frame_wp1_basic_asp},
	{"frame_wp2_basic.asp", apply_cgi_PageName_frame_wp2_basic_asp}, 
	{"reboot", apply_cgi_PageName_reboot_footer},
	{"frame_wireless_security.asp", apply_cgi_PageName_frame_wireless_security_asp},
#if defined(MOTOROLA_WE800G)
	{"frame_wp1_security.asp", apply_cgi_PageName_frame_wp1_security_asp},
	{"frame_wp2_security.asp", apply_cgi_PageName_frame_wp2_security_asp},
#endif
	{NULL, NULL}
};





/* Deal with side effects before committing */

static int
sys_commit(void)
{
#if defined(MOTOROLA_WE800G)

#else
	if (nvram_match("wan_proto", "pppoe"))
		nvram_set("wan_ifname", "ppp0");
	else
		nvram_set("wan_ifname", nvram_get("pppoe_ifname"));
#endif

	//fprintf(stderr, "nvram_commit...");
	sleep(3);
	//fprintf(stderr, "done");
	
	return nvram_commit();
}






#if defined(WE800G)
static int ej_wp1_nvram_get(int eid, webs_t wp, int argc, char_t **argv)
{
	char *name, *c;
	int ret = 0;

	/* append "_wp1" to the original name */
        char profile_name[32]="";
 	if (ejArgs(argc, argv, "%s", &name) < 1) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	strcpy(profile_name,name);
	strcat(profile_name,"_wp1");

	if(!strcmp(name, "wl_passphrase"))
	{
			for (c = nvram_safe_get(profile_name); *c; c++) {
	     		if (isprint((int) *c) &&
			    *c != '\'' && *c != '"' && *c != '&' && *c != '<' && *c != '>')
				ret += websWrite(wp, "%c", *c);
			else
				ret += websWrite(wp, "\\%c", *c);
		}
	}
	else
	{	
		for (c = nvram_safe_get(profile_name); *c; c++) {
	     		if (isprint((int) *c) &&
			    *c != '\'' && *c != '"' && *c != '&' && *c != '<' && *c != '>')
				ret += websWrite(wp, "%c", *c);
			else
				ret += websWrite(wp, "&#%d", *c);
		}
	}
	
	return ret;
}

static int ej_wp2_nvram_get(int eid, webs_t wp, int argc, char_t **argv)
{
	char *name, *c;
	int ret = 0;

	/* append "_wp2" to the original name */
        char profile_name[32]="";

	if (ejArgs(argc, argv, "%s", &name) < 1) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	strcpy(profile_name,name);
	strcat(profile_name,"_wp2");
	
	if(!strcmp(name, "wl_passphrase"))
	{
			for (c = nvram_safe_get(profile_name); *c; c++) {
	     		if (isprint((int) *c) &&
			    *c != '\'' && *c != '"' && *c != '&' && *c != '<' && *c != '>')
				ret += websWrite(wp, "%c", *c);
			else
				ret += websWrite(wp, "\\%c", *c);
		}
	}
	else
	{	
		for (c = nvram_safe_get(profile_name); *c; c++) {
	     		if (isprint((int) *c) &&
			    *c != '\'' && *c != '"' && *c != '&' && *c != '<' && *c != '>')
				ret += websWrite(wp, "%c", *c);
			else
				ret += websWrite(wp, "&#%d", *c);
		}
	}

	return ret;
}
#endif


#if defined(WE800G)
static int ej_wp1_nvram_match(int eid, webs_t wp, int argc, char_t **argv)
{
	char *name, *match, *output;
	/* append "_wp1" to the original name */
	char profile_name[32]="";

	if (ejArgs(argc, argv, "%s %s %s", &name, &match, &output) < 3) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	strcpy(profile_name,name);
	strcat(profile_name,"_wp1");
	if (nvram_match(profile_name, match))
		return websWrite(wp, output);
	return 0;
}
//-----------------------------------------------------------------------------
static int ej_wp2_nvram_match(int eid, webs_t wp, int argc, char_t **argv)
{
	char *name, *match, *output;
	/* append "_wp2" to the original name */
	char profile_name[32]="";

	if (ejArgs(argc, argv, "%s %s %s", &name, &match, &output) < 3) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	strcpy(profile_name,name);
	strcat(profile_name,"_wp2");
	if (nvram_match(profile_name, match))
		return websWrite(wp, output);
	return 0;
}
//-----------------------------------------------------------------------------
static int ej_nvram_dump(int eid, webs_t wp, int argc, char_t **argv)
{
        /* create file: /tmp/var/tmp/nvram */
#if 0
	pid_t pid;
	int ret = EINVAL;
	tsprintf("start to create /tmp/var/tmp/nvram\n");

        _eval("/usr/sbin/nvram show",">/tmp/var/tmp/nvram", 0, &pid);
	waitpid(pid, &ret, 0);
        tsprintf("create done\n");
	system("/usr/sbin/nvram show > /tmp/var/tmp/nvram");
	sleep(1);

#endif
	FILE *fp = NULL;
        char nvram_buf[NVRAM_SPACE];
	char temp[1024];
	char *p;
	fp = fopen("/tmp/var/tmp/nvram","w");
	if (!fp)
	{
		tsprintf("can't open /tmp/var/tmp/nvram\n");
		return -1;
	}

	/* get names and values in nvram */
	nvram_getall(nvram_buf, sizeof(nvram_buf));

	for(p=nvram_buf; *p ; p+=strlen(p)+1)
	{
		memset(temp,0,sizeof(temp));
		sprintf(temp,"nvram_%s",p);
		fprintf(fp,"%s\n",temp);
	}

	fclose(fp);
	return 0;
}


//-----------------------------------------------------------------------------
#endif  /*if defined(WE800G)*/
















#endif  /* end of #if defined(MOTOROLA_SERIES) */

















/* Upgrade from remote server or socket stream */
static int
sys_upgrade(char *url, FILE *stream, int *total)
{
	char upload_fifo[] = "/tmp/uploadXXXXXX";
	FILE *fifo = NULL;
	char *write_argv[] = { "write", upload_fifo, "linux", NULL };
	pid_t pid;
	char *buf = NULL;
	int count, ret = 0;
	long flags = -1;
	int size = BUFSIZ;
	if (url)
		return eval("write", url, "linux");


	/* Feed write from a temporary FIFO */
	if (!mktemp(upload_fifo) ||
	    mkfifo(upload_fifo, S_IRWXU) < 0 ||
	    (ret = _eval(write_argv, NULL, 0, &pid)) ||
	    !(fifo = fopen(upload_fifo, "w")))
	{
		if (!ret)
			ret = errno;
		tsprintf("broadcom.c: 1 sys_upgrade return value: %d\n",ret);
		goto err;
	}

	/* Set nonblock on the socket so we can timeout */
	if ((flags = fcntl(fileno(stream), F_GETFL)) < 0 ||
	    fcntl(fileno(stream), F_SETFL, flags | O_NONBLOCK) < 0) {
		ret = errno;
		tsprintf("broadcom.c: 2 sys_upgrade return value: %d\n",ret);
		goto err;
	}

	/*
	* The buffer must be at least as big as what the stream file is
	* using so that it can read all the data that has been buffered 
	* in the stream file. Otherwise it would be out of sync with fn
	* select specially at the end of the data stream in which case
	* the select tells there is no more data available but there in 
	* fact is data buffered in the stream file's buffer. Since no
	* one has changed the default stream file's buffer size, let's
	* use the constant BUFSIZ until someone changes it.
	*/
	if (size < MIN_BUF_SIZE)
		size = MIN_BUF_SIZE;
	if ((buf = malloc(size)) == NULL) {
		ret = ENOMEM;
		tsprintf("broadcom.c: 3 sys_upgrade return value: %d\n",ret);
		goto err;
	}
	
	/* Pipe the rest to the FIFO */
	cprintf("Upgrading");
#if defined(MOTOROLA_SERIES)
        tsprintf("\nbroadcom.c: motorola Upgrading\n");
#endif
	while (total && *total) {
		if (waitfor(fileno(stream), 5) <= 0)
			break;
		count = safe_fread(buf, 1, size, stream);
		if (!count && (ferror(stream) || feof(stream)))
			break;
		*total -= count;

		safe_fwrite(buf, 1, count, fifo);
		cprintf("-");
	}
	fclose(fifo);
	fifo = NULL;

	/* Wait for write to terminate */
	waitpid(pid, &ret, 0);
	cprintf("done\n");
#if defined(MOTOROLA_SERIES)
        tsprintf("broadcom.c: motorola done\n");
#endif
	/* Reset nonblock on the socket */
	if (fcntl(fileno(stream), F_SETFL, flags) < 0) {
		ret = errno;
		tsprintf("broadcom.c: 4 sys_upgrade return value: %d\n",ret);
		goto err;
	}

 err:
 	if (buf)
		free(buf);
	if (fifo)
		fclose(fifo);
	unlink(upload_fifo);
#if defined(MOTOROLA_SERIES)
	tsprintf("broadcom.c: 5 sys_upgrade return value: %d\n",ret);
#endif
	return ret;
}

#endif

/* Dump firewall log */
static int
ej_dumplog(int eid, webs_t wp, int argc, char_t **argv)
{
	char buf[4096], *line, *next, *s;
	int len, ret = 0;

	time_t tm;
	char *verdict, *src, *dst, *proto, *spt, *dpt;

	if (klogctl(3, buf, 4096) < 0) {
		websError(wp, 400, "Insufficient memory\n");
		return -1;
	}

	for (next = buf; (line = strsep(&next, "\n"));) {
		if (!strncmp(line, "<4>DROP", 7))
			verdict = "denied";
		else if (!strncmp(line, "<4>ACCEPT", 9))
			verdict = "accepted";
		else
			continue;

		/* Parse into tokens */
		s = line;
		len = strlen(s);
		while (strsep(&s, " "));

		/* Initialize token values */
		time(&tm);
		src = dst = proto = spt = dpt = "n/a";

		/* Set token values */
		for (s = line; s < &line[len] && *s; s += strlen(s) + 1) {
			if (!strncmp(s, "TIME=", 5))
				tm = strtoul(&s[5], NULL, 10);
			else if (!strncmp(s, "SRC=", 4))
				src = &s[4];
			else if (!strncmp(s, "DST=", 4))
				dst = &s[4];
			else if (!strncmp(s, "PROTO=", 6))
				proto = &s[6];
			else if (!strncmp(s, "SPT=", 4))
				spt = &s[4];
			else if (!strncmp(s, "DPT=", 4))
				dpt = &s[4];
		}

		ret += websWrite(wp, "%s %s connection %s to %s:%s from %s:%s\n",
				 rfctime(&tm), proto, verdict, dst, dpt, src, spt);
		ret += websWrite(wp, "<br>");
	}

	return ret;
}

struct lease_t {
	unsigned char chaddr[16];
	u_int32_t yiaddr;
	u_int32_t expires;
	char hostname[64];
};

/* Dump leases in <tr><td>hostname</td><td>MAC</td><td>IP</td><td>expires</td></tr> format */
static int
ej_dumpleases(int eid, webs_t wp, int argc, char_t **argv)
{
	FILE *fp = NULL;
	struct lease_t lease;
	int i;
	struct in_addr addr;
	unsigned long expires = 0;
	char *interface;
	char sigusr1[] = "-XX";
	int ret = 0;

	if (ejArgs(argc, argv, "%s", &interface) < 1) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	if (!strcmp(interface, "lan")) {
		/* Write out leases file */
		sprintf(sigusr1, "-%d", SIGUSR1);
		eval("killall", sigusr1, "udhcpd");

		if (!(fp = fopen("/tmp/udhcpd.leases", "r")))
			return 0;

		while (fread(&lease, sizeof(lease), 1, fp)) {
			/* Do not display reserved leases */
			if (ETHER_ISNULLADDR(lease.chaddr))
				continue;
			ret += websWrite(wp, "<tr><td>%s</td><td>", lease.hostname);
			for (i = 0; i < 6; i++) {
				ret += websWrite(wp, "%02X", lease.chaddr[i]);
				if (i != 5) ret += websWrite(wp, ":");
			}
			addr.s_addr = lease.yiaddr;
			ret += websWrite(wp, "</td><td>%s</td><td>", inet_ntoa(addr));
			expires = ntohl(lease.expires);
			if (!expires)
				ret += websWrite(wp, "Expired");
			else
				ret += websWrite(wp, "%s", reltime(expires));
			ret += websWrite(wp, "</td></tr>");
		}

		fclose(fp);
	}

	else if (!strcmp(interface, "wan")) {
		ret += websWrite(wp, "<tr><td>%s</td><td>%s</td><td>%s</td><td>",
				 nvram_safe_get("wan_hostname"),
				 nvram_safe_get("wan_hwaddr"),
				 nvram_safe_get("wan_ipaddr"));
		if (nvram_match("wan_proto", "dhcp")) {
			char *tmp;
			time_t now;

			if ((tmp = file2str("/tmp/udhcpc.expires"))) {
				expires = atoi(tmp);
				free(tmp);
			}
			time(&now);
			if (expires <= now)
				ret += websWrite(wp, "Expired");
			else
				ret += websWrite(wp, "%s", reltime(expires - now));
		} else
			ret += websWrite(wp, "Static");
	}

	return ret;
}




#if 0
/* Renew lease */ 
static int
sys_renew(void)
{
	char sigusr1[] = "-XX";

	sprintf(sigusr1, "-%d", SIGUSR1);
	return eval("killall", sigusr1, "udhcpc");
}

/* Release lease */
static int
sys_release(void)
{
	char sigusr2[] = "-XX";

	sprintf(sigusr2, "-%d", SIGUSR2);
	return eval("killall", sigusr2, "udhcpc");
}
#endif




#define sin_addr(s) (((struct sockaddr_in *)(s))->sin_addr)

/* Return WAN link state */
static int
ej_link(int eid, webs_t wp, int argc, char_t **argv)
{
	char *wan_ifname;
	int s;
	struct ifreq ifr;
	struct ethtool_cmd ecmd;

	/* Get real interface name */
	if (nvram_match("wan_proto", "pppoe"))
		wan_ifname = nvram_safe_get("pppoe_ifname");
	else
		wan_ifname = nvram_safe_get("wan_ifname");

	/* Open socket to kernel */
	if ((s = socket(AF_INET, SOCK_DGRAM, 0)) < 0)
		return websWrite(wp, "Unknown");

	/* Check for hardware link */
	strncpy(ifr.ifr_name, wan_ifname, IFNAMSIZ);
	ifr.ifr_data = (void *) &ecmd;
	ecmd.cmd = ETHTOOL_GSET;
	if (ioctl(s, SIOCETHTOOL, &ifr) < 0) {
		close(s);
		return websWrite(wp, "Unknown");
	}
	if (!ecmd.speed) {
		close(s);
		return websWrite(wp, "Disconnected");
	}

	/* Check for valid IP address */
	strncpy(ifr.ifr_name, nvram_safe_get("wan_ifname"), IFNAMSIZ);
	if (ioctl(s, SIOCGIFADDR, &ifr) < 0) {
		close(s);
		return websWrite(wp, "Connecting");
	}

	/* Otherwise we are probably configured */
	close(s);
	return websWrite(wp, "Connected");
}

#elif defined(vxworks)

#include <endLib.h>
#include <time.h>
#include <taskLib.h>
#include <dhcp/dhcp.h>
#include <dhcp/common.h>
#include <dhcp/hash.h>
#include <private/stdioP.h>
extern int sysClkRateGet(void);
extern int restart_firewall(void);
extern void reboot_firewall(void);
extern int sys_upgrade(char *url, FILE *stream, int *total);
extern int get_vxleaseinfo(int *expires);
extern char *vx_pppoelink(void);
extern int vx_dumplog(char *buf, int len, bool first);
extern int http_stats(const char *url);
extern void unlocklog(void);
extern void locklog(void);
extern void dhcpc_release(void);
extern void dhcpc_renew(void);
extern void sys_restart(void);
extern void sys_reboot(void);
extern void tzset(const char *tz);
#define sys_stats(server) http_stats(server)
#define sys_release()	dhcpc_release()
#define sys_renew()		dhcpc_renew()
#define fcntl(fd, cmd, arg) (0)
extern int end_ioctl(char *name, int request, void *buf);
extern int wl_ioctl(char *name, int request, void *buf, int len);

static int
ej_dumpleases(int eid, webs_t wp, int argc, char_t **argv)
{
	extern struct hash_member *bindlist;
	struct hash_member *cur;
	struct dhcp_binding *bp;
	time_t now;
	int i;
	int expires = 0;
	char *interface;
	int ret = 0;

	if (ejArgs(argc, argv, "%s", &interface) < 1) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	if (!strcmp(interface, "lan")) {
		/* Search the DHCP client table */
		for (cur = bindlist, bp = NULL;
		     cur && (bp = (struct dhcp_binding *) cur->data);
		     cur = cur->next) {
			ret += websWrite(wp, "<tr><td>%s</td><td>", bp->res->hostname);
			for (i = 0; i < 6; i++) {
				ret += websWrite(wp, "%02x", (unsigned char) bp->haddr.haddr[i]);
				if (i != 5) ret += websWrite(wp, ":");
			}
			ret += websWrite(wp, "</td><td>%s</td><td>", inet_ntoa(bp->res->ip_addr));
			time(&now);
			if (!bp->res->binding ||
			    bp->res->binding->expire_epoch < now)
				ret += websWrite(wp, "Expired");
			else if (bp->res->binding->expire_epoch == 0xffffffff)
				ret += websWrite(wp, "Static");
			else {
				expires = bp->res->binding->expire_epoch - now;
				ret += websWrite(wp, "%s", reltime(expires));
			}
			ret += websWrite(wp, "</td></tr>");
		}
	}

	else if (!strcmp(interface, "wan")) {
		ret += websWrite(wp, "<tr><td>%s</td><td>%s</td><td>%s</td><td>",
				 nvram_safe_get("wan_hostname"),
				 nvram_safe_get("wan_hwaddr"),
				 nvram_safe_get("wan_ipaddr"));
		if (nvram_match("wan_proto", "dhcp")) {
			/* get lease info */
			if (get_vxleaseinfo(&expires) == ERROR)	{
				websError(wp, 400, "Failed to get lease info\n");
				return -1;
			}

			if (!expires)
				ret += websWrite(wp, "Expired");
			else
				ret += websWrite(wp, "%s", reltime(expires));
		} else
			ret += websWrite(wp, "Static");
	}

	return ret;
}

/* Dump firewall log */
static int
ej_dumplog(int eid, webs_t wp, int argc, char_t **argv)
{
	char buf[255];
	int ret = 0;
	bool first=TRUE;

	locklog();
	while ((ret = vx_dumplog(buf, 255, first)) > 0) {
		ret += websWrite(wp, "%s", buf);
		ret += websWrite(wp, "<br>");
		first=FALSE;
	}
	unlocklog();

	if (ret < 0) 
		websError(wp, 400, "Insufficient memory\n");
	else 
		ret=1;

	return ret;
}

extern int getAssignedAddr(char *ifname, unsigned long *ipaddr, unsigned long *netmask);

static int
ej_link(int eid, webs_t wp, int argc, char_t **argv)
{
	char *wan_hwname = nvram_safe_get("wan_hwname");
	char *wan_ifname = nvram_safe_get("wan_ifname");
	M2_INTERFACETBL mib2Tbl;
	struct in_addr addr, mask;

	/* Check for hardware link */
	if (end_ioctl(wan_hwname, EIOCGMIB2, (caddr_t) &mib2Tbl) == ERROR ||
		mib2Tbl.ifOperStatus & M2_ifOperStatus_down)
		return websWrite(wp, "Unknown");
	if (!mib2Tbl.ifOperStatus || !mib2Tbl.ifSpeed)
		return websWrite(wp, "Disconnected");

	/* PPPoE connection status */
	if (nvram_match("wan_proto", "pppoe"))
		return websWrite(wp, vx_pppoelink());

	/* Check for valid IP address */
	if (getAssignedAddr(wan_ifname, &addr.s_addr, &mask.s_addr) == ERROR)
		return websWrite(wp, "Unknown");

	/* DHCP client assigns a bogus IP address 10.0.[0-15].[0-255]/255.0.0.0 during init) */
	if ((ntohl(addr.s_addr) & 0xfffff000) == 0x0a000000 && ntohl(mask.s_addr) == 0xff000000)
		return websWrite(wp, "Connecting");

	/* Otherwise we are probably configured */
	return websWrite(wp, "Connected");
}

#endif

static char *
rfctime(const time_t *timep)
{
	static char s[201];
	struct tm tm;

#if defined(linux)
	setenv("TZ", nvram_safe_get("time_zone"), 1);
#elif defined(vxworks)
	tzset(nvram_safe_get("time_zone"));
#endif
	memcpy(&tm, localtime(timep), sizeof(struct tm));
	strftime(s, 200, "%a, %d %b %Y %H:%M:%S %z", &tm);
	return s;
}

static char *
reltime(unsigned int seconds)
{
	static char s[] = "XXXXX days, XX hours, XX minutes, XX seconds";
	char *c = s;

	if (seconds > 60*60*24) {
		c += sprintf(c, "%d days, ", seconds / (60*60*24));
		seconds %= 60*60*24;
	}
	if (seconds > 60*60) {
		c += sprintf(c, "%d hours, ", seconds / (60*60));
		seconds %= 60*60;
	}
	if (seconds > 60) {
		c += sprintf(c, "%d minutes, ", seconds / 60);
		seconds %= 60;
	}
	c += sprintf(c, "%d seconds", seconds);

	return s;
}

/* Report time in RFC-822 format */
static int
ej_localtime(int eid, webs_t wp, int argc, char_t **argv)
{
	time_t tm;

	time(&tm);
	return websWrite(wp, rfctime(&tm));
}

/*
 * Example: 
 * lan_ipaddr=192.168.1.1
 * <% nvram_get("lan_ipaddr"); %> produces "192.168.1.1"
 * <% nvram_get("undefined"); %> produces ""
 */
static int
ej_nvram_get(int eid, webs_t wp, int argc, char_t **argv)
{
	char *name, *c;
	int ret = 0;

	if (ejArgs(argc, argv, "%s", &name) < 1) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	if(!strcmp(name, "wl_passphrase"))
	{
			for (c = nvram_safe_get(name); *c; c++) {
	     		if (isprint((int) *c) &&
			    *c != '\'' && *c != '"' && *c != '&' && *c != '<' && *c != '>')
				ret += websWrite(wp, "%c", *c);
			else
				ret += websWrite(wp, "\\%c", *c);
		}
	}
	else
	{	
		for (c = nvram_safe_get(name); *c; c++) {
	     		if (isprint((int) *c) &&
			    *c != '\'' && *c != '"' && *c != '&' && *c != '<' && *c != '>')
				ret += websWrite(wp, "%c", *c);
			else
				ret += websWrite(wp, "&#%d", *c);
		}
	}

	return ret;
}

/*
 * Example: 
 * wan_proto=dhcp
 * <% nvram_match("wan_proto", "dhcp", "selected"); %> produces "selected"
 * <% nvram_match("wan_proto", "static", "selected"); %> does not produce
 */
static int
ej_nvram_match(int eid, webs_t wp, int argc, char_t **argv)
{
	char *name, *match, *output;

	if (ejArgs(argc, argv, "%s %s %s", &name, &match, &output) < 3) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	if (nvram_match(name, match))
		return websWrite(wp, output);

	return 0;
}	

/*
 * Example: 
 * wan_proto=dhcp
 * <% nvram_invmatch("wan_proto", "dhcp", "disabled"); %> does not produce
 * <% nvram_invmatch("wan_proto", "static", "disabled"); %> produces "disabled"
 */
static int
ej_nvram_invmatch(int eid, webs_t wp, int argc, char_t **argv)
{
	char *name, *invmatch, *output;

	if (ejArgs(argc, argv, "%s %s %s", &name, &invmatch, &output) < 3) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	if (nvram_invmatch(name, invmatch))
		return websWrite(wp, output);

	return 0;
}	

/*
 * Example: 
 * filter_maclist=00:12:34:56:78:00 00:87:65:43:21:00
 * <% nvram_list("filter_maclist", 1); %> produces "00:87:65:43:21:00"
 * <% nvram_list("filter_maclist", 100); %> produces ""
 */
static int
ej_nvram_list(int eid, webs_t wp, int argc, char_t **argv)
{
	char *name;
	int which;
	char word[256], *next;

	if (ejArgs(argc, argv, "%s %d", &name, &which) < 2) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	foreach(word, nvram_safe_get(name), next) {
		if (which-- == 0)
			return websWrite(wp, word);
	}

	return 0;
}

static int
ej_options(int eid, webs_t wp, int argc, char_t **argv)
{
	char *name;
	int cur, min, max, step = 1, ret = 0;

	if (ejArgs(argc, argv, "%s %d %d %d", &name, &min, &max, &step) < 3) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	for (cur = atoi(nvram_safe_get(name)); min <= max; min += step) {
		ret += websWrite(wp, "<option value=\"%d\" %s>%d</option>\n",
				 min, min == cur ? "selected" : "", min);
	}

	return ret;
}


/*
 * Example: 
 * <% filter_client(1, 10); %> produces a table of the first 10 client filter entries
 */
//static int
//ej_filter_client(int eid, webs_t wp, int argc, char_t **argv)
//{
//	int i, n, j, ret = 0;
//	netconf_filter_t start, end;
//	bool valid;
//	char port[] = "XXXXX";
//	char *days[] = { "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday" };
//	char *hours[] = {
//		"12:00 AM", "1:00 AM", "2:00 AM", "3:00 AM", "4:00 AM", "5:00 AM",
//		"6:00 AM", "7:00 AM", "8:00 AM", "9:00 AM", "10:00 AM", "11:00 AM",
//		"12:00 PM", "1:00 PM", "2:00 PM", "3:00 PM", "4:00 PM", "5:00 PM",
//		"6:00 PM", "7:00 PM", "8:00 PM", "9:00 PM", "10:00 PM", "11:00 PM"
//	};
//
//	if (ejArgs(argc, argv, "%d %d", &i, &n) < 2) {
//		websError(wp, 400, "Insufficient args\n");
//		return -1;
//	}
//
//	for (; i <= n; i++) {
//		valid = get_filter_client(i, &start, &end);
//
//		ret += websWrite(wp, "<tr>");
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print address range */
//		ret += websWrite(wp, "<td><input name=\"filter_client_from_start%d\" value=\"%s\" size=\"15\" maxlength=\"15\"></td>",
//				 i, valid ? inet_ntoa(start.match.src.ipaddr) : "");
//		ret += websWrite(wp, "<td>-</td>");
//		ret += websWrite(wp, "<td><input name=\"filter_client_from_end%d\" value=\"%s\" size=\"15\" maxlength=\"15\"></td>",
//				 i, valid ? inet_ntoa(end.match.src.ipaddr) : "");
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print protocol */
//		ret += websWrite(wp, "<td>");
//		ret += websWrite(wp, "<select name=\"filter_client_proto%d\">", i);
//		ret += websWrite(wp, "<option value=\"tcp\" %s>TCP</option>",
//				 valid && start.match.ipproto == IPPROTO_TCP ? "selected" : "");
//		ret += websWrite(wp, "<option value=\"udp\" %s>UDP</option>",
//				 valid && start.match.ipproto == IPPROTO_UDP ? "selected" : "");
//		ret += websWrite(wp, "</select>");
//		ret += websWrite(wp, "</td>");
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print port range */
//		if (valid)
//			snprintf(port, sizeof(port), "%d", ntohs(start.match.dst.ports[0]));
//		else
//			*port = '\0';
//		ret += websWrite(wp, "<td><input name=\"filter_client_to_start%d\" value=\"%s\" size=\"5\" maxlength=\"5\"></td>",
//				 i, port);
//		ret += websWrite(wp, "<td>-</td>");
//		if (valid)
//			snprintf(port, sizeof(port), "%d", ntohs(start.match.dst.ports[1]));
//		else
//			*port = '\0';
//		ret += websWrite(wp, "<td><input name=\"filter_client_to_end%d\" value=\"%s\" size=\"5\" maxlength=\"5\"></td>",
//				 i, port);
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print day range */
//		ret += websWrite(wp, "<td>");
//		ret += websWrite(wp, "<select name=\"filter_client_from_day%d\">", i);
//		for (j = 0; j < ARRAYSIZE(days); j++)
//			ret += websWrite(wp, "<option value=\"%d\" %s>%s</option>",
//					 j, valid && start.match.days[0] == j ? "selected" : "", days[j]);
//		ret += websWrite(wp, "</select>");
//		ret += websWrite(wp, "</td>");
//		ret += websWrite(wp, "<td>-</td>");
//		ret += websWrite(wp, "<td>");
//		ret += websWrite(wp, "<select name=\"filter_client_to_day%d\">", i);
//		for (j = 0; j < ARRAYSIZE(days); j++)
//			ret += websWrite(wp, "<option value=\"%d\" %s>%s</option>",
//					 j, valid && start.match.days[1] == j ? "selected" : "", days[j]);
//		ret += websWrite(wp, "</select>");
//		ret += websWrite(wp, "</td>");
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print time range */
//		ret += websWrite(wp, "<td>");
//		ret += websWrite(wp, "<select name=\"filter_client_from_sec%d\">", i);
//		for (j = 0; j < ARRAYSIZE(hours); j++)
//			ret += websWrite(wp, "<option value=\"%d\" %s>%s</option>",
//					 j * 3600, valid && start.match.secs[0] == (j * 3600) ? "selected" : "", hours[j]);
//		ret += websWrite(wp, "</select>");
//		ret += websWrite(wp, "</td>");
//		ret += websWrite(wp, "<td>-</td>");
//
//		ret += websWrite(wp, "<td>");
//		ret += websWrite(wp, "<select name=\"filter_client_to_sec%d\">", i);
//		for (j = 0; j < ARRAYSIZE(hours); j++)
//			ret += websWrite(wp, "<option value=\"%d\" %s>%s</option>",
//					 j * 3600, valid && start.match.secs[1] == (j * 3600) ? "selected" : "", hours[j]);
//		/* Special case for 11:59:59 PM */
//		ret += websWrite(wp, "<option value=\"%d\" %s>12:00 AM</option>",
//				 24 * 3600 - 1, valid && start.match.secs[1] == (24 * 3600 - 1) ? "selected" : "");
//		ret += websWrite(wp, "</select>");
//		ret += websWrite(wp, "</td>");
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print enable */
//		ret += websWrite(wp, "<td><input type=\"checkbox\" name=\"filter_client_enable%d\" %s></td>",
//				 i, valid && !(start.match.flags & NETCONF_DISABLED) ? "checked" : "");
//
//		ret += websWrite(wp, "</tr>");
//	}
//
//	return ret;
//}

/*
 * Example: 
 * <% forward_port(1, 10); %> produces a table of the first 10 port forward entries
 */
//static int
//ej_forward_port(int eid, webs_t wp, int argc, char_t **argv)
//{
//	int i, n, ret = 0;
//	netconf_nat_t nat;
//	bool valid;
//	char port[] = "XXXXX";
//
//	if (ejArgs(argc, argv, "%d %d", &i, &n) < 2) {
//		websError(wp, 400, "Insufficient args\n");
//		return -1;
//	}
//
//	for (; i <= n; i++) {
//		valid = get_forward_port(i, &nat);
//
//		ret += websWrite(wp, "<tr>");
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print protocol */
//		ret += websWrite(wp, "<td>");
//		ret += websWrite(wp, "<select name=\"forward_port_proto%d\">", i);
//		ret += websWrite(wp, "<option value=\"tcp\" %s>TCP</option>",
//				 valid && nat.match.ipproto == IPPROTO_TCP ? "selected" : "");
//		ret += websWrite(wp, "<option value=\"udp\" %s>UDP</option>",
//				 valid && nat.match.ipproto == IPPROTO_UDP ? "selected" : "");
//		ret += websWrite(wp, "</select>");
//		ret += websWrite(wp, "</td>");
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print WAN destination port range */
//		if (valid)
//			snprintf(port, sizeof(port), "%d", ntohs(nat.match.dst.ports[0]));
//		else
//			*port = '\0';
//		ret += websWrite(wp, "<td><input name=\"forward_port_from_start%d\" value=\"%s\" size=\"5\" maxlength=\"5\"></td>",
//				 i, port);
//		ret += websWrite(wp, "<td>-</td>");
//		if (valid)
//			snprintf(port, sizeof(port), "%d", ntohs(nat.match.dst.ports[1]));
//		else
//			*port = '\0';
//		ret += websWrite(wp, "<td><input name=\"forward_port_from_end%d\" value=\"%s\" size=\"5\" maxlength=\"5\"></td>",
//				 i, port);
//		ret += websWrite(wp, "<td>></td>");
//
//		/* Print address range */
//		ret += websWrite(wp, "<td><input name=\"forward_port_to_ip%d\" value=\"%s\" size=\"15\" maxlength=\"15\"></td>",
//				 i, valid ? inet_ntoa(nat.ipaddr) : "");
//		ret += websWrite(wp, "<td>:</td>");
//
//		/* Print LAN destination port range */
//		if (valid)
//			snprintf(port, sizeof(port), "%d", ntohs(nat.ports[0]));
//		else
//			*port = '\0';
//		ret += websWrite(wp, "<td><input name=\"forward_port_to_start%d\" value=\"%s\" size=\"5\" maxlength=\"5\"></td>",
//				 i, port);
//		ret += websWrite(wp, "<td>-</td>");
//		if (valid)
//			snprintf(port, sizeof(port), "%d", ntohs(nat.ports[1]));
//		else
//			*port = '\0';
//		ret += websWrite(wp, "<td><input name=\"forward_port_to_end%d\" value=\"%s\" size=\"5\" maxlength=\"5\"></td>",
//				 i, port);
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print enable */
//		ret += websWrite(wp, "<td><input type=\"checkbox\" name=\"forward_port_enable%d\" %s></td>",
//				 i, valid && !(nat.match.flags & NETCONF_DISABLED) ? "checked" : "");
//
//		ret += websWrite(wp, "</tr>");
//	}
//
//	return ret;
//}
//
//static int
//ej_autofw_port(int eid, webs_t wp, int argc, char_t **argv)
//{
//	int i, n, ret = 0;
//	netconf_app_t app;
//	bool valid;
//	char port[] = "XXXXX";
//
//	if (ejArgs(argc, argv, "%d %d", &i, &n) < 2) {
//		websError(wp, 400, "Insufficient args\n");
//		return -1;
//	}
//
//	for (; i <= n; i++) {
//		valid = get_autofw_port(i, &app);
//
//		/* Parse out_proto:out_port,in_proto:in_start-in_end>to_start-to_end,enable,desc */
//		ret += websWrite(wp, "<tr>");
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print outbound protocol */
//		ret += websWrite(wp, "<td>");
//		ret += websWrite(wp, "<select name=\"autofw_port_out_proto%d\">", i);
//		ret += websWrite(wp, "<option value=\"tcp\" %s>TCP</option>",
//				 valid && app.match.ipproto == IPPROTO_TCP ? "selected" : "");
//		ret += websWrite(wp, "<option value=\"udp\" %s>UDP</option>",
//				 valid && app.match.ipproto == IPPROTO_UDP ? "selected" : "");
//		ret += websWrite(wp, "</select>");
//		ret += websWrite(wp, "</td>");
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print outbound port */
//		if (valid)
//			snprintf(port, sizeof(port), "%d", ntohs(app.match.dst.ports[0]));
//		else
//			*port = '\0';
//		ret += websWrite(wp, "<td><input name=\"autofw_port_out_start%d\" value=\"%s\" size=\"5\" maxlength=\"5\"></td>",
//				 i, port);
//		ret += websWrite(wp, "<td>-</td>");
//		if (valid)
//			snprintf(port, sizeof(port), "%d", ntohs(app.match.dst.ports[1]));
//		else
//			*port = '\0';
//		ret += websWrite(wp, "<td><input name=\"autofw_port_out_end%d\" value=\"%s\" size=\"5\" maxlength=\"5\"></td>",
//				 i, port);
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print related protocol */
//		ret += websWrite(wp, "<td>");
//		ret += websWrite(wp, "<select name=\"autofw_port_in_proto%d\">", i);
//		ret += websWrite(wp, "<option value=\"tcp\" %s>TCP</option>",
//				 valid && app.proto == IPPROTO_TCP ? "selected" : "");
//		ret += websWrite(wp, "<option value=\"udp\" %s>UDP</option>",
//				 valid && app.proto == IPPROTO_UDP ? "selected" : "");
//		ret += websWrite(wp, "</select>");
//		ret += websWrite(wp, "</td>");
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print related destination port range */
//		if (valid)
//			snprintf(port, sizeof(port), "%d", ntohs(app.dport[0]));
//		else
//			*port = '\0';
//		ret += websWrite(wp, "<td><input name=\"autofw_port_in_start%d\" value=\"%s\" size=\"5\" maxlength=\"5\"></td>",
//				 i, port);
//		ret += websWrite(wp, "<td>-</td>");
//		if (valid)
//			snprintf(port, sizeof(port), "%d", ntohs(app.dport[1]));
//		else
//			*port = '\0';
//		ret += websWrite(wp, "<td><input name=\"autofw_port_in_end%d\" value=\"%s\" size=\"5\" maxlength=\"5\"></td>",
//				 i, port);
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print mapped destination port range */
//		if (valid)
//			snprintf(port, sizeof(port), "%d", ntohs(app.to[0]));
//		else
//			*port = '\0';
//		ret += websWrite(wp, "<td><input name=\"autofw_port_to_start%d\" value=\"%s\" size=\"5\" maxlength=\"5\"></td>",
//				 i, port);
//		ret += websWrite(wp, "<td>-</td>");
//		if (valid)
//			snprintf(port, sizeof(port), "%d", ntohs(app.to[1]));
//		else
//			*port = '\0';
//		ret += websWrite(wp, "<td><input name=\"autofw_port_to_end%d\" value=\"%s\" size=\"5\" maxlength=\"5\"></td>",
//				 i, port);
//		ret += websWrite(wp, "<td></td>");
//
//		/* Print enable */
//		ret += websWrite(wp, "<td><input type=\"checkbox\" name=\"autofw_port_enable%d\" %s></td>",
//				 i, valid && !(app.match.flags & NETCONF_DISABLED) ? "checked" : "");
//
//		ret += websWrite(wp, "</tr>");
//	}
//
//	return ret;
//}

/*
 * Example: 
 * static_route=192.168.2.0:255.255.255.0:192.168.1.2:1:br0
 * <% static_route("ipaddr", 0); %> produces "192.168.2.0"
 * <% static_route("lan", 0); %> produces "selected" if nvram_match("lan_ifname", "br0")
 */
static int
ej_static_route(int eid, webs_t wp, int argc, char_t **argv)
{
	char *arg;
	int which;
	char word[256], *next;
	char *ipaddr, *netmask, *gateway, *metric, *ifname;

	if (ejArgs(argc, argv, "%s %d", &arg, &which) < 2) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	foreach(word, nvram_safe_get("static_route"), next) {
		if (which-- == 0) {
			netmask = word;
			ipaddr = strsep(&netmask, ":");
			if (!ipaddr || !netmask)
				continue;
			gateway = netmask;
			netmask = strsep(&gateway, ":");
			if (!netmask || !gateway)
				continue;
			metric = gateway;
			gateway = strsep(&metric, ":");
			if (!gateway || !metric)
				continue;
			ifname = metric;
			metric = strsep(&ifname, ":");
			if (!metric || !ifname)
				continue;
			if (!strcmp(arg, "ipaddr"))
				return websWrite(wp, ipaddr);
			else if (!strcmp(arg, "netmask"))
				return websWrite(wp, netmask);
			else if (!strcmp(arg, "gateway"))
				return websWrite(wp, gateway);
			else if (!strcmp(arg, "metric"))
				return websWrite(wp, metric);
			else if (!strcmp(arg, "lan") && nvram_match("lan_ifname", ifname))
				return websWrite(wp, "selected");
			else if (!strcmp(arg, "wan") && nvram_match("wan_ifname", ifname))
				return websWrite(wp, "selected");
		}
	}

	return 0;
}

/* Return a list of the currently present wireless interfaces */
static int
ej_wl_list(int eid, webs_t wp, int argc, char_t **argv)
{
	char name[IFNAMSIZ], *next;
	int unit, ret = 0;
	char tmp[100], prefix[] = "wlXXXXXXXXXX_";
	char *hwaddr, *ssid;

	foreach(name, nvram_safe_get("lan_ifnames"), next) {
		/* Probe for wl interfaces */
		if (wl_probe(name) ||
		    wl_ioctl(name, WLC_GET_INSTANCE, &unit, sizeof(unit)))
			continue;

		/* Get configured SSID */
		snprintf(prefix, sizeof(prefix), "wl%d_", unit);
		hwaddr = nvram_get(strcat_r(prefix, "hwaddr", tmp));
		ssid = nvram_get(strcat_r(prefix, "ssid", tmp));
		if (!hwaddr || !*hwaddr || !ssid || !*ssid)
			continue;

		ret += websWrite(wp, "<option value=\"%d\" %s>%s (%s)</option>", unit,
				 unit == atoi(nvram_safe_get("wl_unit")) ? "selected" : "",
				 ssid, hwaddr);
	}

	if (!ret)
		ret += websWrite(wp, "<option value=\"-1\" selected>None</option>");

	return ret;
}

/* Return a list of the supported bands on the currently selected wireless interface */
static int
ej_wl_phytypes(int eid, webs_t wp, int argc, char_t **argv)
{
	int unit, ret = 0;
	char tmp[100], prefix[] = "wlXXXXXXXXXX_";
	char *value;
	char *phylist;
	int i;

	if ((unit = atoi(nvram_safe_get("wl_unit"))) < 0)
		return websWrite(wp, "None");

	/* Get available phy types of the currently selected wireless interface */
	snprintf(prefix, sizeof(prefix), "wl%d_", unit);
	phylist = nvram_safe_get(strcat_r(prefix, "phytypes", tmp));

	/* Get configured phy type */
	value = nvram_safe_get("wl_phytype");

	for (i = 0; i < strlen(phylist); i++) {
		ret += websWrite(wp, "<option value=\"%c\" %s>802.11%c (%s GHz)</option>",
				 phylist[i], phylist[i] == *value ? "selected" : "", phylist[i], 
				 phylist[i] == 'a' ? "5" : "2.4");
	}

	return ret;
}

/* Return a radio ID given a phy type */
static int
ej_wl_radioid(int eid, webs_t wp, int argc, char_t **argv)
{
	char *phytype, var[100], *next;
	int unit;
	char tmp[100], prefix[] = "wlXXXXXXXXXX_";
	int which;

	if (ejArgs(argc, argv, "%s", &phytype) < 1) {
		websError(wp, 400, "Insufficient args\n");
		return -1;
	}

	if ((unit = atoi(nvram_safe_get("wl_unit"))) < 0)
		return websWrite(wp, "None");
	snprintf(prefix, sizeof(prefix), "wl%d_", unit);

	which = strcspn(nvram_safe_get(strcat_r(prefix, "phytypes", tmp)), phytype);
	foreach(var, nvram_safe_get(strcat_r(prefix, "radioids", tmp)), next) {
		if (which == 0)
			return websWrite(wp, var);
		which--;
	}

	return websWrite(wp, "None");
}

/* Return current core revision */
static int
ej_wl_corerev(int eid, webs_t wp, int argc, char_t **argv)
{
	int unit;
	char tmp[100], prefix[] = "wlXXXXXXXXXX_";

	if ((unit = atoi(nvram_safe_get("wl_unit"))) < 0)
		return websWrite(wp, "None");
	snprintf(prefix, sizeof(prefix), "wl%d_", unit);

	return websWrite(wp, nvram_safe_get(strcat_r(prefix, "corerev", tmp)));
}

/* Return current wireless channel */
static int
ej_wl_channel(int eid, webs_t wp, int argc, char_t **argv)
{
	int unit, unit2;
	char name[IFNAMSIZ], *next;

	if ((unit2 = atoi(nvram_safe_get("wl_unit"))) < 0)
		return -1;
	foreach(name, nvram_safe_get("lan_ifnames"), next) {
		if (wl_probe(name) == 0 &&
		    wl_ioctl(name, WLC_GET_INSTANCE, &unit, sizeof(unit)) == 0 &&
		    unit == unit2) {
			channel_info_t ci;
			wl_ioctl(name, WLC_GET_CHANNEL, &ci, sizeof(ci));
			return websWrite(wp, "Current: %d", ci.target_channel);
		}
	}
	return -1;
}

struct variable {
	char *name;
	char *longname;
	void (*validate)(webs_t wp, char *value, struct variable *v);
	char **argv;
	int nullok;
};

#define ARGV(args...) ((char *[]) { args, NULL })
#define XSTR(s) STR(s)
#define STR(s) #s

static void
validate_list(webs_t wp, char *value, struct variable *v,
	      int (*valid)(webs_t, char *, struct variable *))
{
	int n, i;
	char name[100];
	char buf[1000] = "", *cur = buf;

	n = atoi(value);

	for (i = 0; i < n; i++) {
		snprintf(name, sizeof(name), "%s%d", v->name, i);
		if (!(value = websGetVar(wp, name, NULL)))
			return;
		if (!*value && v->nullok)
			continue;
		if (!valid(wp, value, v))
			continue;
		cur += snprintf(cur, buf + sizeof(buf) - cur, "%s%s",
				cur == buf ? "" : " ", value);
	}

	nvram_set(v->name, buf);
}	

static int
valid_ipaddr(webs_t wp, char *value, struct variable *v)
{
	unsigned int buf[4];
	struct in_addr ipaddr, netaddr, broadaddr, netmask;

	if (sscanf(value, "%d.%d.%d.%d", &buf[0], &buf[1], &buf[2], &buf[3]) != 4) {
		websWrite(wp, "Invalid <b>%s</b> %s: not an IP address<br>",
			  v->longname, value);
		return FALSE;
	}

	ipaddr.s_addr = htonl((buf[0] << 24) | (buf[1] << 16) | (buf[2] << 8) | buf[3]);

	if (v->argv) {
		(void) inet_aton(nvram_safe_get(v->argv[0]), &netaddr);
		(void) inet_aton(nvram_safe_get(v->argv[1]), &netmask);
		netaddr.s_addr &= netmask.s_addr;
		broadaddr.s_addr = netaddr.s_addr | ~netmask.s_addr;
		if (netaddr.s_addr != (ipaddr.s_addr & netmask.s_addr)) {
			websWrite(wp, "Invalid <b>%s</b> %s: not in the %s/",
				  v->longname, value, inet_ntoa(netaddr));
			websWrite(wp, "%s network<br>", inet_ntoa(netmask));
			return FALSE;
		}
		if (ipaddr.s_addr == netaddr.s_addr) {
			websWrite(wp, "Invalid <b>%s</b> %s: cannot be the network address<br>",
				  v->longname, value);
			return FALSE;
		}
		if (ipaddr.s_addr == broadaddr.s_addr) {
			websWrite(wp, "Invalid <b>%s</b> %s: cannot be the broadcast address<br>",
				  v->longname, value);
			return FALSE;
		}
	}

	return TRUE;
}

static void
validate_ipaddr(webs_t wp, char *value, struct variable *v)
{
	if (valid_ipaddr(wp, value, v))
		nvram_set(v->name, value);
}

static void
validate_ipaddrs(webs_t wp, char *value, struct variable *v)
{
	validate_list(wp, value, v, valid_ipaddr);
}

static int
valid_choice(webs_t wp, char *value, struct variable *v)
{
	char **choice;

	for (choice = v->argv; *choice; choice++) {
		if (!strcmp(value, *choice))
			return TRUE;
	}

	websWrite(wp, "Invalid <b>%s</b> %s: not one of ", v->longname, value);
	for (choice = v->argv; *choice; choice++)
		websWrite(wp, "%s%s", choice == v->argv ? "" : "/", *choice);
	websWrite(wp, "<br>");
	return FALSE;
}

static void
validate_choice(webs_t wp, char *value, struct variable *v)
{
	if (valid_choice(wp, value, v))
		nvram_set(v->name, value);
}

static int
valid_range(webs_t wp, char *value, struct variable *v)
{
	int n, start, end;

	n = atoi(value);
	start = atoi(v->argv[0]);
	end = atoi(v->argv[1]);

	if (n < start || n > end) {
		websWrite(wp, "Invalid <b>%s</b> %s: out of range %d-%d<br>",
			  v->longname, value, start, end);
		return FALSE;
	}

	return TRUE;
}

static void
validate_range(webs_t wp, char *value, struct variable *v)
{
	if (valid_range(wp, value, v))
		nvram_set(v->name, value);
}

static int
valid_name(webs_t wp, char *value, struct variable *v)
{
	int n, min, max;

	n = strlen(value);
	min = atoi(v->argv[0]);
	max = atoi(v->argv[1]);

	if (n > max) {
		websWrite(wp, "Invalid <b>%s</b> %s: longer than %d characters<br>",
			  v->longname, value, max);
		return FALSE;
	}
	else if (n < min) {
		websWrite(wp, "Invalid <b>%s</b> %s: shorter than %d characters<br>",
			  v->longname, value, min);
		return FALSE;
	}

	return TRUE;
}

static void
validate_name(webs_t wp, char *value, struct variable *v)
{
	if (valid_name(wp, value, v))
		nvram_set(v->name, value);
}

static int
valid_hwaddr(webs_t wp, char *value, struct variable *v)
{
	unsigned char hwaddr[6];

	/* Make exception for "NOT IMPLELEMENTED" string */
	if (!strcmp(value,"NOT_IMPLEMENTED")) 
		return(TRUE);

	/* Check for bad, multicast, broadcast, or null address */
	if (!ether_atoe(value, hwaddr) ||
	    (hwaddr[0] & 1) ||
	    (hwaddr[0] & hwaddr[1] & hwaddr[2] & hwaddr[3] & hwaddr[4] & hwaddr[5]) == 0xff ||
	    (hwaddr[0] | hwaddr[1] | hwaddr[2] | hwaddr[3] | hwaddr[4] | hwaddr[5]) == 0x00) {
		websWrite(wp, "Invalid <b>%s</b> %s: not a MAC address<br>",
			  v->longname, value);
		return FALSE;
	}

	return TRUE;
}

static void
validate_hwaddr(webs_t wp, char *value, struct variable *v)
{
	if (valid_hwaddr(wp, value, v))
		nvram_set(v->name, value);
}

static void
validate_hwaddrs(webs_t wp, char *value, struct variable *v)
{
	validate_list(wp, value, v, valid_hwaddr);
}

static void
validate_dhcp(webs_t wp, char *value, struct variable *v)
{
	struct variable dhcp_variables[] = {
		{ longname: "DHCP Server Starting LAN IP Address", argv: ARGV("lan_ipaddr", "lan_netmask") },
		{ longname: "DHCP Server Ending LAN IP Address", argv: ARGV("lan_ipaddr", "lan_netmask") },
	};
	char *start, *end;

	if (!(start = websGetVar(wp, "dhcp_start", NULL)) ||
	    !(end = websGetVar(wp, "dhcp_end", NULL)))
		return;
	if (!*start) start = end;
	if (!*end) end = start;
	if (!*start && !*end && !strcmp(nvram_safe_get("lan_proto"), "dhcp")) {
		websWrite(wp, "Invalid <b>%s</b>: must specify a range<br>", v->longname);
		return;
	}
	if (!valid_ipaddr(wp, start, &dhcp_variables[0]) ||
	    !valid_ipaddr(wp, end, &dhcp_variables[1]))
		return;
	if (ntohl(inet_addr(start)) > ntohl(inet_addr(end))) {
		websWrite(wp, "Invalid <b>%s</b> %s: greater than <b>%s</b> %s<br>",
			  dhcp_variables[0].longname, start, dhcp_variables[1].longname, end);
		return;
	}

	nvram_set("dhcp_start", start);
	nvram_set("dhcp_end", end);
}

//static void
//validate_lan_ipaddr(webs_t wp, char *value, struct variable *v)
//{
//	struct variable fields[] = {
//		{ name: "lan_ipaddr", longname: "LAN IP Address" },
//		{ name: "lan_netmask", longname: "LAN Subnet Mask" },
//	};
//	char *lan_ipaddr, *lan_netmask;
//	struct in_addr ipaddr, netmask, netaddr, broadaddr;
//	char *lan_ipaddrs[] = { "dhcp_start", "dhcp_end", "dmz_ipaddr" };
//	netconf_filter_t start, end;
//	netconf_nat_t nat;
//	bool valid;
//	int i;
//
//	/* Basic validation */
//	if (!(lan_ipaddr = websGetVar(wp, fields[0].name, NULL)) ||
//	    !(lan_netmask = websGetVar(wp, fields[1].name, NULL)) ||
//	    !valid_ipaddr(wp, lan_ipaddr, &fields[0]) ||
//	    !valid_ipaddr(wp, lan_netmask, &fields[1]))
//		return;
//
//	/* Check for broadcast or network address */
//	(void) inet_aton(lan_ipaddr, &ipaddr);
//	(void) inet_aton(lan_netmask, &netmask);
//	netaddr.s_addr = ipaddr.s_addr & netmask.s_addr;
//	broadaddr.s_addr = netaddr.s_addr | ~netmask.s_addr;
//	if (ipaddr.s_addr == netaddr.s_addr) {
//		websWrite(wp, "Invalid <b>%s</b> %s: cannot be the network address<br>",
//			  fields[0].longname, lan_ipaddr);
//		return;
//	}
//	if (ipaddr.s_addr == broadaddr.s_addr) {
//		websWrite(wp, "Invalid <b>%s</b> %s: cannot be the broadcast address<br>",
//			  fields[0].longname, lan_ipaddr);
//		return;
//	}
//
//	nvram_set("lan_ipaddr", lan_ipaddr);
//	nvram_set("lan_netmask", lan_netmask);
//
//	/* Fix up LAN IP addresses */
//	for (i = 0; i < ARRAYSIZE(lan_ipaddrs); i++) {
//		value = nvram_get(lan_ipaddrs[i]);
//		if (value && *value) {
//			(void) inet_aton(value, &ipaddr);
//			ipaddr.s_addr &= ~netmask.s_addr;
//			ipaddr.s_addr |= netaddr.s_addr;
//			nvram_set(lan_ipaddrs[i], inet_ntoa(ipaddr));
//		}
//	}				
//
//	/* Fix up client filters and port forwards */
//	for (i = 0; i < MAX_NVPARSE; i++) {
//		if (get_filter_client(i, &start, &end)) {
//			start.match.src.ipaddr.s_addr &= ~netmask.s_addr;
//			start.match.src.ipaddr.s_addr |= netaddr.s_addr;
//			end.match.src.ipaddr.s_addr &= ~netmask.s_addr;
//			end.match.src.ipaddr.s_addr |= netaddr.s_addr;
//			valid = set_filter_client(i, &start, &end);
//			a_assert(valid);
//		}
//		if (get_forward_port(i, &nat)) {
//			nat.ipaddr.s_addr &= ~netmask.s_addr;
//			nat.ipaddr.s_addr |= netaddr.s_addr;
//			valid = set_forward_port(i, &nat);
//			a_assert(valid);
//		}
//	}
//}	

//static void
//validate_filter_client(webs_t wp, char *value, struct variable *v)
//{
//	int n, i, j;
//	bool valid;
//	struct variable fields[] = {
//		{ name: "filter_client_from_start%d", longname: "LAN Client Filter Starting IP Address", argv: ARGV("lan_ipaddr", "lan_netmask") },
//		{ name: "filter_client_from_end%d", longname: "LAN Client Filter Ending IP Address", argv: ARGV("lan_ipaddr", "lan_netmask") },
//		{ name: "filter_client_proto%d", longname: "LAN Client Filter Protocol", argv: ARGV("tcp", "udp") },
//		{ name: "filter_client_to_start%d", longname: "LAN Client Filter Starting Destination Port", argv: ARGV("0", "65535") },
//		{ name: "filter_client_to_end%d", longname: "LAN Client Filter Ending Destination Port", argv: ARGV("0", "65535") },
//		{ name: "filter_client_from_day%d", longname: "LAN Client Filter Starting Day", argv: ARGV("0", "6") },
//		{ name: "filter_client_to_day%d", longname: "LAN Client Filter Ending Day", argv: ARGV("0", "6") },
//		{ name: "filter_client_from_sec%d", longname: "LAN Client Filter Starting Second", argv: ARGV("0", "86400") },
//		{ name: "filter_client_to_sec%d", longname: "LAN Client Filter Ending Second", argv: ARGV("0", "86400") },
//	};
//	char *from_start, *from_end, *proto, *to_start, *to_end, *from_day, *to_day, *from_sec, *to_sec, *enable;
//	char **locals[] = { &from_start, &from_end, &proto, &to_start, &to_end, &from_day, &to_day, &from_sec, &to_sec };
//	char name[1000];
//	netconf_filter_t start, end;
//
//	/* filter_client indicates how many to expect */
//	if (!valid_range(wp, value, v))
//		return;
//	n = atoi(value);
//
//	for (i = 0; i <= n; i++) {
//		/* Set up field names */
//		for (j = 0; j < ARRAYSIZE(fields); j++) {
//			snprintf(name, sizeof(name), fields[j].name, i);
//			if (!(*locals[j] = websGetVar(wp, name, NULL)))
//				break;
//		}
//		/* Incomplete web page */
//		if (j < ARRAYSIZE(fields))
//			continue;
//		/* Enable is a checkbox */
//		snprintf(name, sizeof(name), "filter_client_enable%d", i);
//		if (websGetVar(wp, name, NULL))
//			enable = "on";
//		else
//			enable = "off";
//		/* Delete entry if all fields are blank */
//		if (!*from_start && !*from_end && !*to_start && !*to_end) {
//			del_filter_client(i);
//			continue;
//		}
//		/* Fill in empty fields with default values */
//		if (!*from_start) from_start = from_end;
//		if (!*from_end) from_end = from_start;
//		if (!*to_start) to_start = to_end;
//		if (!*to_end) to_end = to_start;
//		if (!*from_start || !*from_end) {
//			websWrite(wp, "Invalid <b>%s</b>: must specify a LAN IP Address Range<br>", v->longname);
//			continue;
//		}
//		if (!*to_start || !*to_end) {
//			websWrite(wp, "Invalid <b>%s</b>: must specify a Destination Port Range<br>", v->longname);
//			continue;
//		}
//		/* Check individual fields */
//		if (!valid_ipaddr(wp, from_start, &fields[0]) ||
//		    !valid_ipaddr(wp, from_end, &fields[1]) ||
//		    !valid_choice(wp, proto, &fields[2]) ||
//		    !valid_range(wp, to_start, &fields[3]) ||
//		    !valid_range(wp, to_end, &fields[4]) ||
//		    !valid_range(wp, from_day, &fields[5]) ||
//		    !valid_range(wp, to_day, &fields[6]) ||
//		    !valid_range(wp, from_sec, &fields[7]) ||
//		    !valid_range(wp, to_sec, &fields[8]))
//			continue;
//		/* Check dependencies between fields */
//		if (ntohl(inet_addr(from_start)) > ntohl(inet_addr(from_end))) {
//			websWrite(wp, "Invalid <b>%s</b> %s: greater than <b>%s</b> %s<br>",
//				  fields[0].longname, from_start, fields[1].longname, from_end);
//			continue;
//		}
//		if (atoi(to_start) > atoi(to_end)) {
//			websWrite(wp, "Invalid <b>%s</b> %s: greater than <b>%s</b> %s<br>",
//				  fields[3].longname, to_start, fields[4].longname, to_end);
//			continue;
//		}
//
//		/* Set up parameters */
//		memset(&start, 0, sizeof(netconf_filter_t));
//		if (!strcmp(proto, "tcp"))
//			start.match.ipproto = IPPROTO_TCP;
//		else if (!strcmp(proto, "udp"))
//			start.match.ipproto = IPPROTO_UDP;
//		(void) inet_aton(from_start, &start.match.src.ipaddr);
//		start.match.src.netmask.s_addr = htonl(0xffffffff);
//		start.match.dst.ports[0] = htons(atoi(to_start));
//		start.match.dst.ports[1] = htons(atoi(to_end));
//		start.match.days[0] = atoi(from_day);
//		start.match.days[1] = atoi(to_day);
//		start.match.secs[0] = atoi(from_sec);
//		start.match.secs[1] = atoi(to_sec);
//		if (!strcmp(enable, "off"))
//			start.match.flags |= NETCONF_DISABLED;
//		memcpy(&end, &start, sizeof(netconf_filter_t));
//		(void) inet_aton(from_end, &end.match.src.ipaddr);
//
//		/* Do it */
//		valid = set_filter_client(i, &start, &end);
//		a_assert(valid);
//	}
//}
//
//static void
//validate_forward_port(webs_t wp, char *value, struct variable *v)
//{
//	int n, i, j;
//	bool valid;
//	struct variable fields[] = {
//		{ name: "forward_port_proto%d", longname: "Port Forward Protocol", argv: ARGV("tcp", "udp") },
//		{ name: "forward_port_from_start%d", longname: "Port Forward Starting WAN Port", argv: ARGV("0", "65535") },
//		{ name: "forward_port_from_end%d", longname: "Port Forward Ending WAN Port", argv: ARGV("0", "65535") },
//		{ name: "forward_port_to_ip%d", longname: "Port Forward LAN IP Address", argv: ARGV("lan_ipaddr", "lan_netmask") },
//		{ name: "forward_port_to_start%d", longname: "Port Forward Starting LAN Port", argv: ARGV("0", "65535") },
//		{ name: "forward_port_to_end%d", longname: "Port Forward Ending LAN Port", argv: ARGV("0", "65535") },
//	};
//	char *proto, *from_start, *from_end, *to_ip, *to_start, *to_end, *enable;
//	char **locals[] = { &proto, &from_start, &from_end, &to_ip, &to_start, &to_end };
//	char name[1000];
//	netconf_nat_t nat;
//
//	/* forward_port indicates how many to expect */
//	if (!valid_range(wp, value, v))
//		return;
//	n = atoi(value);
//
//	for (i = 0; i <= n; i++) {
//		/* Set up field names */
//		for (j = 0; j < ARRAYSIZE(fields); j++) {
//			snprintf(name, sizeof(name), fields[j].name, i);
//			if (!(*locals[j] = websGetVar(wp, name, NULL)))
//				break;
//		}
//		/* Incomplete web page */
//		if (j < ARRAYSIZE(fields))
//			continue;
//		/* Enable is a checkbox */
//		snprintf(name, sizeof(name), "forward_port_enable%d", i);
//		if (websGetVar(wp, name, NULL))
//			enable = "on";
//		else
//			enable = "off";
//		/* Delete entry if all fields are blank */
//		if (!*from_start && !*from_end && !*to_ip && !*to_start && !*to_end) {
//			del_forward_port(i);
//			continue;
//		}
//		/* Fill in empty fields with default values */
//		if (!*from_start) from_start = from_end;
//		if (!*from_end) from_end = from_start;
//		if (!*to_start && !*to_end)
//			to_start = from_start;
//		if (!*to_start) to_start = to_end;
//		if (!*to_end) to_end = to_start;
//		if (!*from_start || !*from_end) {
//			websWrite(wp, "Invalid <b>%s</b>: must specify a LAN IP Address Range<br>", v->longname);
//			continue;
//		}
//		if (!*to_ip) {
//			websWrite(wp, "Invalid <b>%s</b>: must specify a LAN IP Address<br>", v->longname);
//			continue;
//		}
//		if (!*to_start || !*to_end) {
//			websWrite(wp, "Invalid <b>%s</b>: must specify a Destination Port Range<br>", v->longname);
//			continue;
//		}
//		/* Check individual fields */
//		if (!valid_choice(wp, proto, &fields[0]) ||
//		    !valid_range(wp, from_start, &fields[1]) ||
//		    !valid_range(wp, from_end, &fields[2]) ||
//		    !valid_ipaddr(wp, to_ip, &fields[3]) ||
//		    !valid_range(wp, to_start, &fields[4]) ||
//		    !valid_range(wp, to_end, &fields[5]))
//			continue;
//		if (atoi(from_start) > atoi(from_end)) {
//			websWrite(wp, "Invalid <b>%s</b> %s: greater than <b>%s</b> %s<br>",
//				  fields[1].longname, from_start, fields[2].longname, from_end);
//			continue;
//		}
//		if (atoi(to_start) > atoi(to_end)) {
//			websWrite(wp, "Invalid <b>%s</b> %s: greater than <b>%s</b> %s<br>",
//				  fields[4].longname, to_start, fields[5].longname, to_end);
//			continue;
//		}
//		if ((atoi(from_end) - atoi(from_start)) != (atoi(to_end) - atoi(to_start))) {
//			websWrite(wp, "Invalid <b>%s</b>: WAN Port Range and LAN Port Range must be the same size<br>", v->longname);
//			continue;
//		}
//
//		/* Set up parameters */
//		memset(&nat, 0, sizeof(netconf_nat_t));
//		if (!strcmp(proto, "tcp"))
//			nat.match.ipproto = IPPROTO_TCP;
//		else if (!strcmp(proto, "udp"))
//			nat.match.ipproto = IPPROTO_UDP;
//		nat.match.dst.ports[0] = htons(atoi(from_start));
//		nat.match.dst.ports[1] = htons(atoi(from_end));
//		(void) inet_aton(to_ip, &nat.ipaddr);
//		nat.ports[0] = htons(atoi(to_start));
//		nat.ports[1] = htons(atoi(to_end));
//		if (!strcmp(enable, "off"))
//			nat.match.flags |= NETCONF_DISABLED;
//
//		/* Do it */
//		valid = set_forward_port(i, &nat);
//		a_assert(valid);
//	}
//}
//
//static void
//validate_autofw_port(webs_t wp, char *value, struct variable *v)
//{
//	int n, i, j;
//	bool valid;
//	struct variable fields[] = {
//		{ name: "autofw_port_out_proto%d", longname: "Outbound Protocol", argv: ARGV("tcp", "udp") },
//		{ name: "autofw_port_out_start%d", longname: "Outbound Port Start", argv: ARGV("0", "65535") },
//		{ name: "autofw_port_out_end%d", longname: "Outbound Port End", argv: ARGV("0", "65535") },
//		{ name: "autofw_port_in_proto%d", longname: "Inbound Protocol", argv: ARGV("tcp", "udp") },
//		{ name: "autofw_port_in_start%d", longname: "Inbound Port Start", argv: ARGV("0", "65535") },
//		{ name: "autofw_port_in_end%d", longname: "Inbound Port End", argv: ARGV("0", "65535") },
// 		{ name: "autofw_port_to_start%d", longname: "To Port Start", argv: ARGV("0", "65535") },
// 		{ name: "autofw_port_to_end%d", longname: "To Port End", argv: ARGV("0", "65535") },
//	};
//	char *out_proto, *out_start, *out_end, *in_proto, *in_start, *in_end, *to_start, *to_end, *enable;
//	char **locals[] = { &out_proto, &out_start, &out_end, &in_proto, &in_start, &in_end, &to_start, &to_end };
//	char name[1000];
//	netconf_app_t app;
//
//	/* autofw_port indicates how many to expect */
//	if (!valid_range(wp, value, v))
//		return;
//	n = atoi(value);
//
//	for (i = 0; i <= n; i++) {
//		/* Set up field names */
//		for (j = 0; j < ARRAYSIZE(fields); j++) {
//			snprintf(name, sizeof(name), fields[j].name, i);
//			if (!(*locals[j] = websGetVar(wp, name, NULL)))
//				break;
//		}
//		/* Incomplete web page */
//		if (j < ARRAYSIZE(fields))
//			continue;
//		/* Enable is a checkbox */
//		snprintf(name, sizeof(name), "autofw_port_enable%d", i);
//		if (websGetVar(wp, name, NULL))
//			enable = "on";
//		else
//			enable = "off";
//		/* Delete entry if all fields are blank */
//		if (!*out_start && !*out_end && !*in_start && !*in_end && !*to_start && !*to_end) {
//			del_autofw_port(i);
//			continue;
//		}
//		/* Fill in empty fields with default values */
//		if (!*out_start) out_start = out_end;
//		if (!*out_end) out_end = out_start;
//		if (!*in_start) in_start = in_end;
//		if (!*in_end) in_end = in_start;
//		if (!*to_start && !*to_end)
//			to_start = in_start;
//		if (!*to_start) to_start = to_end;
//		if (!*to_end) to_end = to_start;
//		if (!*out_start || !*out_end) {
//			websWrite(wp, "Invalid <b>%s</b>: must specify an Outbound Port Range<br>", v->longname);
//			continue;
//		}
//		if (!*in_start || !*in_end) {
//			websWrite(wp, "Invalid <b>%s</b>: must specify an Inbound Port Range<br>", v->longname);
//			continue;
//		}
//		if (!*to_start || !*to_end) {
//			websWrite(wp, "Invalid <b>%s</b>: must specify a To Port Range<br>", v->longname);
//			continue;
//		}
//		/* Check individual fields */
//		if (!valid_choice(wp, out_proto, &fields[0]) ||
//		    !valid_range(wp, out_start, &fields[1]) ||
//		    !valid_range(wp, out_end, &fields[2]) ||
//		    !valid_choice(wp, in_proto, &fields[3]) ||
//		    !valid_range(wp, in_start, &fields[4]) ||
//		    !valid_range(wp, in_end, &fields[5]) ||
//		    !valid_range(wp, to_start, &fields[6]) ||
//		    !valid_range(wp, to_end, &fields[7]))
//			continue;
//		/* Check dependencies between fields */
//		if (atoi(out_start) > atoi(out_end)) {
//			websWrite(wp, "Invalid <b>%s</b> %s: greater than <b>%s</b> %s<br>",
//				  fields[1].longname, out_start, fields[2].longname, out_end);
//			continue;
//		}
//		if (atoi(in_start) > atoi(in_end)) {
//			websWrite(wp, "Invalid <b>%s</b> %s: greater than <b>%s</b> %s<br>",
//				  fields[4].longname, in_start, fields[5].longname, in_end);
//			continue;
//		}
//		if (atoi(to_start) > atoi(to_end)) {
//			websWrite(wp, "Invalid <b>%s</b> %s: greater than <b>%s</b> %s<br>",
//				  fields[6].longname, in_start, fields[7].longname, in_end);
//			continue;
//		}
//		if ((atoi(in_end) - atoi(in_start)) != (atoi(to_end) - atoi(to_start))) {
//			websWrite(wp, "Invalid <b>%s</b>: Inbound Port Range and To Port Range must be the same size<br>", v->longname);
//			continue;
//		}
//
//		/* Set up parameters */
//		memset(&app, 0, sizeof(netconf_app_t));
//		if (!strcmp(out_proto, "tcp"))
//			app.match.ipproto = IPPROTO_TCP;
//		else if (!strcmp(out_proto, "udp"))
//			app.match.ipproto = IPPROTO_UDP;
//		app.match.dst.ports[0] = htons(atoi(out_start));
//		app.match.dst.ports[1] = htons(atoi(out_end));
//		if (!strcmp(in_proto, "tcp"))
//			app.proto = IPPROTO_TCP;
//		else if (!strcmp(in_proto, "udp"))
//			app.proto = IPPROTO_UDP;
//		app.dport[0] = htons(atoi(in_start));
//		app.dport[1] = htons(atoi(in_end));
//		app.to[0] = htons(atoi(to_start));
//		app.to[1] = htons(atoi(to_end));
//		if (!strcmp(enable, "off"))
//			app.match.flags |= NETCONF_DISABLED;
//
//		/* Do it */
//		valid = set_autofw_port(i, &app);
//		a_assert(valid);
//	}
//}

static void
validate_static_route(webs_t wp, char *value, struct variable *v)
{
	int n, i;
	char buf[1000] = "", *cur = buf;
	struct variable static_route_variables[] = {
		{ longname: "Route IP Address", argv: NULL },
		{ longname: "Route Subnet Mask", argv: NULL },
		{ longname: "Route Gateway", argv: NULL },
		{ longname: "Route Metric", argv: ARGV("0", "15") },
		{ longname: "Route Interface", argv: ARGV("lan", "wan") },
	};

	n = atoi(value);

	for (i = 0; i < n; i++) {
		char static_route_ipaddr[] = "static_route_ipaddrXXX";
		char static_route_netmask[] = "static_route_netmaskXXX";
		char static_route_gateway[] = "static_route_gatewayXXX";
		char static_route_metric[] = "static_route_metricXXX";
		char static_route_ifname[] = "static_route_ifnameXXX";
		char *ipaddr, *netmask, *gateway, *metric, *ifname;

 		snprintf(static_route_ipaddr, sizeof(static_route_ipaddr), "%s_ipaddr%d", v->name, i);
		snprintf(static_route_netmask, sizeof(static_route_netmask), "%s_netmask%d", v->name, i);
 		snprintf(static_route_gateway, sizeof(static_route_gateway), "%s_gateway%d", v->name, i);
 		snprintf(static_route_metric, sizeof(static_route_metric), "%s_metric%d", v->name, i);
		snprintf(static_route_ifname, sizeof(static_route_ifname), "%s_ifname%d", v->name, i);
		if (!(ipaddr = websGetVar(wp, static_route_ipaddr, NULL)) ||
		    !(netmask = websGetVar(wp, static_route_netmask, NULL)) ||
		    !(gateway = websGetVar(wp, static_route_gateway, NULL)) ||
		    !(metric = websGetVar(wp, static_route_metric, NULL)) ||
		    !(ifname = websGetVar(wp, static_route_ifname, NULL)))
			return;
		if (!*ipaddr && !*netmask && !*gateway && !*metric)
			continue;
		if (!*ipaddr && !*netmask && *gateway) {
			ipaddr = "0.0.0.0";
			netmask = "0.0.0.0";
		}
		if (!*gateway)
			gateway = "0.0.0.0";
		if (!*metric)
			metric = "0";
		if (!valid_choice(wp, ifname, &static_route_variables[4]))
			continue;
		if (!*ipaddr) {
			websWrite(wp, "Invalid <b>%s</b>: must specify an IP Address<br>", v->longname);
			continue;
		}
		if (!*netmask) {
			websWrite(wp, "Invalid <b>%s</b>: must specify a Subnet Mask<br>", v->longname);
			continue;
		}
		if (!strcmp(ifname, "lan")) {
			ifname = nvram_safe_get("lan_ifname");
			static_route_variables[2].argv = ARGV("lan_ipaddr", "lan_netmask");
		} else {
			ifname = nvram_safe_get("wan_ifname");
			static_route_variables[2].argv = NULL;
		}
		if (!valid_ipaddr(wp, ipaddr, &static_route_variables[0]) ||
		    !valid_ipaddr(wp, netmask, &static_route_variables[1]) ||
		    !valid_ipaddr(wp, gateway, &static_route_variables[2]) ||
		    !valid_range(wp, metric, &static_route_variables[3]))
			continue;
		cur += snprintf(cur, buf + sizeof(buf) - cur, "%s%s:%s:%s:%s:%s",
				cur == buf ? "" : " ", ipaddr, netmask, gateway, metric, ifname);
	}

	nvram_set(v->name, buf);
}

static void
validate_auth_mode(webs_t wp, char *value, struct variable *v)
{
	if (!valid_choice(wp, value, v))
		return;

	if (!strcmp(value, "radius") || !strcmp(value, "wpa")) {
		if (nvram_match("wl_radius_ipaddr", "")) {
			websWrite(wp, "Invalid <b>%s</b>: must first specify a valid <b>RADIUS Server</b><br>", v->longname);
			return;
		}
	}

	if (!strcmp(value, "psk")) {
		if (nvram_match("wl_wpa_psk", "")) {
			websWrite(wp, "Invalid <b>%s</b>: must first specify a valid <b>WPA Pre-Shared Key</b><br>", v->longname);
			return;
		}
	} 

	if (!strcmp(value, "wpa") || !strcmp(value, "psk")) {
		if (!nvram_match("wl_wep", "tkip") && !nvram_match("wl_wep", "aes") &&
		    !nvram_match("wl_wep", "tkip+aes")) {
			websWrite(wp, "Invalid <b>%s</b>: <b>Data Encryption</b> mode must be TKIP or AES or TKIP+AES<br>", v->longname);
			return;
		}
		nvram_set("wl_auth", "0");
	} else {
		if (!nvram_match("wl_wep", "off") && !nvram_match("wl_wep", "wep")) {
			websWrite(wp, "Invalid <b>%s</b>: <b>Data Encryption</b> mode must be Off or WEP<br>", v->longname);
			return;
		}
	}			

	nvram_set(v->name, value);
}

static void
validate_wpa_psk(webs_t wp, char *value, struct variable *v)
{
	int len = strlen(value);
	char *c;

	if (len == 64) {
		for (c = value; *c; c++) {
			if (!isxdigit((int) *c)) {
				websWrite(wp, "Invalid <b>%s</b>: character %c is not a hexadecimal digit<br>", v->longname, *c);
				return;
			}
		}
	} else if (len < 8 || len > 63) {
		websWrite(wp, "Invalid <b>%s</b>: must be between 8 and 63 ASCII characters or 64 hexadecimal digits<br>", v->longname);
		return;
	}

	nvram_set(v->name, value);
}

static void
validate_wl_key(webs_t wp, char *value, struct variable *v)
{
	char *c;

	switch (strlen(value)) {
	case 5:
	case 13:			
		break;
	case 10:
	case 26:
		for (c = value; *c; c++) {
			if (!isxdigit((int) *c)) {
				websWrite(wp, "Invalid <b>%s</b>: character %c is not a hexadecimal digit<br>", v->longname, *c);
				return;
			}
		}
		break;
	default:
		websWrite(wp, "Invalid <b>%s</b>: must be 5 or 13 ASCII characters or 10 or 26 hexadecimal digits<br>", v->longname);
		return;
	}

	nvram_set(v->name, value);
}

static void
validate_wl_wep(webs_t wp, char *value, struct variable *v)
{
	if (!valid_choice(wp, value, v))
		return;

	if (!strcmp(value, "wep") || !strcmp(value, "on") || !strcmp(value, "restricted")) {
		char wl_key[] = "wl_keyXXX";

		snprintf(wl_key, sizeof(wl_key), "wl_key%s", nvram_safe_get("wl_key"));
		if (!strlen(nvram_safe_get(wl_key))) {
			websWrite(wp, "Invalid <b>%s</b>: must first specify a valid <b>Network Key</b><br>", v->longname);
			return;
		}
	}

	nvram_set(v->name, value);
}

static void
validate_wl_auth(webs_t wp, char *value, struct variable *v)
{
	if (!valid_choice(wp, value, v))
		return;

	if (atoi(value) == 1) {
		char wl_key[] = "wl_keyXXX";

		snprintf(wl_key, sizeof(wl_key), "wl_key%s", nvram_safe_get("wl_key"));
		if (!strlen(nvram_safe_get(wl_key))) {
			websWrite(wp, "Invalid <b>%s</b>: must first specify a valid <b>Network Key</b><br>", v->longname);
			return;
		}
	}

	nvram_set(v->name, value);
}

struct variable variables[];

/* Hook to write wl_* default set through to wl%d_* variable set */
static void
wl_unit(webs_t wp, char *value, struct variable *v)
{
	char tmp[100], prefix[] = "wlXXXXXXXXXX_";

	/* Do not write through if no interfaces are present */
	if (atoi(value) < 0)
		return;

	/* Set prefix */
	snprintf(prefix, sizeof(prefix), "wl%d_", atoi(value));

	/* Write through to selected variable set */
	for (; v >= variables && !strncmp(v->name, "wl_", 3); v--)
		nvram_set(strcat_r(prefix, &v->name[3], tmp), nvram_safe_get(v->name));
}

/* 
 * Variables are set in order (put dependent variables later). Set
 * nullok to TRUE to ignore zero-length values of the variable itself.
 * For more complicated validation that cannot be done in one pass or
 * depends on additional form components or can throw an error in a
 * unique painful way, write your own validation routine and assign it
 * to a hidden variable (e.g. filter_ip).
 */
struct variable variables[] = {
	{ "lan_hwaddr", "LAN MAC Address", validate_hwaddr, NULL, TRUE },
	{ "wan_hwaddr", "WAN MAC Address", validate_hwaddr, NULL, TRUE },	
	{ "et0macaddr", "LAN MAC Address", validate_hwaddr, NULL, TRUE },
	{ "et1macaddr", "WAN MAC Address", validate_hwaddr, NULL, TRUE },
	{ "lan_ipaddr", "LAN IP Address", NULL, NULL, FALSE },
	{ "lan_proto", "LAN Protocol", validate_choice, ARGV("dhcp", "static"), FALSE },
	{ "lan_stp", "Spanning Tree Protocol", validate_choice, ARGV("0", "1"), FALSE },
	{ "lan_lease", "DHCP Server Lease Time", validate_range, ARGV("1", "604800"), FALSE },
	{ "dhcp_start", "DHCP Server LAN IP Address Range", validate_dhcp, NULL, FALSE },
	{ "wan_hostname", "WAN Host Name", validate_name, ARGV("0", "255"), TRUE },
	{ "wan_domain", "WAN Domain Name", validate_name, ARGV("0", "255"), TRUE },
	{ "wan_hwaddr", "WAN MAC Address", validate_hwaddr, NULL, TRUE },
	{ "wan_ipaddr", "WAN IP Address", validate_ipaddr, NULL, FALSE },
	{ "wan_netmask", "WAN Subnet Mask", validate_ipaddr, NULL, FALSE },
	{ "wan_gateway", "WAN Gateway", validate_ipaddr, NULL, TRUE },
	{ "wan_dns", "WAN DNS Server", validate_ipaddrs, NULL, TRUE },
	{ "wan_wins", "WAN WINS Server", validate_ipaddrs, NULL, TRUE },
	{ "wan_proto", "WAN Protocol", validate_choice, ARGV("dhcp", "static", "pppoe", "disabled"), FALSE },
	{ "pppoe_username", "PPPoE Username", validate_name, ARGV("0", "255"), TRUE },
	{ "pppoe_passwd", "PPPoE Password", validate_name, ARGV("0", "255"), TRUE },
	{ "pppoe_service", "PPPoE Service Name", validate_name, ARGV("0", "255"), TRUE },
	{ "pppoe_ac", "PPPoE Access Concentrator", validate_name, ARGV("0", "255"), TRUE },
	{ "pppoe_keepalive", "PPPoE Keep Alive", validate_choice, ARGV("0", "1"), FALSE },
	{ "pppoe_demand", "PPPoE Connect on Demand", validate_choice, ARGV("0", "1"), FALSE },
	{ "pppoe_idletime", "PPPoE Max Idle Time", validate_range, ARGV("1", "3600"), TRUE },
	{ "pppoe_mru", "PPPoE MRU", validate_range, ARGV("128", "16384"), FALSE },
	{ "pppoe_mtu", "PPPoE MTU", validate_range, ARGV("128", "16384"), FALSE },
	{ "http_username", "Router Username", validate_name, ARGV("0", "63"), TRUE },
	{ "http_passwd", "Router Password", validate_name, ARGV("0", "63"), TRUE },
	{ "http_wanport", "Router WAN Port", validate_range, ARGV("0", "65535"), TRUE },
	{ "router_disable", "Router Mode", validate_choice, ARGV("0", "1"), FALSE },
	{ "fw_disable", "Firewall", validate_choice, ARGV("0", "1"), FALSE },
	{ "time_zone", "Time Zone", validate_choice, ARGV("PST8PDT", "MST7MDT", "CST6CDT", "EST5EDT"), FALSE },
	{ "upnp_enable", "UPnP", validate_choice, ARGV("0", "1"), FALSE },
	{ "ntp_server", "NTP Servers", validate_ipaddrs, NULL, TRUE },
	{ "log_level", "Connection Logging", validate_range, ARGV("0", "3"), FALSE },
	{ "filter_macmode", "MAC Filter Mode", validate_choice, ARGV("disabled", "allow", "deny"), FALSE },
	{ "filter_maclist", "MAC Filter", validate_hwaddrs, NULL, TRUE },
	{ "filter_client", "LAN Client Filter", NULL, ARGV("0", XSTR(MAX_NVPARSE - 1)), FALSE },
	{ "forward_port", "Port Forward", NULL, ARGV("0", XSTR(MAX_NVPARSE - 1)), FALSE },
	{ "autofw_port", "Application Specific Port Forward", NULL, ARGV("0", XSTR(MAX_NVPARSE - 1)), FALSE },
	{ "static_route", "Static Route", validate_static_route, NULL, FALSE },
	{ "dmz_ipaddr", "DMZ LAN IP Address", validate_ipaddr, ARGV("lan_ipaddr", "lan_netmask"), TRUE },
	{ "log_ipaddr", "Log LAN IP Address", validate_ipaddr, ARGV("lan_ipaddr", "lan_netmask"), TRUE },
	/* ALL wl_XXXX variables are per-interface */
	{ "wl_ssid", "Network Name (SSID)", validate_name, ARGV("1", "32"), FALSE },
	{ "wl_closed", "Network Type", validate_choice, ARGV("0", "1"), FALSE },
	{ "wl_country", "Country", validate_choice, ARGV("Worldwide", "Thailand", "Israel", "Jordan", "China", "Japan", "USA", "Europe", "USA Low", "Japan High", "All"), FALSE },
	{ "wl_mode", "AP Mode", validate_choice, ARGV("ap", "sta", "wds"), FALSE },
	{ "wl_lazywds", "Bridge Restrict", validate_choice, ARGV("0", "1"), FALSE },
	{ "wl_wds", "Remote Bridges", validate_hwaddrs, NULL, TRUE },
	/* Order and index matters for WEP keys so enumerate them separately */
	{ "wl_key", "Network Key Index", validate_range, ARGV("1", "4"), FALSE },
	{ "wl_key1", "Network Key 1", validate_wl_key, NULL, TRUE },
	{ "wl_key2", "Network Key 2", validate_wl_key, NULL, TRUE },
	{ "wl_key3", "Network Key 3", validate_wl_key, NULL, TRUE },
	{ "wl_key4", "Network Key 4", validate_wl_key, NULL, TRUE },
	{ "wl_wep", "Data Encryption", validate_wl_wep, ARGV("off", "wep", "tkip", "aes", "tkip+aes"), FALSE },
	{ "wl_auth", "Shared Key Authentication", validate_wl_auth, ARGV("0", "1"), FALSE },
	{ "wl_macmode", "MAC Restrict Mode", validate_choice, ARGV("disabled", "allow", "deny"), FALSE },
	{ "wl_maclist", "Allowed MAC Address", validate_hwaddrs, NULL, TRUE },
	{ "wl_radio", "Radio Enable", validate_choice, ARGV("0", "1"), FALSE },
	{ "wl_phytype", "Radio Band", validate_choice, ARGV("a", "b", "g"), TRUE },
	/* Channel and rate are fixed in wlconfig() if incorrect */
	{ "wl_channel", "Channel", validate_range, ARGV("0", "216"), FALSE },
	{ "wl_rate", "Rate", validate_range, ARGV("0", "54000000"), FALSE },
	{ "wl_rateset", "Supported Rates", validate_choice, ARGV("all", "default", "12"), FALSE },
	{ "wl_frag", "Fragmentation Threshold", validate_range, ARGV("256", "2346"), FALSE },
	{ "wl_rts", "RTS Threshold", validate_range, ARGV("0", "2347"), FALSE },
	{ "wl_dtim", "DTIM Period", validate_range, ARGV("1", "255"), FALSE },
	{ "wl_bcn", "Beacon Interval", validate_range, ARGV("1", "65535"), FALSE },
	{ "wl_plcphdr", "Preamble Type", validate_choice, ARGV("long", "short"), FALSE },

	
	
	/* When testing 11b WiFi, must set this value to B only -- Joshua */
	{ "wl_gmode", "54g Mode", validate_choice, ARGV(XSTR(GMODE_AUTO), XSTR(GMODE_PERFORMANCE), XSTR(GMODE_LRS), XSTR(GMODE_LEGACY_B)), FALSE },
	{ "wl_gmode_wp1", "54g Mode Profile 1", NULL, NULL, TRUE},
	{ "wl_gmode_wp2", "54g Mode Profile 2", NULL, NULL, TRUE},
	
	{ "wl_gmode_protection", "54g Protection", validate_choice, ARGV("off", "auto"), FALSE },
	{ "wl_frameburst", "Frame Bursting", validate_choice, ARGV("off", "on"), FALSE },
	/* WPA parameters */
	{ "wl_wpa_psk", "WPA Pre-Shared Key", validate_wpa_psk, ARGV("64"), TRUE },
	{ "wl_wpa_gtk_rekey", "WPA GTK Rekey Timer", NULL, NULL, TRUE },
	{ "wl_radius_ipaddr", "RADIUS Server", validate_ipaddr, NULL, TRUE },
	{ "wl_radius_port", "RADIUS Port", validate_range, ARGV("0", "65535"), FALSE },
	{ "wl_radius_key", "RADIUS Shared Secret", validate_name, ARGV("0", "255"), TRUE },
	{ "wl_auth_mode", "Auth Mode", validate_auth_mode, ARGV("disabled", "radius", "wpa", "psk"), FALSE },

#if defined(MOTOROLA_SERIES)
#if defined(MOTOROLA_WE800G)
	{ "wl_profile", "active wireless profile", NULL, ARGV("1", "2"), TRUE},
	{ "wl_network_type", "infra or adhoc", NULL, ARGV("infra", "adhoc"), TRUE},

#endif
	{ "wl_key_strength", "wl_key_strength", NULL, NULL, TRUE},   /*64 or 128*/

#endif

	/* MUST leave this entry here after all wl_XXXX variables */
	{ "wl_unit", "802.11 Instance", wl_unit, NULL, TRUE },
	/* Internal variables */
	{ "os_server", "OS Server", NULL, NULL, TRUE },
	{ "stats_server", "Stats Server", NULL, NULL, TRUE },
	{ "timer_interval", "Timer Interval", NULL, NULL, TRUE }, 
	
#if defined(MOTOROLA_SERIES)
	{ "login_msg", "login msg", NULL, NULL, TRUE},
	{ "logonidletimer", "Logon session idle timer", NULL, NULL, TRUE},
	{ "wl_passphrase", "Wireless passphrase", NULL, NULL, TRUE},
	{ "Enable802_1x", "Enable802_1x", NULL, NULL, TRUE},
	{ "wl_key_input_method", "Password Input Method", NULL, NULL, TRUE},

#endif
#if defined(MOTOROLA_WE800G)
#if 1
	{ "wl_ssid_wp1", "Network Name (SSID) wp1", validate_name, ARGV("1", "32"), FALSE },
	{ "wl_ssid_wp2", "Network Name (SSID) wp2", validate_name, ARGV("1", "32"), FALSE },
	{ "wl_network_type_wp1", "infra or adhoc", NULL, ARGV("infra", "adhoc"), TRUE},
	{ "wl_network_type_wp2", "infra or adhoc", NULL, ARGV("infra", "adhoc"), TRUE},
	{ "wl_passphrase_wp1", "Wireless passphrase", NULL, NULL, TRUE},
	{ "wl_passphrase_wp2", "Wireless passphrase", NULL, NULL, TRUE},
	{ "wl_country_wp1", "Country", validate_choice, ARGV("Worldwide", "Thailand", "Israel", "Jordan", "China", "Japan", "USA", "Europe", "USA Low", "Japan High", "All"), FALSE },
	{ "wl_country_wp2", "Country", validate_choice, ARGV("Worldwide", "Thailand", "Israel", "Jordan", "China", "Japan", "USA", "Europe", "USA Low", "Japan High", "All"), FALSE },
	{ "wl_channel_wp1", "Channel", validate_range, ARGV("0", "216"), FALSE },
	{ "wl_channel_wp2", "Channel", validate_range, ARGV("0", "216"), FALSE },
	{ "wl_radio_wp1", "Radio Enable", validate_choice, ARGV("0", "1"), FALSE },
	{ "wl_radio_wp2", "Radio Enable", validate_choice, ARGV("0", "1"), FALSE },

	{ "wl_plcphdr_wp1", "Preamble Type", validate_choice, ARGV("long", "short"), FALSE },
	{ "wl_plcphdr_wp2", "Preamble Type", validate_choice, ARGV("long", "short"), FALSE },
	{ "wl_rts_wp1", "RTS Threshold", validate_range, ARGV("0", "2347"), FALSE },
	{ "wl_rts_wp2", "RTS Threshold", validate_range, ARGV("0", "2347"), FALSE },
	{ "wl_frag_wp1", "Fragmentation Threshold", validate_range, ARGV("256", "2346"), FALSE },
	{ "wl_frag_wp2", "Fragmentation Threshold", validate_range, ARGV("256", "2346"), FALSE },
	{ "wl_rateset_wp1", "Supported Rates", validate_choice, ARGV("all", "default", "12"), FALSE },
	{ "wl_rateset_wp2", "Supported Rates", validate_choice, ARGV("all", "default", "12"), FALSE },
	{ "wl_gmode_protection_wp1", "54g Protection", validate_choice, ARGV("off", "auto"), FALSE },
	{ "wl_gmode_protection_wp2", "54g Protection", validate_choice, ARGV("off", "auto"), FALSE },
	{ "wl_frameburst_wp1", "Frame Bursting", validate_choice, ARGV("off", "on"), FALSE },
	{ "wl_frameburst_wp2", "Frame Bursting", validate_choice, ARGV("off", "on"), FALSE },

	{ "wl_closed_wp1", "SSID broadcast?", validate_choice, ARGV("0", "1"), FALSE },
	{ "wl_closed_wp2", "SSID broadcast?", validate_choice, ARGV("0", "1"), FALSE },

	{ "wl_auth_mode_wp1", "Auth Mode", NULL, NULL, FALSE },
	{ "wl_auth_mode_wp2", "Auth Mode", NULL, NULL, FALSE },
	{ "wl_wep_wp1", "Data Encryption", NULL, NULL, FALSE },
	{ "wl_wep_wp2", "Data Encryption", NULL, NULL, FALSE },	
//	{ "wl_auth_mode_wp1", "Auth Mode", validate_auth_mode, ARGV("disabled", "radius", "wpa", "psk"), FALSE },
//	{ "wl_auth_mode_wp2", "Auth Mode", validate_auth_mode, ARGV("disabled", "radius", "wpa", "psk"), FALSE },
//	{ "wl_wep_wp1", "Data Encryption", validate_wl_wep, ARGV("off", "wep", "tkip", "aes", "tkip+aes"), FALSE },
//	{ "wl_wep_wp2", "Data Encryption", validate_wl_wep, ARGV("off", "wep", "tkip", "aes", "tkip+aes"), FALSE },

	{ "wl_auth_wp1", "Shared Key Authentication", NULL, NULL, FALSE },
	{ "wl_auth_wp2", "Shared Key Authentication", NULL, NULL, FALSE },
	{ "wl_key_input_method_wp1", "Password Input Method", NULL, NULL, TRUE},
	{ "wl_key_input_method_wp2", "Password Input Method", NULL, NULL, TRUE},
	{ "wl_key_strength_wp1", "wl_key_strength", NULL, NULL, TRUE},
	{ "wl_key_strength_wp2", "wl_key_strength", NULL, NULL, TRUE},
	{ "wl_key_wp1", "Network Key Index", validate_range, ARGV("1", "4"), FALSE },
	{ "wl_key_wp2", "Network Key Index", validate_range, ARGV("1", "4"), FALSE },
	{ "wl_key1_wp1", "Network Key 1", validate_wl_key, NULL, TRUE },
	{ "wl_key1_wp2", "Network Key 1", validate_wl_key, NULL, TRUE },
	{ "wl_key2_wp1", "Network Key 2", validate_wl_key, NULL, TRUE },
	{ "wl_key2_wp2", "Network Key 2", validate_wl_key, NULL, TRUE },
	{ "wl_key3_wp1", "Network Key 3", validate_wl_key, NULL, TRUE },
	{ "wl_key3_wp2", "Network Key 3", validate_wl_key, NULL, TRUE },
	{ "wl_key4_wp1", "Network Key 4", validate_wl_key, NULL, TRUE }, 
	{ "wl_key4_wp2", "Network Key 4", validate_wl_key, NULL, TRUE },
	{ "Enable802_1x_wp1", "Enable802_1x wp1", NULL, NULL, TRUE},
	{ "Enable802_1x_wp2", "Enable802_1x wp2", NULL, NULL, TRUE},
	{ "wl_wpa_psk_wp1", "WPA Pre-Shared Key", validate_wpa_psk, ARGV("64"), TRUE },
	{ "wl_wpa_psk_wp2", "WPA Pre-Shared Key", validate_wpa_psk, ARGV("64"), TRUE },
	{ "Redirect_To", "Redirect to", NULL, NULL, FALSE},
	{ "flag_MAC", "", NULL, NULL, TRUE},


#endif
#endif



};

static void
validate_cgi(webs_t wp)
{
	struct variable *v;
	char *value;

	/* Validate and set variables in table order */
	for (v = variables; v < &variables[sizeof(variables)/sizeof(variables[0])]; v++) {
		if (!(value = websGetVar(wp, v->name, NULL)))
			continue;
		if ((!*value && v->nullok) || !v->validate)
			nvram_set(v->name, value);
		else
			v->validate(wp, value, v);
	}
}



#if defined(MOTOROLA_SERIES)




static int apply_cgi_Login(char* act, int *action, int *jumpto, webs_t wp)
{
	char *id, *passwd;
	tsprintf("apply_cgi_Apply : %s\n", act);
	id = websGetVar(wp, "userid", "");
	passwd = websGetVar(wp, "password", "");
	tsprintf("id : %s, passwd : %s, NVRAM user : %s password : %s\n", id, passwd, nvram_get("http_username"), nvram_get("http_passwd"));

	if(strcmp( id, nvram_get("http_username") ) == 0 && strcmp( passwd, nvram_get("http_passwd") ) == 0 )
	{
		AuthReset = 0;
		{
  			char msg[100];
			char bp[20];
       			struct  tm             *rv_tm;
//      			struct  timeval         curtime;
			time_t  systime;
			static const char *months[] = {
			        "Jan", "Feb", "Mar", "Apr", "May", "Jun",
			        "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
			};
			static const char *days[] = {
			        "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
     			};
       			time(&systime);
    			rv_tm = gmtime(&systime);
    			sprintf(bp,"%s, %s %2d %2d:%02d:%02d %4d",
              		days[rv_tm->tm_wday], months[rv_tm->tm_mon], rv_tm->tm_mday,
              		rv_tm->tm_hour, rv_tm->tm_min, rv_tm->tm_sec,
              		1900+rv_tm->tm_year);
 			memset( msg, '\0', sizeof(msg) );
 			sprintf( msg, "%s##%s login success", bp, nvram_get("login_addr"));
			write_eventlog(2, msg);
		}
		
		nvram_set("server_ipaddr", nvram_get("wan_ipaddr"));
		
		if(MOTOROLA_Wizard == 1)
			websWrite(wp, Login_OK_wizard_asp);
		else
			websWrite(wp, Login_OK_asp);		
	}
	else
	{
  		AuthReset = 1;
 		{
 			char msg[100];
			char bp[20];
      			struct  tm             *rv_tm;
 //     			struct  timeval         curtime;
			time_t  systime;
			static const char *months[] = {
			        "Jan", "Feb", "Mar", "Apr", "May", "Jun",
			        "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
			};
			static const char *days[] = {
			        "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
			};
			time(&systime);
    			rv_tm = gmtime(&systime);
     			sprintf(bp,"%s, %s %2d %2d:%02d:%02d %4d",
              		days[rv_tm->tm_wday], months[rv_tm->tm_mon], rv_tm->tm_mday,
              		rv_tm->tm_hour, rv_tm->tm_min, rv_tm->tm_sec,
              		1900+rv_tm->tm_year);
			memset( msg, '\0', sizeof(msg) );
			sprintf( msg, "%s##%s login fail", bp, nvram_get("login_addr"));
			write_eventlog(2, msg);
			nvram_set("login_msg", "fail");
		}
		websWrite(wp, Login_Fail_asp);
	}
	tsprintf("broadcom.c : AuthReset => %d %p\n", AuthReset, &AuthReset);
	*action = NOTHING;
	*jumpto = JUMP_ACTION;
	return *action;
}
 

extern struct sockaddr_in mysockaddr;
static int apply_cgi_log_out(char* act, int *action, int *jumpto, webs_t wp)
{
	tsprintf("apply_cgi_log_out : %s\n", act);
	AuthReset = 1;
	memset(&mysockaddr, 0, sizeof(mysockaddr));
	websWrite(wp, Login_Fail_asp);
	{
		char msg[100];
		char bp[20];
		struct  tm             *rv_tm;
//		struct  timeval         curtime;
		time_t  systime;
		static const char *months[] = {
		        "Jan", "Feb", "Mar", "Apr", "May", "Jun",
		        "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
		};
		static const char *days[] = {
		        "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat"
		};
		time(&systime);
  		rv_tm = gmtime(&systime);
  		sprintf(bp,"%s, %s %2d %2d:%02d:%02d %4d",
            	days[rv_tm->tm_wday], months[rv_tm->tm_mon], rv_tm->tm_mday,
            		rv_tm->tm_hour, rv_tm->tm_min, rv_tm->tm_sec,
            		1900+rv_tm->tm_year);
		memset( msg, '\0', sizeof(msg) );
		sprintf( msg, "%s##%s logout", bp, nvram_get("login_addr"));
		write_eventlog(2, msg);
	}
	*action = NOTHING;
	*jumpto = JUMP_ACTION;
	//goto footer;
	return *action;
}

//-----------------------------------------------------------------------------

static int apply_cgi_Apply(char* act, int *action, int *jumpto, webs_t wp)
{
	tsprintf("apply_cgi_Apply : %s\n", act);
	websHeader(wp);
	websWrite(wp, (char_t *) apply_header);
	tsprintf("Finish header apply_cgi_Apply : %s\n", act);
	validate_cgi(wp);

	//*action = RESTART;

	nvram_set("NeedReboot", "1");

	tsprintf("Finish apply_cgi_Apply : %s action : %d\n", act, *action);
  	*action = NOTHING;
	*jumpto = JUMP_NOTHING;
 	return *action;
}
//-----------------------------------------------------------------------------
static int apply_cgi_restart(char* act, int *action, int *jumpto, webs_t wp)
{
	char buf[200];
	tsprintf("apply_cgi_restart : %s\n", act);
	websWrite(wp, (char_t *) apply_asp_header);

	sprintf(buf, "<input type=\"hidden\" name=\"dest_ip\" value=\"%s\">\n", nvram_get("wan_ipaddr"));
		
	websWrite(wp, buf);
	websWrite(wp, (char_t *) apply_asp_footer);
	websDone(wp, 200);
	//*action = REBOOT;
	*action = NOTHING;

	*jumpto = JUMP_ACTION;
	//goto footer;
	return *action;
}
//-----------------------------------------------------------------------------
static int apply_cgi_Restore_Defaults(char* act, int *action, int *jumpto, webs_t wp)
{
	char buf[200];
	tsprintf("apply_cgi_Restore_Defaults : %s\n", act);

	websHeader(wp);
#if defined(MOTOROLA_WE800G)
	nvram_set("move_to_defaults","1");
  nvram_set("restore_defaults","0");
	sys_commit();
#endif
	system ( "echo 000 > /tmp/ResetToDefaultFlag" );
	websWrite(wp, (char_t *) apply_asp_header);


	sprintf(buf, "<input type=\"hidden\" name=\"dest_ip\" value=\"%s\">\n", nvram_get("wan_ipaddr"));
#if defined(MOTOROLA_WE800G)
	nvram_set("wan_ipaddr", "192.168.30.1");
#endif
	websWrite(wp, buf);
	websWrite(wp, (char_t *) apply_asp_restore_default_footer);
	websDone(wp, 200);

	*action = NOTHING;
	//*action = REBOOT;
	*jumpto = JUMP_ACTION;

	return *action;
}


//-----------------------------------------------------------------------------
static int apply_cgi_wizard(char* act, int *action, int *jumpto, webs_t wp)
{
	char buf[200] = {0};
	tsprintf("apply_cgi_wizard : %s\n", act);
	websHeader(wp);
	websWrite(wp, (char_t *) apply_asp_wizard_header);
	tsprintf("Finish header apply_cgi_wizard : %s\n", act);

	validate_cgi(wp);
	
	//printf("Key Info : Input method : %s Key Lnegth : %s\n", nvram_get("wl_key_input_method_wp1"), nvram_get("wl_key_strength_wp1"));
	if(!strcmp(nvram_get("wl_key_input_method_wp1"), "0")) /* 0 */
	{
		if(!strcmp(nvram_get("wl_key_strength_wp1"), "64")) /* 64 128 */
		{
//			unsigned char key_buf[65] = {0};
			unsigned char buf[65] = {0};
			gen_11i_passphrase_key_we800g(1);
//			strncpy(key_buf, nvram_get("Passphrase_key_11i_wp1"), 65);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[0], key_buf[1], key_buf[2], key_buf[3], key_buf[4]);
			nvram_set("wl_key1_wp1", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[8], key_buf[9], key_buf[10], key_buf[11], key_buf[12]);
			nvram_set("wl_key2_wp1", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[16], key_buf[17], key_buf[18], key_buf[19], key_buf[20]);
			nvram_set("wl_key3_wp1", buf);
			sprintf(buf, "%02X%02X%02X%02X%02X", key_buf[24], key_buf[25], key_buf[26], key_buf[27], key_buf[28]);
			nvram_set("wl_key4_wp1", buf);			
			
			//printf("Final result : \n");
			//printf("1 : %s\n2 : %s\n3 : %s\n4 : %s\n", nvram_get("wl_key1_wp1"), nvram_get("wl_key2_wp1"), nvram_get("wl_key3_wp1"), nvram_get("wl_key4_wp1"));
		}
		else if(!strcmp(nvram_get("wl_key_strength_wp1"), "128"))
		{
//			unsigned char key_buf[65] = {0};
			unsigned char buf[65] = {0};
			gen_11i_passphrase_key_we800g(1);
//			strncpy(key_buf, nvram_get("Passphrase_key_11i_wp1"), 65);
			sprintf(buf, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", key_buf[0], key_buf[1], key_buf[2], key_buf[3], key_buf[4], key_buf[5], key_buf[6], key_buf[7], key_buf[8], key_buf[9], key_buf[10], key_buf[11], key_buf[12]);
			nvram_set("wl_key1_wp1", buf);			
			sprintf(buf, "%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X%02X", key_buf[16], key_buf[17], key_buf[18], key_buf[19], key_buf[20], key_buf[21], key_buf[22], key_buf[23], key_buf[24], key_buf[25], key_buf[26], key_buf[27], key_buf[28]);			
			nvram_set("wl_key2_wp1", buf);
			nvram_set("wl_key3_wp1", "");
			nvram_set("wl_key4_wp1", "");			
			
			//printf("Final result : \n");
			//printf("1 : %s\n2 : %s\n3 : %s\n4 : %s\n", nvram_get("wl_key1_wp1"), nvram_get("wl_key2_wp1"), nvram_get("wl_key3_wp1"), nvram_get("wl_key4_wp1"));
			
		}
		else
		{
//			printf("Unknown wl_key_strength!\n"); 
//			*action = NOTHING;
//			*jumpto = JUMP_NOTHING;
//			return *action;
		}
	}
		
	tsprintf("Finish apply_cgi_wizard : %s action : %d\n", act, *action);
	
	sprintf(buf, "<input type=\"hidden\" name=\"dest_ip\" value=\"%s\">\n", nvram_get("wan_ipaddr"));

	websWrite(wp, buf);		
	websWrite(wp, (char_t *) apply_asp_wizard_footer);	
	websDone(wp, 200);

	sys_commit();
	
	wizard_reboot = 1;
		
	*action = NOTHING; 
	*jumpto = JUMP_ACTION;	

	return *action;
}
//----------------------------------------------------------------------------- 

static int apply_cgi_redirect_to_reboot(char* act, int *action, int *jumpto, webs_t wp)
{
	char buf[100] = {0};
	tsprintf("apply_cgi_redirect_to_reboot : %s\n", act);
	websWrite(wp, (char_t *) reboot_asp);
	sprintf(buf, "<input type=\"hidden\" name=\"server_ip\" value='%s'\">\n", nvram_get("server_ipaddr"));
	websWrite(wp, buf);	
	sprintf(buf, "<input type=\"hidden\" name=\"dest_ip\" value='%s'\">\n", nvram_get("wan_ipaddr"));
	websWrite(wp, buf);
	sprintf(buf, "<input type=\"hidden\" name=\"wan_proto\" value='%s'>\n", nvram_get("wan_proto"));
	websWrite(wp, buf);			
	websWrite(wp, (char_t *) reboot_asp_footer);
	//validate_cgi(wp);
	websDone(wp, 200);
	*action = REBOOT;
	*jumpto = JUMP_ACTION;
	return *action;
}

//----------------------------------------------------------------------------- 
static int apply_cgi_backup_configuration(char* act, int *action, int *jumpto, webs_t wp)
{

	tsprintf("apply_cgi_backup_configuration : %s\n", act);

	websHeader(wp);
	websWrite(wp, (char_t *) apply_header);
	validate_cgi(wp);

	/* make /tmp/config.bin */
	{
        	pid_t pid;
		int ret = EINVAL;
		char *restore_argv[] = { "/sbin/restore", "/tmp/var/tmp/nvram", "1", "/tmp/config.bin", "/tmp/test", nvram_get("ModelId"), NULL};

		tsprintf("broadcom.c : Backup nvram file...");
		_eval(restore_argv, NULL, 0, &pid);
		waitpid(pid, &ret, 0);
		tsprintf("done\n");
	}
	websWrite(wp, "<script>window.parent.config_bottom.location.href = 'config.bin';</script>\n");

	*action = NOTHING;
	*jumpto = JUMP_NOTHING;

	return *action;
}

//-----------------------------------------------------------------------------

static int apply_cgi_restore_configuration(char* act, int *action, int *jumpto, webs_t wp)
{
	tsprintf("apply_cgi_restore_configuration : %s\n", act);

	websHeader(wp);
	websWrite(wp, (char_t *) apply_header);
	validate_cgi(wp);

	*action = NOTHING;
	*jumpto = JUMP_NOTHING;

	return *action;
}

static int apply_cgi_restore(char* act, int *action, int *jumpto, webs_t wp)
{

}

static int apply_cgi_UpgradeComplete(char* act, int *action, int *jumpto, webs_t wp)

{

	tsprintf("apply_cgi_UpgradeComplete : %s\n", act);

	

	websWrite(wp, (char_t *) Firmware_Update_Header);


	websWrite(wp, "<input type=\"hidden\" name=\"restart_status\" value='%s'>\n", nvram_get("NeedReboot"));
	websWrite(wp, "<span class=\"text\"><font size=\"3\">Upgrade Complete<br><br>Please press Restart button.</font></span>\n");
	websWrite(wp, "<script>window.status=\"Upgrade progress status : Upgrade Complete\";</script>\n");

	websWrite(wp, (char_t *) Firmware_Update_Footer);
	

	*action = NOTHING;		

	*jumpto = JUMP_ACTION;

	

	return *action;

}

static int apply_cgi_UpgradeFail4702Only(char* act, int *action, int *jumpto, webs_t wp)
{
	tsprintf("apply_cgi_UpgradeFail4702Only : %s\n", act);
	
	websWrite(wp, (char_t *) Firmware_Update_Header);

	websWrite(wp, "<input type=\"hidden\" name=\"restart_status\" value='%s'>\n", nvram_get("NeedReboot"));
	websWrite(wp, "<span class=\"text\"><font size=\"3\">Please use newer firmware to upgrade this device.</font></span>\n");
	websWrite(wp, "<script>window.status=\"Upgrade progress status : Upgrade Failed\";</script>\n");

	websWrite(wp, (char_t *) Firmware_Update_Footer);
	
	*action = NOTHING;		
	*jumpto = JUMP_ACTION;
	
	return *action;
}

static int apply_cgi_UpgradeFail(char* act, int *action, int *jumpto, webs_t wp)

{

	tsprintf("apply_cgi_UpgradeFail : %s\n", act);

	

	websWrite(wp, (char_t *) Firmware_Update_Header);


	websWrite(wp, "<input type=\"hidden\" name=\"restart_status\" value='%s'>\n", nvram_get("NeedReboot"));
	websWrite(wp, "<span class=\"text\"><font size=\"3\">Upgrade Failed</font></span>\n");
	websWrite(wp, "<script>window.status=\"Upgrade progress status : Upgrade Failed\";</script>\n");

	websWrite(wp, (char_t *) Firmware_Update_Footer);
	

	*action = NOTHING;		

	*jumpto = JUMP_ACTION;

	

	return *action;

}
//-----------------------------------------------------------------------------
#endif /* end of #if defined(MOTOROLA_SERIES) */

#if defined(MOTOROLA_SERIES)
 /* move this to the above */
#else
static const char * const apply_header =
"<head>"
"<title>Broadcom Home Gateway Reference Design: Apply</title>"
"<meta http-equiv=\"Content-Type\" content=\"text/html; charset=utf-8\">"
"<style type=\"text/css\">"
"body { background: white; color: black; font-family: arial, sans-serif; font-size: 9pt }"
".title	{ font-family: arial, sans-serif; font-size: 13pt; font-weight: bold }"
".subtitle { font-family: arial, sans-serif; font-size: 11pt }"
".label { color: #306498; font-family: arial, sans-serif; font-size: 7pt }"
"</style>"
"</head>"
"<body>"
"<p>"
"<span class=\"title\">APPLY</span><br>"
"<span class=\"subtitle\">This screen notifies you of any errors "
"that were detected while changing the router's settings.</span>"
"<form method=\"get\" action=\"apply.cgi\">"
"<p>"
;
#endif 

#if defined(MOTOROLA_SERIES)
static const char * const apply_footer =
//"<input type=\"button\" name=\"action\" value=\"Continue\" OnClick=\"window.location.href = document.referrer;\">"
"<script language=\"JavaScript\" type=\"text/JavaScript\">\n"
"<!--\n"
"	document.location.href = document.referrer;\n"
"//-->\n"
"</script>\n"
"</th>"
"</tr>"
"</table>"
"</form>"
"</center>"
"</body>"
; 
#else
static const char * const apply_footer =
"<p>"
"<input type=\"button\" name=\"action\" value=\"Continue\" OnClick=\"document.location.href='%s';\">"
"<input type=\"submit\" name=\"action\" value=\"Restore Defaults\">"
"</form>"
"<p class=\"label\">&#169;2001-2003 Broadcom Corporation. All rights reserved.</p>"
"</body>"
;
#endif


#if defined(MOTOROLA_SERIES)
  /* move this enum to the above */
#else
enum {
	NOTHING,
	REBOOT,
	RESTART,
};
#endif

static int
ej_need_redirect_to( int eid , webs_t wp , int argc , char_t **argv )
{
	printf("Redirect to %s\n", nvram_safe_get("Redirect_To"));
	
	if(!strcmp(nvram_safe_get("Redirect_To"), "1"))
	{
		websWrite ( wp , "%s", "top.location.href = \"frame_wp1_security.asp\";");
	}
	else if(!strcmp(nvram_safe_get("Redirect_To"), "2"))
	{
		websWrite ( wp , "%s", "top.location.href = \"frame_wp2_security.asp\";");
	}
	
	nvram_set("Redirect_To", "");
	
	sys_commit();
	
	return;
}

static int
ej_get_associate_result( int eid , webs_t wp , int argc , char_t **argv )
{
	char name[10];
	char empty_bssid[6] = {0x00, 0x00, 0x00, 0x00, 0x00, 0x00};
	unsigned char buf[100]={0};
	int result = 0;
	
	if(!strcmp(nvram_safe_get("wl_radio"), "0"))
	{
		websWrite ( wp , "%s", "Not associated");
		return;
	}

	if(!check_associate_status())
	{
		websWrite ( wp , "%s", "Not associated");		
		return;
	}
	
	strcpy(name, nvram_safe_get("wlif"));
		
	result = wl_ioctl(name, WLC_GET_BSSID, buf, sizeof(buf));
	
	if(result == -1 || !memcmp( buf, empty_bssid, 6 ))
	{
		//printf("WLC_GET_BSSID : %02X:%02X:%02X:%02X:%02X:%02X\n", buf[0], buf[1], buf[2], buf[3], buf[4], buf[5]);
		websWrite ( wp , "%s", "Not associated");
		return;
	}
	else
	{	
		//printf("Associate with %02X:%02X:%02X:%02X:%02X:%02X\n", buf[0], buf[1], buf[2], buf[3], buf[4], buf[5]);
		websWrite ( wp , "Associated");	
	}
	return;
}

static int
ej_get_associate_SSID( int eid , webs_t wp , int argc , char_t **argv )
{
	char name[10];
	unsigned char buf[8192] ;	
	wlc_ssid_t *p;
	int result = 0;
	int i=0;
	
	if(!strcmp(nvram_safe_get("wl_radio"), "0"))
	{
		websWrite ( wp , "%s", "");
		return;
	}

	if(!check_associate_status())
	{
		websWrite ( wp , "%s", "");		
		return;
	}
	
	strcpy(name, nvram_safe_get("wlif"));
		
	result = wl_ioctl(name, WLC_GET_SSID, buf, sizeof(buf));
	p = buf;
	tsprintf("buf.SSID_len : %d\n", p->SSID_len);
	
	for(i=0;i<p->SSID_len;i++)
	{
		tsprintf("%c", p->SSID[i]);
		websWrite ( wp , "%c", p->SSID[i]);
	}
	tsprintf("\n");
	
	return;
}

static int
ej_get_associate_ap_mac( int eid , webs_t wp , int argc , char_t **argv )
{
	char name[10];
	unsigned char buf[100]={0};
	int result = 0;
	FILE *fp;
	
	if(!strcmp(nvram_safe_get("wl_radio"), "0"))
	{
		websWrite ( wp , "%s", "N/A");
		return;
	}

	if(!check_associate_status())
	{
		websWrite ( wp , "%s", "N/A");		
		return;
	}
		
	strcpy(name, nvram_safe_get("wlif"));
		
	result = wl_ioctl(name, WLC_GET_BSSID, buf, sizeof(buf));
	
	websWrite ( wp , "%02X:%02X:%02X:%02X:%02X:%02X", buf[0], buf[1], buf[2], buf[3], buf[4], buf[5]);	

	return;
}

static int
ej_get_associate_ap_auth_mode( int eid , webs_t wp , int argc , char_t **argv )
{
	//unsigned char buf[1000]={0};
	//FILE *fp;

	if(!strcmp(nvram_safe_get("wl_auth"), "0"))
	{
		websWrite ( wp , "Open System");	
	}
	else if(!strcmp(nvram_safe_get("wl_auth"), "1"))
	{
		websWrite ( wp , "Pre-Shared Key (PSK)");	
	}
	else
	{
		websWrite ( wp , "Open System");	
	}
	
//	system("wl dump > /tmp/wl_temp");		
//	
//	if ((fp = fopen("/tmp/wl_temp","r")) == NULL) 
//	{

//		tsprintf(" No /tmp/wl_temp file!\n");

//	}

//	else

//	{
//		char buf1[100], buf2[100], buf3[100], buf4[100];
//				
//		fgets(buf, 1000, fp);
//		//printf("%s\n", buf);
//		fgets(buf, 1000, fp);
//		//printf("%s\n", buf);
//		fgets(buf, 1000, fp);
//		//printf("%s\n", buf);
//		fgets(buf, 1000, fp);
//		//printf("%s\n", buf);
//		fgets(buf, 1000, fp);
//		//printf("%s\n", buf);
//		fscanf(fp, "%s %s %s %s", buf1, buf2, buf3, buf4);

//		//printf("%s %s %s %s\n", buf1, buf2, buf3, buf4);	
//		
//		if(!strcmp(buf4, "1"))
//		{
//			websWrite ( wp , "Pre-Shared Key (PSK)");	
//		}
//		else
//			websWrite ( wp , "Open System");		
//	}	
//	fclose(fp);		

	return;
}

static int
ej_get_associate_ap_encry_status( int eid , webs_t wp , int argc , char_t **argv )
{
	//unsigned char buf[100]={0};
	//FILE *fp;

	if(!strcmp(nvram_safe_get("wl_wep"), "off"))
	{
			websWrite ( wp , "None");		
	}
	else if(!strcmp(nvram_safe_get("wl_wep"), "wep"))
	{
			if(!strcmp(nvram_get("wl_key_strength"), "64"))
				websWrite ( wp , "WEP64");
			else if(!strcmp(nvram_get("wl_key_strength"), "128"))
				websWrite ( wp , "WEP128");
			else
				websWrite ( wp , "WEP");		
	}
	else
	{
			websWrite ( wp , "None");
	}
	
//	system("wl wepstatus > /tmp/wl_temp");		
//	
//	if ((fp = fopen("/tmp/wl_temp","r")) == NULL) 
//	{

//		tsprintf(" No /tmp/wl_temp file!\n");

//	}

//	else

//	{
//		char buf1[100], buf2[100], buf3[100];		
//		fscanf(fp, "%s %s %s", buf1, buf2, buf3);

//		//printf("%s %s %s\n", buf1, buf2, buf3);	
//		if(!strcmp(buf3, "1"))
//		{
//			if(!strcmp(nvram_get("wl_key_strength"), "64"))
//				websWrite ( wp , "WEP64");
//			else if(!strcmp(nvram_get("wl_key_strength"), "128"))
//				websWrite ( wp , "WEP128");
//			else
//				websWrite ( wp , "WEP");	
//		}
//		else
//			websWrite ( wp , "None");		
//	}	
//	fclose(fp);	
	
	return;
}

static int
ej_get_associate_rate( int eid , webs_t wp , int argc , char_t **argv )
{
	int rate_info = 0;

	if(!strcmp(nvram_safe_get("wl_radio"), "0"))
	{
		websWrite ( wp , "%s", "N/A");
		return;
	}

	if(!check_associate_status())
	{
		websWrite ( wp , "%s", "N/A");		
		return;
	}
		
	//fprintf(stderr, "broadcom.c : WLC_GET_RATE\n");
	wl_ioctl( nvram_safe_get("wlif"), WLC_GET_RATE, &rate_info, sizeof(rate_info) );
	//fprintf(stderr, "WLC_GET_RATE : %d\n", rate_info);
	
	websWrite ( wp , "%dMbps", (rate_info * 500) / 1000);
//	FILE *fp;
//
//	system("wl rate > /tmp/wl_temp");
//	if ((fp = fopen("/tmp/wl_temp","r")) == NULL) 
//	{

//		tsprintf(" No /tmp/wl_temp file!\n");

//	}

//	else

//	{
//		char buf1[100], buf2[100], buf3[100], buf4[100];		
//		fscanf(fp, "%s %s %s %s", buf1, buf2, buf3, buf4);

//		tsprintf("%s %s %s %s\n", buf1, buf2, buf3, buf4);	
//		websWrite ( wp , "%sMbps", buf3);		

//	}
	
//	
//	fclose(fp);
	
	return;
}

static int
ej_get_associate_channel( int eid , webs_t wp , int argc , char_t **argv )
{
	char ioctl_buf[12];
	channel_info_t *ioctl_channel_info = (channel_info_t *)ioctl_buf;	

	if(!strcmp(nvram_safe_get("wl_radio"), "0"))
	{
		websWrite ( wp , "%s", "N/A");
		return;
	}

	if(!check_associate_status())
	{
		websWrite ( wp , "%s", "N/A");		
		return;
	}
		
	memset(ioctl_buf,0,sizeof(ioctl_buf));
	//fprintf(stderr, "broadcom.c : WLC_GET_CHANNEL\n");
	wl_ioctl( nvram_safe_get("wlif"), WLC_GET_CHANNEL, ioctl_buf, sizeof(ioctl_buf) );
	//fprintf(stderr, "ej_get_associate_channel : hw_channel:%d target_channel:%d scan_channel:%d\n", ioctl_channel_info->hw_channel, ioctl_channel_info->target_channel, ioctl_channel_info->scan_channel);
	websWrite ( wp , "%d", ioctl_channel_info->target_channel);	
//	FILE *fp;
//
//	system("wl channel > /tmp/wl_temp");
//	if ((fp = fopen("/tmp/wl_temp","r")) == NULL) 
//	{

//		tsprintf(" No /tmp/wl_temp file!\n");

//	}

//	else

//	{
//		char buf1[100], buf2[100], buf3[100], buf4[100];		
//		fscanf(fp, "%s %s %s %s", buf1, buf2, buf3, buf4);
//		fscanf(fp, "%s %s %s %s", buf1, buf2, buf3, buf4);

//		tsprintf("%s %s %s %s\n", buf1, buf2, buf3, buf4);	
//		if(!strcmp("current", buf4))		
//		{
//			websWrite ( wp , "%s", buf3);					
//		}
//		else
//		{
//			websWrite ( wp , "%s", buf4);		
//		}
//	}	
//	fclose(fp);	
	return;
}

static int
ej_get_associate_rssi( int eid , webs_t wp , int argc , char_t **argv )
{
	FILE *fp;

	if(!strcmp(nvram_safe_get("wl_radio"), "0"))
	{
		websWrite ( wp , "%s", "N/A");
		return;
	}

	if(!check_associate_status())
	{
		websWrite ( wp , "%s", "N/A");		
		return;
	}
	
	system("wl rssi > /tmp/wl_temp");
	if ((fp = fopen("/tmp/wl_temp","r")) == NULL) 
	{

		tsprintf(" No /tmp/wl_temp file!\n");

	}

	else

	{
		char buf1[100], buf2[100];		
		int rssi_value = 0;
		fscanf(fp, "%s %s %d", buf1, buf2, &rssi_value);

		tsprintf("%s %s %d\n", buf1, buf2, rssi_value);	
		websWrite ( wp , "%d%%", 100 - abs(rssi_value));		

	}
	
	fclose(fp);	
	return;
}

static int
ej_get_associate_noise( int eid , webs_t wp , int argc , char_t **argv )
{
	FILE *fp;

	if(!strcmp(nvram_safe_get("wl_radio"), "0"))
	{
		websWrite ( wp , "%s", "N/A");
		return;
	}

	if(!check_associate_status())
	{
		websWrite ( wp , "%s", "N/A");		
		return;
	}
	
	system("wl noise > /tmp/wl_temp");		
	if ((fp = fopen("/tmp/wl_temp","r")) == NULL) 
	{

		tsprintf(" No /tmp/wl_temp file!\n");

	}

	else

	{
		char buf1[100], buf2[100], buf3[100];		
		fscanf(fp, "%s %s %s", buf1, buf2, buf3);

		tsprintf("%s %s %s\n", buf1, buf2, buf3);	
		websWrite ( wp , "%s", buf3);		

	}	
	fclose(fp);	
	return;
}

static int
ej_get_debug_result( int eid , webs_t wp , int argc , char_t **argv )
{
	FILE *fp;
	char buf[1026];
	int count = 0;
	
	fp = fopen("/tmp/debug_result", "r") ;
	//websWrite(wp, "Network Diagnostic Result : ");
	//websWrite(wp, buf);
	//websWrite(wp, "<br><br><hr><br>\n");
	
	if( fp == NULL )
	{
		websWrite(wp, "");
		return ;
	}
	
	while(fgets( buf, sizeof(buf)-2, fp ))
	{
		char *p_str = NULL;
		count++;
		if(p_str = strchr(buf, '\n'))
		{
		  memset(p_str, '\\', 1);
		  memset(p_str + 1, 'n', 1);
		  memset(p_str + 2, 0, 1);
		}		  
		websWrite(wp, buf);
	}
	
	if(count == 0)
	{
		//websWrite(wp, "Network unreachable!");
	}
									
	fclose(fp);
}

static int apply_cgi_connect(char* act, int *action, int *jumpto, webs_t wp)
{
	tsprintf("apply_cgi_connect : %s\n", act);
	websHeader(wp);
	websWrite(wp, (char_t *) apply_header);
	tsprintf("Finish apply_cgi_connect : %s action : %d\n", act, *action);
	
	system("join");
	
 	*action = NOTHING;
	*jumpto = JUMP_NOTHING;
	return *action;	
}

static int apply_cgi_disconnect(char* act, int *action, int *jumpto, webs_t wp)
{
	tsprintf("apply_cgi_disconnect : %s\n", act);
	websHeader(wp);
	websWrite(wp, (char_t *) apply_header);
	tsprintf("Finish apply_cgi_disconnect : %s action : %d\n", act, *action);
	
	system("wl disassoc");
	
 	*action = NOTHING;
	*jumpto = JUMP_NOTHING;
	return *action;	
}

static int apply_cgi_Re_associate(char* act, int *action, int *jumpto, webs_t wp)
{
	tsprintf("apply_cgi_Re_associate : %s\n", act);
	websHeader(wp);
	websWrite(wp, (char_t *) apply_header);
	tsprintf("Finish apply_cgi_Re_associate : %s action : %d\n", act, *action);
	
	system("wl disassoc");
	system("join");
	
 	*action = NOTHING;
	*jumpto = JUMP_NOTHING;
	return *action;	
}

static int apply_cgi_debug_page(char* act, int *action, int *jumpto, webs_t wp)
{
	FILE *fp = NULL ;
	char buf[1024];
	char temp[50];
	int count = 0;

	tsprintf("apply_cgi_debug_page : %s\n", act);
	
	websHeader(wp);
	websWrite(wp, (char_t *) apply_header);
	//websWrite(wp, "<form>\n");
	//websWrite(wp, "<a href=\"gw_network_diagnostic.asp\">Return to Network Diagnostic Page</a>&nbsp;&nbsp;\n");	
	//websWrite(wp, "<input type=\"hidden\" name=\"action\" value=\"cmd\">\n");
	//websWrite(wp, "<table><tr><th align=\"right\">Command :&nbsp;&nbsp; </th><td>&nbsp;<input name=\"cmdfile\"  size=\"15\"></td></tr><tr><th align=\"right\">Output file :&nbsp;&nbsp; </th><td>&nbsp;<input name=\"tempfile\"  size=\"15\"></td></tr></table>\n");
	//websWrite(wp, "<input type=\"submit\" name=\"cmdBtn\" value=\"cmd\">\n");
	
	if(!strcmp(websGetVar(wp, "cmd", ""), ""))
	{
		websWrite(wp, "cmd : command error\n");	
	}
	else
	{
		if(!strcmp(websGetVar(wp, "tempfile", ""), ""))
		{
			sprintf(temp, "/tmp/network_diag");
		}
		else
		{
			sprintf(temp, "/tmp/%s", websGetVar(wp, "tempfile", ""));
		}

		sprintf(buf, "/usr/bin/killall %s", websGetVar(wp, "cmd_type", ""));
		tsprintf("%s\n", buf);
		system(buf);
		
		sprintf(buf, "%s > %s", websGetVar(wp, "cmd", ""), temp);
		system(buf);
		
		fp = fopen(temp, "r") ;
		//websWrite(wp, "Network Diagnostic Result : ");
		//websWrite(wp, buf);
		//websWrite(wp, "<br><br><hr><br>\n");
		
		if( fp == NULL )
		{
			//websWrite(wp, "No Network Diagnostic Result!\n");
			return *action;
		}
		
		while(fgets( buf, sizeof(buf), fp ))
		{
			count++;
			websWrite(wp, buf);
			websWrite(wp, "<br>\n");			
		}
		
		if(count == 0)
		{
			//websWrite(wp, "Network unreachable!");
			websWrite(wp, "<br>\n");	
		}
										
		fclose(fp);
	}
	//websWrite(wp, "<br><img src=\"bar.gif\"><br>\n");	
	//websWrite(wp, "</from><br><br><hr><br>\n");
	websWrite(wp, (char_t *) apply_footer);	
	websFooter(wp);
	websDone(wp, 200);	
	
	*action = NOTHING;
	*jumpto = JUMP_RETURN;
	
	//goto NOTHING ;	
	return *action;
}

static int
apply_cgi(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg,
	  char_t *url, char_t *path, char_t *query)
{
#if defined(MOTOROLA_SERIES)
	int action = NOTHING, jumpto = 0; //jumpto : 0 => Do Nothing, 1 => footer
	char *value, *pagename;//, buf[256];
	struct apply_cgi_handler *handler;
	struct apply_cgi_PageName *PageNamehandler;

	if (!query)
		goto footer;

	value = websGetVar(wp, "action", "");
	pagename = websGetVar(wp, "PageName", "");

	if(strcmp(value, "wizard.html"))
	{
		if(strcmp(value, "Login") && AuthReset == 1)
		{
			websWrite(wp, Login_Fail_asp);
			websDone(wp, 200);
			return 0;
		}
	}
        
	/* parse the "action" value in the page */
	for (handler = &apply_cgi_handlers[0]; handler->pattern; handler++) {
		if (strncmp(handler->pattern, value, strlen(handler->pattern)) == 0)
		{
			handler->output(value, &action, &jumpto, wp);
			break;
		}
	}

	//printf("1 Write WEB action => action : %d value : %s PageName : %s\n", action, value, pagename);

	if(handler->pattern == NULL)
	{
		websHeader(wp);
		websWrite(wp, (char_t *) apply_header);
		websWrite(wp, "Invalid action %s<br>", value);
		websWrite(wp, (char_t *) apply_footer);
		jumpto = JUMP_FOOTER;
	}
 	if(jumpto == JUMP_NOTHING)
	{
		tsprintf("Right action...Continue\n");
	}
	else if(jumpto == JUMP_PAGENAME)
	{
		tsprintf("goto DoPageName\n");
		goto DoPageName;
	}
	else if(jumpto == JUMP_FOOTER)
	{
		tsprintf("goto footer\n");
		goto footer;
	}
	else if(jumpto == JUMP_ACTION)
	{
		tsprintf("goto DoAction\n");
		goto DoAction;
	}
	else if(jumpto == JUMP_RETURN)
	{
		tsprintf("goto return\n");
		return 1;
	}
	else
	{
		tsprintf("Wrong action...Return!\n");
	}

DoPageName:

	//printf("2 Write WEB action => action : %d value : %s PageName : %s\n", action, value, pagename);
        /* parse the "PageName" value in the page */
	for (PageNamehandler = &apply_cgi_PageNames[0]; PageNamehandler->pattern; PageNamehandler++) {
		if (strncmp(PageNamehandler->pattern, pagename, strlen(PageNamehandler->pattern)) == 0)
		{
			PageNamehandler->output(pagename, &action, &jumpto, wp);
			websWrite(wp, (char_t *) apply_footer);
			break;
		}
	}
        tsprintf("after parse the PageName\n");
	if(PageNamehandler->pattern == NULL)
	{
		tsprintf("PageNamehandler->pattern == NULL\n");
		//websHeader(wp);
		//websWrite(wp, (char_t *) apply_header);
		//websWrite(wp, "PageName not find %s<br>", pagename);
		//printf("PageName not find %s<br>\n", pagename);
		websWrite(wp, (char_t *) apply_footer);
		//goto footer;
	}
footer:

	//printf("Write WEB Footer => action : %d value : %s PageName : %s\n", action, value, pagename);
	websFooter(wp);
	websDone(wp, 200);

	//websWrite(wp, "Saving is in Progress...");
	tsprintf("sys_commit()");
	sys_commit();
	//websWrite(wp, "Done");
	tsprintf("...Done\n");
	/* Added by PeterChen, 2002/10/22 PM 05:29 */
	/* Modified by PeterChen, 2002/10/23 PM 01:51 */

DoAction:
	if (action == RESTART)
	{
		sys_restart();
	}
	else if (action == REBOOT)
	{
		sys_reboot();
	}
	else if (action == NOTHING)
	{
		/* Nothing to Do */
	}
	return 1;

#else
	int action = NOTHING;
	char *value;

	websHeader(wp);
	websWrite(wp, (char_t *) apply_header);

	value = websGetVar(wp, "action", "");

	/* Apply values */
	if (!strcmp(value, "Apply")) {
		websWrite(wp, "Validating values...");
		validate_cgi(wp);
		websWrite(wp, "done<br>");
		websWrite(wp, "Committing values...");
		nvram_commit();
		websWrite(wp, "done<br>");
		action = RESTART;
	}

	/* Restore defaults */
	else if (!strncmp(value, "Restore", 7)) {
		websWrite(wp, "Restoring defaults...");
		nvram_set("move_to_defaults","1");
		nvram_set("restore_defaults", "0");
		nvram_commit();
		websWrite(wp, "done<br>");
		action = REBOOT;
	}
	
	/* Release lease */
	else if (!strcmp(value, "Release")) {
		websWrite(wp, "Releasing lease...");
		sys_release();
		websWrite(wp, "done<br>");
		action = NOTHING;
	}

	/* Renew lease */
	else if (!strcmp(value, "Renew")) {
		websWrite(wp, "Renewing lease...");
		sys_renew();
		websWrite(wp, "done<br>");
		action = NOTHING;
	}

	/* Upgrade image */
	else if (!strcmp(value, "Upgrade")) {
		char *os_name = nvram_safe_get("os_name");
		char *os_server = websGetVar(wp, "os_server", nvram_safe_get("os_server"));
		char *os_version = websGetVar(wp, "os_version", "current");
		char url[PATH_MAX];
		if (!*os_version)
			os_version = "current";
		snprintf(url, sizeof(url), "%s/%s/%s/%s.trx",
			 os_server, os_name, os_version, os_name);
		websWrite(wp, "Retrieving %s...", url);
		if (sys_upgrade(url, NULL, NULL)) {
			websWrite(wp, "error<br>");
			goto footer;
		} else {
			websWrite(wp, "done<br>");
			action = REBOOT;
		}
	}

	/* Report stats */
	else if (!strcmp(value, "Stats")) {
		char *server = websGetVar(wp, "stats_server", nvram_safe_get("stats_server"));
		websWrite(wp, "Contacting %s...", server);
		if (sys_stats(server)) {
			websWrite(wp, "error<br>");
			goto footer;
		} else {
			websWrite(wp, "done<br>");
			nvram_set("stats_server", server);
		}
	}
	
	/* Invalid action */
	else
		websWrite(wp, "Invalid action %s<br>", value);

 footer:
	websWrite(wp, (char_t *) apply_footer, websGetVar(wp, "page", ""));
	websFooter(wp);
	websDone(wp, 200);

	if (action == RESTART)
		sys_restart();
	else if (action == REBOOT)
		sys_reboot();

	return 1;
#endif
}

static int
wireless_asp(webs_t wp, char_t *urlPrefix, char_t *webDir, int arg, 
	     char_t *url, char_t *path, char_t *query)
{
	struct variable *v;
	char *value;
	char name[IFNAMSIZ], *next;
	int unit = 0;
	char tmp[100], prefix[] = "wlXXXXXXXXXX_";

	/* Can enter this function through GET or POST */
	if ((value = websGetVar(wp, "action", NULL))) {
		if (strcmp(value, "Select"))
			return apply_cgi(wp, urlPrefix, webDir, arg, url, path, query);
	}

	if ((value = websGetVar(wp, "wl_unit", NULL)))
		unit = atoi(value);
	else {
		/* Probe for first wl interface */
		foreach(name, nvram_safe_get("lan_ifnames"), next) {
			if (wl_probe(name) == 0 &&
			    wl_ioctl(name, WLC_GET_INSTANCE, &unit, sizeof(unit)) == 0)
				break;
		}
		if (!*name)
			unit = -1;
	}

	if (unit >= 0) {
		snprintf(prefix, sizeof(prefix), "wl%d_", unit);
		for (v = variables; v < &variables[sizeof(variables)/sizeof(variables[0])]; v++) {
			if (!strncmp(v->name, "wl_", 3))
				nvram_set(v->name, nvram_safe_get(strcat_r(prefix, &v->name[3], tmp)));
		}
	}

	/* Set currently selected unit */
	snprintf(tmp, sizeof(tmp), "%d", unit);
	nvram_set("wl_unit", tmp);

	/* Display the page */
	return websDefaultHandler(wp, urlPrefix, webDir, arg, url, path, query);
}

#ifdef WEBS

void
initHandlers(void)
{
	websAspDefine("nvram_get", ej_nvram_get);
	websAspDefine("nvram_match", ej_nvram_match);
	websAspDefine("nvram_invmatch", ej_nvram_invmatch);
	websAspDefine("nvram_list", ej_nvram_list);
	//websAspDefine("filter_client", ej_filter_client);
	//websAspDefine("forward_port", ej_forward_port);
	websAspDefine("static_route", ej_static_route);
	websAspDefine("localtime", ej_localtime);
	websAspDefine("dumplog", ej_dumplog);
	websAspDefine("dumpleases", ej_dumpleases);
	websAspDefine("link", ej_link);
	websAspDefine("need_redirect_to", ej_need_redirect_to);
	websAspDefine("get_associate_result", ej_get_associate_result);
	websAspDefine("get_associate_SSID", ej_get_associate_SSID);
	websAspDefine("get_associate_ap_auth_mode", ej_get_associate_ap_auth_mode);
	websAspDefine("get_associate_ap_encry_status", ej_get_associate_ap_encry_status);
	websAspDefine("get_associate_ap_mac", ej_get_associate_ap_mac);	
	websAspDefine("get_associate_rate", ej_get_associate_rate);
	websAspDefine("get_associate_channel", ej_get_associate_channel);
	websAspDefine("get_associate_rssi", ej_get_associate_rssi);
	websAspDefine("get_associate_noise", ej_get_associate_noise);
	websAspDefine("get_debug_result", ej_get_debug_result);
	websAspDefine("force_reboot", ej_force_reboot);
	websUrlHandlerDefine("/apply.cgi", NULL, 0, apply_cgi, 0);
	websUrlHandlerDefine("/wireless.asp", NULL, 0, wireless_asp, 0);

	websSetPassword(nvram_safe_get("http_passwd"));

	websSetRealm("Broadcom Home Gateway Reference Design");
}

#else /* !WEBS */

static void
do_auth(char *userid, char *passwd, char *realm)
{
	strncpy(userid, nvram_safe_get("http_username"), AUTH_MAX);
	strncpy(passwd, nvram_safe_get("http_passwd"), AUTH_MAX);
	strncpy(realm, "Broadcom Home Gateway Reference Design", AUTH_MAX);
}

static char post_buf[10000] = { 0 };

static void
do_apply_post(char *url, FILE *stream, int len, char *boundary)
{
	/* Get query */
	if (!fgets(post_buf, MIN(len + 1, sizeof(post_buf)), stream))
		return;
	len -= strlen(post_buf);

	/* Initialize CGI */
	init_cgi(post_buf);

	/* Slurp anything remaining in the request */
	while (len--)
		(void) fgetc(stream);
}

static void
do_apply_cgi(char *url, FILE *stream)
{
	char *path, *query;

	/* Parse path */
	query = url;
	path = strsep(&query, "?") ? : url;

	apply_cgi(stream, NULL, NULL, 0, url, path, query);

	/* Reset CGI */
	init_cgi(NULL);
}

static int upgrade_ret;

static void
do_upgrade_post(char *url, FILE *stream, int len, char *boundary)
{
	char buf[1024];
	system("/bin/cat /proc/kmemory/Power_Green_Off");	
	system("/bin/cat /proc/kmemory/Power_Red_On");
	system("killall ResetToDefault");
	upgrade_ret = EINVAL;

	/* Look for our part */
	while (len > 0) {
		if (!fgets(buf, MIN(len + 1, sizeof(buf)), stream))
			return;
		len -= strlen(buf);
		if (!strncasecmp(buf, "Content-Disposition:", 20) &&
		    strstr(buf, "name=\"file\""))
			break;
	}

	/* Skip boundary and headers */
	while (len > 0) {
		if (!fgets(buf, MIN(len + 1, sizeof(buf)), stream))
			return;
		len -= strlen(buf);
		if (!strcmp(buf, "\n") || !strcmp(buf, "\r\n"))
			break;
	}

	upgrade_ret = sys_upgrade(NULL, stream, &len);

	/* Slurp anything remaining in the request */
	while (len--)
		(void) fgetc(stream);
}





#if defined(MOTOROLA_SERIES)

static void do_restore_post(char *url, FILE *stream, int len, char *boundary)
{
	char upload_fifo[] = "/tmp/restoreXXXXXX";
	FILE *fifo = NULL;
	char buf[1024];
	int count = EINVAL;
	char *base = NULL ;

	/* Look for our part */
	while (len > 0)
	{
		if (!fgets(buf, MIN(len + 1, sizeof(buf)), stream))
		{
			goto err;
		}

		len -= strlen(buf);

		if (!strncasecmp(buf, "Content-Disposition:", 20) && strstr(buf, "name=\"file\""))
			break;
	}
 	/* Skip boundary and headers */
	while (len > 0)
	{
		if (!fgets(buf, MIN(len + 1, sizeof(buf)), stream))
		{
			goto err;
		}
		
		len -= strlen(buf);
		if (!strcmp(buf, "\n") || !strcmp(buf, "\r\n"))
			break;
	}

	/* Feed write from a temporary FIFO */
	if (!mktemp(upload_fifo) ||	!(fifo = fopen(upload_fifo, "w")))
	{
		goto err;
	}

	/* Set nonblock on the socket so we can timeout */
	if (fcntl(fileno(stream), F_SETFL, O_NONBLOCK) < 0)
	{
		goto err;
	}

	/* Pipe the rest to the FIFO */
	cprintf("Upgrading\n");

	while (len > 0)
	{
		count = fread(buf, 1, MIN(len, sizeof(buf)), stream);
		len -= count;
		base = strstr(buf, "\r\n" );
		if( base )
		{
			fwrite(buf, 1, &base[0]-&buf[0], fifo);
			cprintf(".\n");
			break ;
		}
		else
		{
			fwrite(buf, 1, count, fifo);
			cprintf(".\n");
		}
	}

	fclose(fifo);
	fifo = NULL;
	cprintf("done\n");

	/* restore restoreXXXXXX */
	tsprintf("restore : config.txt\n");
	eval( "/sbin/restore", upload_fifo, "2", "/tmp/config.txt", "/tmp/test", nvram_get("ModelId"));
        //system("cat /tmp/config.txt");

	/* Reset nonblock on the socket */
	if (fcntl(fileno(stream), F_SETFL, 0) < 0)
	{
		goto err;
	}

 err:
	if (fifo)
		fclose(fifo);

	remove(upload_fifo);
        tsprintf("Leave restore post\n");
	
}

static void do_restore_cgi(char *url, FILE *stream)
{
#if 0
	int ret;
	FILE *fifo = NULL;
	char *base = NULL ;
	char buf[1024];
	char config_txt = "/tmp/config.txt" ;
#endif  
                FILE* wp;
		wp=stream;
		tsprintf("enter apply_cgi_restore\n");
		FILE *fp = NULL ;
		char buf[1024];
		char name[50];
		char temp[50];
		char *base = NULL ;
		char *b = NULL ;

		fp = fopen( "/tmp/config.txt", "r" ) ;
		if( fp == NULL )
		{
			printf("open config.txt error \n");
			websWrite(wp, (char_t *) apply_header_child);
			websWrite(wp, (char_t *) apply_restore_footer);
			websDone(wp, 200);
//			*action = NOTHING;
//			*jumpto = JUMP_ACTION;
			return;
		}
		
		while(fgets( buf, sizeof(buf), fp ))
		{
			if( base = strchr( buf, '=' ) )
			{
				memset( name, '\0', sizeof(name) );
				memset( temp, '\0', sizeof(temp) );
				memcpy( temp, buf, &base[0]-&buf[0] );
				
				if( b = strchr( temp, '_' ) )
				{
					b = b + 1 ;
					strcpy(name,b);

					if(!strcmp(name, "sdram_init") || !strcmp(name, "SerialNumber") || !strcmp(name, "et0macaddr") || !strcmp(name, "et1macaddr") || !strcmp(name, "lan_hwaddr") || !strcmp(name, "wan_hwaddr") || !strcmp(name, "BackupForMAClone") || !strcmp(name, "MACloneSys") || !strcmp(name, "MACloneAddress") || !strcmp(name, "http_username") || !strcmp(name, "http_passwd"))
					{
						//Do nothing
					}
					else
					{       
            char *p_str=NULL;
						base = base + 1 ;
						if(p_str = strchr(base, '\n'))
						  memset(p_str, 0, 1);
						
						{
							struct variable *v;
							char *value;
						
							/* Validate and set variables in table order */
							for (v = variables; v < &variables[sizeof(variables)/sizeof(variables[0])]; v++) 
							{
								if(!strcmp(name, v->name))
								{
									//cprintf("=== Find nvram : [%s] value is [%s]\n", name, base);
									nvram_set( name, base);
									//cprintf("\n----------\n");
									break;
								}
							}
						}		
						
					}
				}
			}
		}

		fclose(fp);
		sys_commit();
		websWrite(wp, (char_t *) apply_header_child);
		websWrite(wp, (char_t *) apply_restore_footer);
		websDone(wp, 200);
		nvram_set("NeedReboot", "1");
//		*action = NOTHING;
//		*jumpto = JUMP_ACTION;
		//printf("exit apply_cgi_restore\n");

//	websHeader(stream);
//	websWrite(stream, (char_t *) RedirectApplyCGI);
//	websFooter(stream);
//	websDone(stream, 200);
}
#endif








static void
do_upgrade_cgi(char *url, FILE *stream)
{
//	websHeader(stream);
	websWrite(stream, (char_t *) apply_header);

	/* We could probably be more informative here... */
#if defined(MOTOROLA_SERIES)
	if (upgrade_ret)
	{
		if(upgrade_ret == 24064) /* 4702 only error code */
		{
			websWrite(stream, upgrade_fail_4702_only_footer);
		}		
		else
		{
			websWrite(stream, upgrade_fail_footer);
		}		
	}
	else 
	{
		nvram_set("NeedReboot", "1");
		websWrite(stream, (char_t *)force_reboot_footer);
	}
#else
	if (upgrade_ret)
		websWrite(stream, "Error during upgrade<br>");
	else
		websWrite(stream, "Upgrade complete<br>");

	websWrite(stream, (char_t *) apply_footer, "firmware.asp");
#endif
	websFooter(stream);
	websDone(stream, 200);
	
	system("/sbin/ResetToDefault &");
	system("/bin/cat /proc/kmemory/Power_Red_Off");
	system("/bin/cat /proc/kmemory/Power_Green_On");	
#if defined(MOTOROLA_SERIES)
        /* Do not need to reboot */
#else
	/* Reboot if successful */
	if (upgrade_ret == 0)
		sys_reboot(); 
#endif
}

static void
do_wireless_asp(char *url, FILE *stream)
{
	char *path, *query;

	/* Parse path */
	query = url;
	path = strsep(&query, "?") ? : url;

	wireless_asp(stream, NULL, NULL, 0, url, path, query);

	/* Reset CGI */
	init_cgi(NULL);
}

static char no_cache[] =
"Cache-Control: no-cache\r\n"
"Pragma: no-cache\r\n"
"Expires: 0"
;

struct mime_handler mime_handlers[] = {
	{ "wireless.asp", "text/html", no_cache, do_apply_post, do_wireless_asp, do_auth },
	{ "security.asp", "text/html", no_cache, do_apply_post, do_wireless_asp, do_auth },
	{ "**.html", "text/html", no_cache, NULL, do_ej, do_auth },	
	{ "**.asp", "text/html", no_cache, NULL, do_ej, do_auth },
	{ "**.css", "text/css", NULL, NULL, do_file, do_auth },
	{ "**.gif", "image/gif", NULL, NULL, do_file, do_auth },
	{ "**.jpg", "image/jpeg", NULL, NULL, do_file, do_auth },
	{ "**.js", "text/javascript", NULL, NULL, do_file, do_auth },
	{ "apply.cgi*", "text/html", no_cache, do_apply_post, do_apply_cgi, do_auth },
	{ "upgrade.cgi*", "text/html", no_cache, do_upgrade_post, do_upgrade_cgi, do_auth },
#if defined(MOTOROLA_SERIES)
	{ "sysconf.cgi*" , "text/html" , no_cache , do_wep_post , do_wep_cgi , do_auth },
	{ "**.bin", "octet/stream", NULL, NULL, do_file, do_auth },
	{ "restore.cgi*", "text/html", no_cache, do_restore_post, do_restore_cgi, do_auth },
#endif
	{ NULL, NULL, NULL, NULL, NULL, NULL }
};

struct ej_handler ej_handlers[] = {
	{ "nvram_get", ej_nvram_get },
	{ "nvram_match", ej_nvram_match },
	{ "nvram_invmatch", ej_nvram_invmatch },
	{ "nvram_list", ej_nvram_list },
	{ "options", ej_options },
	//{ "filter_client", ej_filter_client },
	//{ "forward_port", ej_forward_port },
	//{ "autofw_port", ej_autofw_port },
	{ "static_route", ej_static_route },
	{ "localtime", ej_localtime },
	{ "dumplog", ej_dumplog },
	{ "dumpleases", ej_dumpleases },
	{ "link", ej_link },
	{ "wl_list", ej_wl_list },
	{ "wl_phytypes", ej_wl_phytypes },
	{ "wl_radioid", ej_wl_radioid },
	{ "wl_corerev", ej_wl_corerev },
	{ "wl_channel", ej_wl_channel },
#if defined(MOTOROLA_SERIES)
	{ "get_login_msg", ej_get_login_msg},
	{ "doSiteSurvey", ej_doSiteSurvey},
	{ "doSite_Survey_Info", ej_doSite_Survey_Info},	
	{ "GetAllVar", ej_GetAllVar },
	{ "get_reboot_msg", ej_get_reboot_msg},
	{ "need_redirect_to", ej_need_redirect_to},
	{ "get_associate_result", ej_get_associate_result},
	{ "get_associate_SSID", ej_get_associate_SSID},
	{ "get_associate_ap_auth_mode", ej_get_associate_ap_auth_mode},
	{ "get_associate_ap_encry_status", ej_get_associate_ap_encry_status},
	{ "get_associate_ap_mac", ej_get_associate_ap_mac},
	{ "get_associate_rate", ej_get_associate_rate},
	{ "get_associate_channel", ej_get_associate_channel},
	{ "get_associate_rssi", ej_get_associate_rssi},
	{ "get_associate_noise", ej_get_associate_noise},			
	{ "get_debug_result", ej_get_debug_result},
	{ "force_reboot", ej_force_reboot},
#if defined(WE800G)
	{ "wp1_nvram_get", ej_wp1_nvram_get},
	{ "wp1_nvram_match", ej_wp1_nvram_match},
	{ "wp2_nvram_get", ej_wp2_nvram_get},
	{ "wp2_nvram_match", ej_wp2_nvram_match},
	{ "nvram_dump", ej_nvram_dump},
#endif
#endif
	{ NULL, NULL }
};

#endif /* !WEBS */
